#include "StdAfx.h"
#include "Resource.h"
#include "CardFile.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////////
//궨

//
#define POS_SHOOT					10									//
#define POS_SPACE					20									//ָ
#define ITEM_COUNT_W				9									//Ŀ
#define ITEM_COUNT_H				4									//Ŀ
#define ITEM_HUA_H					5									//
#define INVALID_ITEM				0xFFFF								//Ч

//˿˴С
#define CARD_WIDTH					52									//˿˿
#define CARD_HEIGHT					82  								//˿˸߶

#define CARD_COUNT					14

//////////////////////////////////////////////////////////////////////////

//캯
CCardListImage::CCardListImage()
{
	//λñ
	m_nItemWidth=0;
	m_nItemHeight=0;
	m_pCardListImage=NULL;
	return;
}

//
CCardListImage::~CCardListImage()
{
}

//Դ
bool CCardListImage::LoadResource(HTEXTURE tex,float cbWidth,float cbHeight,bool bHuaCard)
{
	//Դ
	m_pCardListImage=new MySprite(tex,0,0,cbWidth,cbHeight);

	if(bHuaCard)
	{
		//ñ
		m_nItemHeight=(int)(m_pCardListImage->GetHeight()/ITEM_HUA_H);
		m_nItemWidth=(int)(m_pCardListImage->GetWidth()/ITEM_COUNT_W);
	}
	else
	{
		//ñ
		m_nItemHeight=(int)(m_pCardListImage->GetHeight()/ITEM_COUNT_H);
		m_nItemWidth=(int)(m_pCardListImage->GetWidth()/ITEM_COUNT_W);
	}
	m_pCardListImage->SetBlendMode(BLEND_DEFAULT);
	return true;
}

//ͷԴ
bool CCardListImage::DestroyResource()
{
	//ñ
	m_nItemWidth=0;
	m_nItemHeight=0;

	if(m_pCardListImage)
		delete m_pCardListImage;
	return true;
}

//滭˿
bool CCardListImage::DrawCardItem(BYTE cbCardData, float xDest, float yDest,bool bShowCard,float fScale)
{
	//Ч״̬
	ASSERT(m_pCardListImage!=NULL);
	ASSERT((m_nItemWidth!=0)&&(m_nItemHeight!=0));

	if(cbCardData==0)
	{
		m_pCardListImage->SetTextureRect((float)((8)*m_nItemWidth),(float)(4)*m_nItemHeight,
			(float)m_nItemWidth,(float)m_nItemHeight);
		m_pCardListImage->RenderEx(xDest,yDest,0.0f,fScale);
	}
	//滭
	if(cbCardData>0&&cbCardData<=0x3F)
	{
		BYTE cbValue=cbCardData&MASK_VALUE;
		BYTE cbColor=(cbCardData&MASK_COLOR)>>4;
		if(cbCardData>0x37)
		{
			cbValue-=7;
			cbColor+=1;
		}

		m_pCardListImage->SetTextureRect((float)((cbValue-1)*m_nItemWidth),(float)((cbColor)*m_nItemHeight),
			(float)m_nItemWidth,(float)m_nItemHeight);
		if(bShowCard)
			m_pCardListImage->RenderEx(xDest,yDest,0.0f,fScale);
	}
	return true;
}


//////////////////////////////////////////////////////////////////////////

//캯
CCardResource::CCardResource()
{
}

//
CCardResource::~CCardResource()
{
}

//Դ
bool CCardResource::LoadResource()
{
	HTEXTURE tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexHandCardWhite");
	m_HandCardWhite.LoadResource(tex,468,410,true);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexHandCardGrayed");
	m_HandCardGrayed.LoadResource(tex,468,410,true);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexSpecialCard");
	m_SpecialCard.LoadResource(tex,450,370,true);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexSmallSpecialCard");
	m_SmallSpecialCard.LoadResource(tex,297,240,true);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexHua");
	m_pHua=new MySprite(tex,0,0,46,41);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexXiaoHua");
	m_pXiaoHua=new MySprite(tex,0,0,28,25);
	return true;
}

//Դ
bool CCardResource::DestroyResource()
{
	m_HandCardWhite.DestroyResource();
	m_HandCardGrayed.DestroyResource();
	m_SpecialCard.DestroyResource();
	m_SmallSpecialCard.DestroyResource();
	if(m_pHua)
		delete m_pHua;
	if(m_pXiaoHua)
		delete m_pXiaoHua;
	return true;
}
//////////////////////////////////////////////////////////////////////////

//캯
CHeapCard::CHeapCard(const tstring& strName)
: hgeItemContainer(strName)
{
	//Ʊ
	m_ControlPoint.SetPoint(0,0);
	m_CardDirection=Direction_East;
	m_ShowingCardIndex=-1;
	m_fScale=1.0f;

	//˿˱
	m_wFullCount=HEAP_FULL_COUNT;
	m_wMinusHeadCount=0;
	m_wMinusLastCount=0;
	ZeroMemory( m_cbCardData,sizeof(m_cbCardData) );

	return;
}

//
CHeapCard::~CHeapCard()
{
}
//滭˿
void CHeapCard::Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect)
{
	switch (m_CardDirection)
	{
	case Direction_South:	//
		{
			//滭˿
			if ((m_wFullCount-m_wMinusHeadCount-m_wMinusLastCount)>=0)
			{
				//
				float nXPos,nYPos=0;

				//β˿
				float nXExcusion=g_CardResource.m_SmallSpecialCard.GetViewWidth()*m_fScale;
				float nYExcusion=14*m_fScale;
				nYPos = (float)m_ControlPoint.y;
				nXPos = m_ControlPoint.x-m_wFullCount/2*nXExcusion+m_wMinusLastCount/2*nXExcusion;
				WORD wCardIndex = (m_wMinusLastCount/2)*2;//Ƶżһѵ
				if(m_wMinusLastCount%2!=0)
				{
					g_CardResource.m_SmallSpecialCard.DrawCardItem(0,nXPos,(nYPos+nYExcusion),true,m_fScale);
					wCardIndex+=2;
					nXPos+=nXExcusion;
				}

				//м˿
				WORD wFinallyIndex=(m_wFullCount-m_wMinusHeadCount)/2;
				WORD wDoubleIndex = (m_wMinusLastCount+1)/2;
				for (WORD i=wDoubleIndex;i<wFinallyIndex;i++)
				{
					if(m_cbCardData[wCardIndex+1]==0)
						g_CardResource.m_SmallSpecialCard.DrawCardItem(0,nXPos,(nYPos+nYExcusion),true,m_fScale);
					if(m_cbCardData[wCardIndex]==0)
						g_CardResource.m_SmallSpecialCard.DrawCardItem(0,nXPos,nYPos,true,m_fScale);
					wCardIndex += 2;
					nXPos += nXExcusion;
				}

				//ͷ˿
				if (m_wMinusHeadCount%2!=0)
				{
					g_CardResource.m_SmallSpecialCard.DrawCardItem(0,nXPos,(nYPos+nYExcusion),true,m_fScale);
				}
			}
			break;
		}
	case Direction_North:	//
		{
			//滭˿
			if ((m_wFullCount-m_wMinusHeadCount-m_wMinusLastCount)>=0)
			{
				//
				float nXPos=0,nYPos=0;

				//ͷ˿
				float nXExcusion = g_CardResource.m_SmallSpecialCard.GetViewWidth()*m_fScale;
				float nYExcusion = 14*m_fScale;
				nYPos = (float)m_ControlPoint.y;
				nXPos = m_ControlPoint.x+m_wMinusHeadCount/2*nXExcusion;
				WORD wCardIndex = m_wFullCount-(m_wMinusHeadCount/2)*2-2;//-2Ǽȥ1 һ
				if (m_wMinusHeadCount%2!=0)//Ƶżһһѵһŵ
				{
					g_CardResource.m_SmallSpecialCard.DrawCardItem(0,nXPos,(nYPos+nYExcusion),true,m_fScale);
					wCardIndex -= 2;
					nXPos += nXExcusion;
				}

				//м˿
				WORD wFinallyIndex=(m_wFullCount-m_wMinusLastCount)/2;
				WORD wDoubleIndex = (m_wMinusHeadCount+1)/2;
				for (WORD i=wDoubleIndex;i<wFinallyIndex;i++)
				{
					if(m_cbCardData[wCardIndex+1]==0)
						g_CardResource.m_SmallSpecialCard.DrawCardItem(0,nXPos,(nYPos+nYExcusion),true,m_fScale);
					if(m_cbCardData[wCardIndex]==0)
						g_CardResource.m_SmallSpecialCard.DrawCardItem(0,nXPos,nYPos,true,m_fScale);
					wCardIndex -= 2;
					if(i==7)
						nXPos += (nXExcusion-1);
					else
						nXPos += nXExcusion;
				}

				//β˿
				if (m_wMinusLastCount%2!=0)
				{
					g_CardResource.m_SmallSpecialCard.DrawCardItem(0,nXPos,(nYPos+nYExcusion),true,m_fScale);
				}
			}
			break;
		}
	}
}
//˿
bool CHeapCard::SetHeapCardInfo(WORD wMinusHeadCount, WORD wMinusLastCount)
{
	ASSERT( wMinusHeadCount+wMinusLastCount<=m_wFullCount );
	if( wMinusHeadCount + wMinusLastCount > m_wFullCount ) return false;

	//ñ
	m_wMinusHeadCount=wMinusHeadCount;
	m_wMinusLastCount=wMinusLastCount;

	return true;
}

//÷,wIndexβֻ
void CHeapCard::SetCardData( WORD wIndex, BYTE cbCardData )
{
	ASSERT( wIndex < m_wFullCount );
	if( wIndex >= m_wFullCount ) return;

	/*for(BYTE i=0;i<m_wFullCount;i++)
	{
		if(i%2) continue;
		m_cbCardData[i]=cbCardData;
	}*/

	m_cbCardData[wIndex] = cbCardData;
}

//÷
void CHeapCard::ResetCardData()
{
	ZeroMemory( m_cbCardData,sizeof(m_cbCardData) );
	return ;
}

//Ϊ,wIndexβֻ
void CHeapCard::SetCardEmpty( WORD wIndex, BYTE cbEmptyCount )
{
	ASSERT( wIndex+1 >= cbEmptyCount );
	if( wIndex+1 < cbEmptyCount ) return;

	for( int i = wIndex; i >= wIndex+1-cbEmptyCount; i-- )
	{
		m_cbCardData[i] = 255;
	}
}

//ȡλ
CPoint CHeapCard::GetDispatchCardPos( bool bTail )
{
	CPoint ptHead = m_ControlPoint;

	switch( m_CardDirection )
	{
	case Direction_South:	//
		{
			int nXExcusion = 0;
			if( !bTail )
			{
				nXExcusion = (m_wMinusHeadCount+2)/2;
				ptHead.x -= nXExcusion*(int)g_CardResource.m_SmallSpecialCard.GetViewWidth();
				if( m_wMinusHeadCount%2 != 0 ) ptHead.y += 9;
			}
			else
			{
				nXExcusion = (m_wFullCount-m_wMinusLastCount+1)/2;
				ptHead.x -= nXExcusion*(int)g_CardResource.m_SmallSpecialCard.GetViewWidth();
				if( m_wMinusLastCount%2 != 0 ) ptHead.y += 9;
			}
		}
		break;
	case Direction_North:	//
		{
			int nXExcusion = 0;
			if( !bTail )
			{
				nXExcusion = m_wMinusHeadCount/2;
				ptHead.x += nXExcusion*(int)g_CardResource.m_SmallSpecialCard.GetViewWidth();
				if( m_wMinusHeadCount%2 != 0 ) ptHead.y += 9;
			}
			else
			{
				nXExcusion = (m_wFullCount-m_wMinusLastCount)/2;
				ptHead.x += nXExcusion*(int)g_CardResource.m_SmallSpecialCard.GetViewWidth();
				if( m_wMinusLastCount%2 != 0 ) ptHead.y += 9;
			}
		}
		break;
	}

	return ptHead;
}

//ȡλ,wIndexʾβֻ
CPoint CHeapCard::GetDispatchCardPos( WORD wIndex )
{
	ASSERT( wIndex < m_wFullCount );
	CPoint ptHead = m_ControlPoint;

	switch( m_CardDirection )
	{
	case Direction_South:	//
		{
			int nXExcusion =(int) ((m_wFullCount-wIndex+1)/2*(g_CardResource.m_SmallSpecialCard.GetViewWidth()*m_fScale));
			ptHead.x -= nXExcusion;
			if( wIndex%2 != 0 ) ptHead.y += 9;
		}
		break;
	case Direction_North:	//
		{
			int nXExcusion =(int) ((m_wFullCount/2-(wIndex+2)/2)*(g_CardResource.m_SmallSpecialCard.GetViewWidth()*m_fScale));
			ptHead.x += nXExcusion;
			if( wIndex%2 != 0 ) ptHead.y += 9;
		}
		break;
	}

	return ptHead;
}

//ƶƳ,bTailָǷβƳ
bool CHeapCard::DeductionHeapCard( bool bTail )
{
	if( m_wMinusHeadCount+m_wMinusLastCount >= m_wFullCount ) return false;

	if( !bTail )
	{
		m_wMinusHeadCount++;
		WORD wCardIndex = 0;
		if( (m_wFullCount-m_wMinusHeadCount)%2 != 0 )
			wCardIndex = m_wFullCount-m_wMinusHeadCount-1;
		else wCardIndex = m_wFullCount-m_wMinusHeadCount+1;
		while( m_cbCardData[wCardIndex] != 0 && m_wMinusLastCount+m_wMinusHeadCount<m_wFullCount )
		{
			m_wMinusHeadCount++;
			if( wCardIndex%2 != 0 )
			{
				if( wCardIndex < 3 ) break;
				wCardIndex -= 3;
			}
			else wCardIndex++;
		}
		if(m_cbCardData[wCardIndex]==0) m_cbCardData[wCardIndex] = 255;
	}
	else 
	{
		m_wMinusLastCount++;
		while( m_cbCardData[m_wMinusLastCount-1] != 0 && m_wMinusLastCount+m_wMinusHeadCount<m_wFullCount )
			m_wMinusLastCount++;
		if(m_cbCardData[m_wMinusLastCount-1]==0) m_cbCardData[m_wMinusLastCount-1]=255;
	}

	return true;
}

//////////////////////////////////////////////////////////////////////////

//캯
//////////////////////////////////////////////////////////////////////////
//////캯
//CHeapCard::CHeapCard(const tstring& strName)
//: hgeItemContainer(strName)
//{
//	//Ʊ
//	m_ControlPoint=hgePoint(0,0);
//
//	//˿˱
//	m_wFullCount=HEAP_FULL_COUNT;
//	m_cbCardCount=0;
//	m_fScale=1.0f;
//}
////
//CHeapCard::~CHeapCard()
//{
//}
////滭˿
//void CHeapCard::Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect)
//{
////	g_CardResource.m_SpecialCard.DrawCardItem(0,m_ControlPoint.x,m_ControlPoint.y);
//
//	if(m_cbCardCount>12)
//	{
//		float nXPos=m_ControlPoint.x,nYPos=m_ControlPoint.y;
//		float nXExcusion=float(g_CardResource.m_SpecialCard.GetViewWidth())*m_fScale;
//		float nYExcusion=19*m_fScale;
//		for(WORD i=0;i<m_wFullCount/2;i++)
//		{
//			g_CardResource.m_SpecialCard.DrawCardItem(0,nXPos,nYPos+nYExcusion,false,m_fScale);
//			g_CardResource.m_SpecialCard.DrawCardItem(0,nXPos,nYPos,false,m_fScale);
//			nXPos+=nXExcusion;
//		}
//	}
//	else
//	{
//		float nXPos=m_ControlPoint.x,nYPos=m_ControlPoint.y;
//		float nXExcusion=float(g_CardResource.m_SpecialCard.GetViewWidth())*m_fScale;
//		float nYExcusion=19*m_fScale;
//		nXPos+=(nXExcusion*((m_wFullCount-m_cbCardCount)/2));
//		if(m_cbCardCount%2!=0)
//		{
//			g_CardResource.m_SpecialCard.DrawCardItem(0,nXPos,nYPos+nYExcusion,false,m_fScale);
//			nXPos+=nXExcusion;
//		}
//		for(WORD i=0;i<m_cbCardCount/2;i++)
//		{
//			g_CardResource.m_SpecialCard.DrawCardItem(0,nXPos,nYPos+nYExcusion,false,m_fScale);
//			g_CardResource.m_SpecialCard.DrawCardItem(0,nXPos,nYPos,false,m_fScale);
//			nXPos+=nXExcusion;
//		}
//	}
//}
//void CHeapCard::SetCardCount(BYTE cbCardCount)
//{
//	m_cbCardCount=cbCardCount;
//}
//////////////////////////////////////////////////////////////////////////
CWeaveCard::CWeaveCard(const tstring& strName)
:hgeItemContainer(strName)
{
	//״̬
	m_bDisplayItem=false;
	m_ControlPoint.SetPoint(0,0);
	m_CardDirection=Direction_South;
	m_cbDirectionCardPos = 4;
	m_fScale=1.0f;

	//˿
	m_wCardCount=0;
	ZeroMemory(&m_cbCardData,sizeof(m_cbCardData));
	m_cbWeaveType=0;
	m_ArrayCard.RemoveAll();
	m_bXiao=false;
	m_bSmall=false;
	return;
}

//
CWeaveCard::~CWeaveCard()
{
}
void CWeaveCard::ResealeInfo()
{
	m_ArrayCard.RemoveAll();
	m_bXiao=false;
}
void CWeaveCard::Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect)
{
	//ʾж
	if (m_wCardCount==0) 
		return;

	//
	float nXScreenPos=0,nYScreenPos=0;
	CCardListImage *pCardListImg = NULL; 
	int nTmpX=0,nTmpY=0;

	//滭˿
	switch (m_CardDirection)
	{
	case Direction_South:	//
		{
			if(m_bSmall)
			{
				int nXExcusionV = g_CardResource.m_SmallSpecialCard.GetViewWidth();

				nXScreenPos =(float) m_ControlPoint.x;
				nYScreenPos =(float) m_ControlPoint.y;

				//һ˿
				g_CardResource.m_SmallSpecialCard.DrawCardItem(GetCardData(0),nXScreenPos,nYScreenPos,true,m_fScale);
				for(BYTE j=0;j<m_ArrayCard.GetCount();j++)
				{
					if(GetCardData(0)==m_ArrayCard[j])
					{
						g_CardResource.m_pXiaoHua->RenderEx(nXScreenPos+3,nYScreenPos-26,0.0f,m_fScale);
					}
				}
				nXScreenPos += nXExcusionV;

				//ڶ˿
				g_CardResource.m_SmallSpecialCard.DrawCardItem(GetCardData(1),nXScreenPos,nYScreenPos,true,m_fScale);
				if(m_wCardCount != 4)
				{
					for(BYTE j=0;j<m_ArrayCard.GetCount();j++)
					{
						if(GetCardData(1)==m_ArrayCard[j])
						{
							g_CardResource.m_pXiaoHua->RenderEx(nXScreenPos+3,nYScreenPos-26,0.0f,m_fScale);
						}
					}
				}
				nXScreenPos += nXExcusionV;

				//˿
				g_CardResource.m_SmallSpecialCard.DrawCardItem(GetCardData(2),nXScreenPos,nYScreenPos,true,m_fScale);
				for(BYTE j=0;j<m_ArrayCard.GetCount();j++)
				{
					if(GetCardData(2)==m_ArrayCard[j])
					{
						g_CardResource.m_pXiaoHua->RenderEx(nXScreenPos+3,nYScreenPos-26,0.0f,m_fScale);
					}
				}

				//˿
				if( m_wCardCount == 4 )
				{
					g_CardResource.m_SmallSpecialCard.DrawCardItem(GetCardData(3),nXScreenPos-nXExcusionV,nYScreenPos-13,
						true,m_fScale);
					for(BYTE j=0;j<m_ArrayCard.GetCount();j++)
					{
						if(GetCardData(3)==m_ArrayCard[j])
						{
							g_CardResource.m_pXiaoHua->RenderEx(nXScreenPos-nXExcusionV+3,nYScreenPos-13-26,0.0f,m_fScale);
						}
					}
				}
			}
			else
			{
				int nXExcusionV = g_CardResource.m_SpecialCard.GetViewWidth()-1;

				nXScreenPos =(float) m_ControlPoint.x;
				nYScreenPos =(float) m_ControlPoint.y;

				//һ˿
				g_CardResource.m_SpecialCard.DrawCardItem(GetCardData(0),nXScreenPos,nYScreenPos,true,m_fScale);
				for(BYTE j=0;j<m_ArrayCard.GetCount();j++)
				{
					if(GetCardData(0)==m_ArrayCard[j])
					{
						if(!m_bXiao)
							g_CardResource.m_pHua->Render(nXScreenPos+4,nYScreenPos-41);
						else
							g_CardResource.m_pXiaoHua->Render(nXScreenPos+15,nYScreenPos-26);
					}
				}
				nXScreenPos += nXExcusionV;

				//ڶ˿
				g_CardResource.m_SpecialCard.DrawCardItem(GetCardData(1),nXScreenPos,nYScreenPos,true,m_fScale);
				if(m_wCardCount != 4)
				{
					for(BYTE j=0;j<m_ArrayCard.GetCount();j++)
					{
						if(GetCardData(1)==m_ArrayCard[j])
						{
							if(!m_bXiao)
								g_CardResource.m_pHua->Render(nXScreenPos+4,nYScreenPos-41);
							else
								g_CardResource.m_pXiaoHua->Render(nXScreenPos+15,nYScreenPos-26);
						}
					}
				}
				nXScreenPos += nXExcusionV;

				//˿
				g_CardResource.m_SpecialCard.DrawCardItem(GetCardData(2),nXScreenPos,nYScreenPos,true,m_fScale);
				for(BYTE j=0;j<m_ArrayCard.GetCount();j++)
				{
					if(GetCardData(2)==m_ArrayCard[j])
					{
						if(!m_bXiao)
							g_CardResource.m_pHua->Render(nXScreenPos+4,nYScreenPos-41);
						else
							g_CardResource.m_pXiaoHua->Render(nXScreenPos+15,nYScreenPos-26);
					}
				}

				//˿
				if( m_wCardCount == 4 )
				{
					g_CardResource.m_SpecialCard.DrawCardItem(GetCardData(3),nXScreenPos-nXExcusionV,nYScreenPos-20,
						true,m_fScale);
					for(BYTE j=0;j<m_ArrayCard.GetCount();j++)
					{
						if(GetCardData(3)==m_ArrayCard[j])
						{
							if(!m_bXiao)
								g_CardResource.m_pHua->Render(nXScreenPos-nXExcusionV+4,nYScreenPos-20-41);
							else
								g_CardResource.m_pXiaoHua->Render(nXScreenPos-nXExcusionV+15,nYScreenPos-20-26);
						}
					}
				}
			}

			break;
		}
	case Direction_North:	//
		{
			if(m_bSmall)
			{
				//
				float nXExcusionV = g_CardResource.m_SmallSpecialCard.GetViewWidth()*m_fScale;

				nXScreenPos =(float) m_ControlPoint.x-nXExcusionV*3;
				nYScreenPos =(float) m_ControlPoint.y;

				//˿
				g_CardResource.m_SmallSpecialCard.DrawCardItem(GetCardData(2),nXScreenPos,nYScreenPos,true,m_fScale);
				for(BYTE j=0;j<m_ArrayCard.GetCount();j++)
				{
					if(GetCardData(2)==m_ArrayCard[j])
					{
						g_CardResource.m_pXiaoHua->RenderEx(nXScreenPos+3,nYScreenPos-(26*m_fScale),0.0f,m_fScale);
					}
				}
				nXScreenPos += nXExcusionV;

				//ڶ˿
				g_CardResource.m_SmallSpecialCard.DrawCardItem(GetCardData(1),nXScreenPos,nYScreenPos,true,m_fScale);
				if( m_wCardCount != 4 )
				{
					for(BYTE j=0;j<m_ArrayCard.GetCount();j++)
					{
						if(GetCardData(1)==m_ArrayCard[j])
						{
							g_CardResource.m_pXiaoHua->RenderEx(nXScreenPos+3,nYScreenPos-(26*m_fScale),0.0f,m_fScale);
						}
					}
				}
				nXScreenPos += nXExcusionV;

				//һ˿
				g_CardResource.m_SmallSpecialCard.DrawCardItem(GetCardData(0),nXScreenPos,nYScreenPos,true,m_fScale);
				for(BYTE j=0;j<m_ArrayCard.GetCount();j++)
				{
					if(GetCardData(0)==m_ArrayCard[j])
					{
						g_CardResource.m_pXiaoHua->RenderEx(nXScreenPos+3,nYScreenPos-(26*m_fScale),0.0f,m_fScale);
					}
				}


				//˿
				if( m_wCardCount == 4 )
				{
					g_CardResource.m_SmallSpecialCard.DrawCardItem(GetCardData(3),nXScreenPos-nXExcusionV,
						nYScreenPos-(13*m_fScale),true,m_fScale);
					for(BYTE j=0;j<m_ArrayCard.GetCount();j++)
					{
						if(GetCardData(3)==m_ArrayCard[j])
						{
							g_CardResource.m_pXiaoHua->RenderEx(nXScreenPos-nXExcusionV+3,
								nYScreenPos-(13*m_fScale)-(26*m_fScale),0.0f,m_fScale);
						}
					}
				}
			}
			else
			{
				//
				int nXExcusionV = g_CardResource.m_SpecialCard.GetViewWidth()-1;

				nXScreenPos =(float) m_ControlPoint.x-nXExcusionV*3;
				nYScreenPos =(float) m_ControlPoint.y;

				//˿
				g_CardResource.m_SpecialCard.DrawCardItem(GetCardData(2),nXScreenPos,nYScreenPos,true,m_fScale);
				for(BYTE j=0;j<m_ArrayCard.GetCount();j++)
				{
					if(GetCardData(2)==m_ArrayCard[j])
					{
						if(!m_bXiao)
							g_CardResource.m_pHua->Render(nXScreenPos+4,nYScreenPos-41);
						else
							g_CardResource.m_pXiaoHua->Render(nXScreenPos+15,nYScreenPos-26);
					}
				}
				nXScreenPos += nXExcusionV;

				//ڶ˿
				g_CardResource.m_SpecialCard.DrawCardItem(GetCardData(1),nXScreenPos,nYScreenPos,true,m_fScale);
				if( m_wCardCount != 4 )
				{
					for(BYTE j=0;j<m_ArrayCard.GetCount();j++)
					{
						if(GetCardData(1)==m_ArrayCard[j])
						{
							if(!m_bXiao)
								g_CardResource.m_pHua->Render(nXScreenPos+4,nYScreenPos-41);
							else
								g_CardResource.m_pXiaoHua->Render(nXScreenPos+15,nYScreenPos-26);
						}
					}
				}
				nXScreenPos += nXExcusionV;

				//һ˿
				g_CardResource.m_SpecialCard.DrawCardItem(GetCardData(0),nXScreenPos,nYScreenPos,true,m_fScale);
				for(BYTE j=0;j<m_ArrayCard.GetCount();j++)
				{
					if(GetCardData(0)==m_ArrayCard[j])
					{
						if(!m_bXiao)
							g_CardResource.m_pHua->Render(nXScreenPos+4,nYScreenPos-41);
						else
							g_CardResource.m_pXiaoHua->Render(nXScreenPos+15,nYScreenPos-26);
					}
				}


				//˿
				if( m_wCardCount == 4 )
				{
					g_CardResource.m_SpecialCard.DrawCardItem(GetCardData(3),nXScreenPos-nXExcusionV,nYScreenPos-20,
						true,m_fScale);
					for(BYTE j=0;j<m_ArrayCard.GetCount();j++)
					{
						if(GetCardData(3)==m_ArrayCard[j])
						{
							if(!m_bXiao)
								g_CardResource.m_pHua->Render(nXScreenPos-nXExcusionV+4,nYScreenPos-20-41);
							else
								g_CardResource.m_pXiaoHua->Render(nXScreenPos-nXExcusionV+15,nYScreenPos-20-26);
						}
					}
				}
			}
			
			break;
		}
	}

	return;
}
//˿
bool CWeaveCard::SetCardData(const BYTE cbCardData[], WORD wCardCount,BYTE cbWeaveType)
{
	//ЧС
	ASSERT(wCardCount<=CountArray(m_cbCardData));
	if (wCardCount>CountArray(m_cbCardData)) return false;

	//˿
	m_wCardCount=wCardCount;
	CopyMemory(m_cbCardData,cbCardData,sizeof(BYTE)*wCardCount);
	m_cbWeaveType=cbWeaveType;

	if( m_wCardCount == 0 )
		m_cbDirectionCardPos = 4;

	return true;
}

//ȡ˿
BYTE CWeaveCard::GetCardData(WORD wIndex)
{
	ASSERT(wIndex<CountArray(m_cbCardData));
	return (m_bDisplayItem==true||wIndex==3)?m_cbCardData[wIndex]:0;
}
void CWeaveCard::SetDuiHuaCard(BYTE cbCardData,bool bXiao)
{
	m_ArrayCard.Add(cbCardData);
	m_bXiao=bXiao;
}
//////////////////////////////////////////////////////////////////////////

//캯
CUserCard::CUserCard(const tstring& strName)
:hgeItemContainer(strName)
{
	//˿
	m_wCardCount=0;
	m_bCurrentCard=false;
	m_fScale=1.0f;

	//Ʊ
	m_ControlPoint.SetPoint(0,0);
	m_CardDirection=Direction_East;
}

//
CUserCard::~CUserCard()
{
}
//滭˿
void CUserCard::Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect)
{
	switch (m_CardDirection)
	{
	case Direction_North:	//
		{
			float nXExcusion =float(g_CardResource.m_HandCardWhite.GetViewWidth())*m_fScale;

			float nXPos = (float)m_ControlPoint.x;
			float nYPos = (float)m_ControlPoint.y;

			//˿
			for (WORD i=0;i<m_wCardCount;i++)
			{
				g_CardResource.m_HandCardWhite.DrawCardItem( 0,nXPos,nYPos,false,m_fScale);
				nXPos -= nXExcusion;
			}
			
			nXPos =(m_ControlPoint.x+POS_SPACE*m_fScale)+nXExcusion;

			//ǰ˿
			if (m_bCurrentCard==true)
			{
				g_CardResource.m_HandCardWhite.DrawCardItem(0,nXPos,nYPos,false,m_fScale);
			}

			break;
		}
	}

	return;
}

//˿
bool CUserCard::SetCurrentCard(bool bCurrentCard)
{
	//ñ
	m_bCurrentCard=bCurrentCard;

	return true;
}

//˿
bool CUserCard::SetCardData(WORD wCardCount, bool bCurrentCard)
{
	//ñ
	m_wCardCount=wCardCount;
	m_bCurrentCard=bCurrentCard;

	return true;
}

//˿
bool CUserCard::AddCardData(bool bCurrentCard)
{
	ASSERT( m_wCardCount+(m_bCurrentCard?1:0) < MAX_COUNT );
	if( m_wCardCount+(m_bCurrentCard?1:0) >= MAX_COUNT ) return false;

	if( !bCurrentCard )
		m_wCardCount++;
	else 
	{
		m_bCurrentCard = true;
	}

	return true;
}

//ȡλ
CPoint CUserCard::GetDispatchCardPos()
{
	CPoint ptTail = m_ControlPoint;
	ptTail.x=(m_ControlPoint.x+POS_SPACE*m_fScale)+float(g_CardResource.m_HandCardWhite.GetViewWidth())*m_fScale;
	return ptTail;
}
//////////////////////////////////////////////////////////////////////////

//캯
CDiscardCard::CDiscardCard(const tstring& strName)
:hgeItemContainer(strName)
{
	//˿
	m_cbCurrentCount = 0;
	m_cbCurrentMaxCount =CARD_COUNT;
	m_cbCurrentCount=CARD_COUNT;

	//Ʊ
	m_ControlPoint.SetPoint(0,0);
	m_CardDirection=Direction_East;

	return;
}

//
CDiscardCard::~CDiscardCard()
{
	
}
//滭˿
void CDiscardCard::Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect)
{
//滭
	switch (m_CardDirection)
	{
	case Direction_South:	//
		{
			if( m_ItemArray.GetCount() == 0 ) break;

			//for( int i = 0; i < m_ItemArray.GetCount(); i++ )
			for( INT_PTR i = m_ItemArray.GetCount()-1; i >=0; i-- )
			{
				tagDiscardItem &di = m_ItemArray[i];
				float nXPos=(float)m_ControlPoint.x+di.ptExcusion.x;
				float nYPos=(float)m_ControlPoint.y+di.ptExcusion.y;
				g_CardResource.m_SmallSpecialCard.DrawCardItem(di.cbCardData,nXPos,nYPos);
			}

			break;
		}
	case Direction_North:	//
		{
			if( m_ItemArray.GetCount() == 0 ) break;

			//for( INT_PTR i = m_ItemArray.GetCount()-1; i >=0; i-- )
			for( int i = 0; i < m_ItemArray.GetCount(); i++ )
			{
				tagDiscardItem &di = m_ItemArray[i];
				float nXPos=(float)m_ControlPoint.x+di.ptExcusion.x;
				float nYPos=(float)m_ControlPoint.y+di.ptExcusion.y;
				g_CardResource.m_SmallSpecialCard.DrawCardItem(di.cbCardData,nXPos,nYPos);
			}

			break;
		}
	}

	return;
}
//˿
bool CDiscardCard::AddCardItem(BYTE cbCardData)
{
	//
	tagDiscardItem di;
	di.cbCardData = cbCardData;

	//
	//ǰ
	if( ++m_cbCurrentCount > m_cbMaxCount )
	{
		//ѾŵС
		if( m_cbCurrentMaxCount == 2 )
		{
			//滻һ
			m_ItemArray[m_ItemArray.GetCount()-1].cbCardData = cbCardData;
			return true;
		}
		//¿ʼһ
		m_cbCurrentMaxCount -= 2;
		m_cbCurrentCount = 1;
	}

	//ƫ
	CPoint pt;
	switch( m_CardDirection )
	{
	case Direction_South:	//
		{
			int nItemWidth = g_CardResource.m_SmallSpecialCard.GetViewWidth();
			int nItemHeight = Y_TABLE_BOTTOM_EXCUSION;
			int nRowIndex = (CARD_COUNT-m_cbCurrentMaxCount)/2;
			di.wRowIndex=nRowIndex;
			di.wCardIndex=nRowIndex*CARD_COUNT+(m_cbCurrentCount-1);
			pt.x = (m_cbCurrentCount-1)*nItemWidth;
			pt.y = -nItemHeight*nRowIndex;
		}
		break;
	case Direction_North:	//
		{
			int nItemWidth = g_CardResource.m_SmallSpecialCard.GetViewWidth();
			int nItemHeight = Y_TABLE_TOP_EXCUSION;
			int nRowIndex = (CARD_COUNT-m_cbCurrentMaxCount)/2;
			pt.x =(m_cbCurrentCount)*nItemWidth;
			pt.y =nItemHeight*nRowIndex;
		}
		break;
	}

	//ƫ
	di.ptExcusion = pt;

	//
	m_ItemArray.Add( di );

	return true;
}

//÷
void CDiscardCard::SetDirection( enDirection Direction )
{
	m_CardDirection = Direction;

	//õǰʾĿ,ˮƽһΪ12,𲽼2,ֱһΪ10,𲽼2
	if( m_CardDirection == Direction_East || m_CardDirection == Direction_West )
		m_cbCurrentMaxCount = CARD_COUNT;
	else m_cbCurrentMaxCount = CARD_COUNT;

	m_cbMaxCount=m_cbCurrentMaxCount;
}

//˿
bool CDiscardCard::SetCardData(const BYTE cbCardData[], WORD wCardCount)
{
	m_cbCurrentCount = 0;

	//õǰʾĿ,ˮƽһΪ12,𲽼2,ֱһΪ10,𲽼2
	if( m_CardDirection == Direction_East || m_CardDirection == Direction_West )
		m_cbCurrentMaxCount = CARD_COUNT;
	else m_cbCurrentMaxCount = CARD_COUNT;
	m_cbMaxCount=m_cbCurrentMaxCount;

	m_ItemArray.RemoveAll();
	for( WORD i = 0; i < wCardCount; i++ )
		AddCardItem( cbCardData[i] );

	return true;
}

//ȡλ
CPoint CDiscardCard::GetLastCardPosition()
{
	if( m_ItemArray.GetCount() == 0 ) return CPoint(0,0);

	CPoint pt = m_ItemArray[m_ItemArray.GetCount()-1].ptExcusion;
	pt.x += m_ControlPoint.x;
	pt.y += m_ControlPoint.y;

	//
	switch( m_CardDirection )
	{
	case Direction_East:
	case Direction_West:
		{
			pt.x += g_CardResource.m_SmallSpecialCard.GetViewWidth()/2;
			pt.y += Y_TABLE_LEFT_EXCUSION/2;
		}
		break;
	case Direction_North:
	case Direction_South:
		{
			pt.x += g_CardResource.m_SmallSpecialCard.GetViewWidth()/2;
			pt.y += Y_TABLE_TOP_EXCUSION/2;
		}
	}

	return pt;
}

//ȡλ
CPoint CDiscardCard::GetDispatchCardPos()
{
	CPoint pt;

	//ǰ
	BYTE cbCurrentCount = m_cbCurrentCount;
	BYTE cbCurrentMaxCount = m_cbCurrentMaxCount;
	if( ++cbCurrentCount > m_cbMaxCount )
	{
		//ѾŵС
		if( cbCurrentMaxCount == 2 )
		{
			//滻һ
			pt = m_ItemArray[m_ItemArray.GetCount()-1].ptExcusion;
			pt += m_ControlPoint;
			return pt;
		}
		//¿ʼһ
		cbCurrentMaxCount -= 2;
		cbCurrentCount = 1;
	}

	//ƫ
	switch( m_CardDirection )
	{
	case Direction_South:	//
		{
			int nItemWidth = g_CardResource.m_SmallSpecialCard.GetViewWidth();
			int nItemHeight = Y_TABLE_BOTTOM_EXCUSION;
			int nRowIndex = (CARD_COUNT-cbCurrentMaxCount)/2;
			pt.x = (cbCurrentCount-1)*nItemWidth;
			pt.y = -nItemHeight*nRowIndex;
		}
		break;
	case Direction_North:	//
		{
			int nItemWidth = g_CardResource.m_SmallSpecialCard.GetViewWidth();
			int nItemHeight = Y_TABLE_TOP_EXCUSION;
			int nRowIndex = (CARD_COUNT-cbCurrentMaxCount)/2;
			pt.x = (cbCurrentCount)*nItemWidth/*-(nRowIndex*(nItemWidth/2))*/;
			pt.y = nItemHeight*nRowIndex-(nRowIndex*20);
		}
		break;
	}

	//ӻ׼λ
	pt += m_ControlPoint;

	return pt;
}

//Ƴ
void CDiscardCard::RemoveCard( BYTE cbRemoveCount )
{
	ASSERT( cbRemoveCount <= m_ItemArray.GetCount() );
	if( cbRemoveCount > m_ItemArray.GetCount() ) return;

	INT nCount = (INT)m_ItemArray.GetCount();
	m_ItemArray.RemoveAt( nCount-cbRemoveCount,cbRemoveCount );

	//ñ
	if( m_cbCurrentCount < cbRemoveCount )
	{
		cbRemoveCount -= m_cbCurrentCount;
		if( m_CardDirection == Direction_East || m_CardDirection == Direction_West )
			m_cbCurrentMaxCount = __min( CARD_COUNT,m_cbCurrentMaxCount+2 );
		else m_cbCurrentMaxCount = __min( CARD_COUNT,m_cbCurrentMaxCount+2 );
		while( cbRemoveCount > m_cbCurrentMaxCount )
		{
			cbRemoveCount -= m_cbCurrentMaxCount;
			if( m_CardDirection == Direction_East || m_CardDirection == Direction_West )
				m_cbCurrentMaxCount = __min( CARD_COUNT,m_cbCurrentMaxCount+2 );
			else m_cbCurrentMaxCount = __min( CARD_COUNT,m_cbCurrentMaxCount+2 );
		}
		m_cbCurrentCount = m_cbCurrentMaxCount-cbRemoveCount;
	}
	else m_cbCurrentCount -= cbRemoveCount;

	return;
}
BYTE CDiscardCard::GetLastCard()
{
	INT nCount = (INT)m_ItemArray.GetCount();
	return m_ItemArray[nCount-1].cbCardData;
}
//////////////////////////////////////////////////////////////////////////

//캯
CTableCard::CTableCard(const tstring& strName)
:hgeItemContainer(strName)
{
	//˿
	m_wCardCount=0;
	m_fScale=0.0f;
	ZeroMemory(m_cbCardData,sizeof(m_cbCardData));

	//Ʊ
	m_ControlPoint.SetPoint(0,0);
	m_CardDirection=Direction_East;
	m_cbProvideCard=0;
	m_cbHuIndex=0;
	m_cbUpData=0;
	m_bSmall=false;
	m_ArrayCard.RemoveAll();

	return;
}

//
CTableCard::~CTableCard()
{
}
void CTableCard::ResealeInfo()
{
	m_ArrayCard.RemoveAll();
}
//滭˿
void CTableCard::Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect)
{
	//滭
	switch (m_CardDirection)
	{
	case Direction_South:	//
		{
			int nXExcusion = g_CardResource.m_SpecialCard.GetViewWidth()-1;
			float nXPos =(float)m_ControlPoint.x+(CountArray(m_cbCardData)-m_wCardCount)*nXExcusion;
			float nYPos =(float)m_ControlPoint.y;

			//滭˿
			for (WORD i=0;i<m_wCardCount;i++)
			{
				g_CardResource.m_SpecialCard.DrawCardItem(m_cbCardData[i],nXPos,nYPos);
				for(BYTE j=0;j<m_ArrayCard.GetCount();j++)
				{
					if(m_cbCardData[i]==m_ArrayCard[j])
						g_CardResource.m_pHua->Render(nXPos+4,nYPos-41);
				}
				nXPos += nXExcusion;
			}

			if(m_cbProvideCard!=0)
			{
				nXPos+=POS_SPACE;
				g_CardResource.m_SpecialCard.DrawCardItem(m_cbProvideCard,nXPos,nYPos);
				g_CardResource.m_SpecialCard.DrawCardItem(m_cbProvideCard,nXPos,nYPos);
				for(BYTE j=0;j<m_ArrayCard.GetCount();j++)
				{
					if(m_cbProvideCard==m_ArrayCard[j])
						g_CardResource.m_pHua->Render(nXPos+4,nYPos-41);
				}
			}
			break;
		}
	case Direction_North:	//
		{
			if(m_bSmall)
			{
				float nXExcusion = g_CardResource.m_SmallSpecialCard.GetViewWidth()*m_fScale;
				float nXPos =(float)m_ControlPoint.x+(CountArray(m_cbCardData)-m_wCardCount)*nXExcusion;
				float nYPos =(float)m_ControlPoint.y;

				//滭˿
				for (WORD i=0;i<m_wCardCount;i++)
				{
					g_CardResource.m_SmallSpecialCard.DrawCardItem(m_cbCardData[i],nXPos,nYPos,true,m_fScale);
					g_CardResource.m_SmallSpecialCard.DrawCardItem(m_cbCardData[i],nXPos,nYPos,true,m_fScale);
					for(BYTE j=0;j<m_ArrayCard.GetCount();j++)
					{
						if(m_cbCardData[i]==m_ArrayCard[j])
							g_CardResource.m_pXiaoHua->RenderEx(nXPos+4,nYPos-(26*m_fScale),0.0f,m_fScale);
					}
					nXPos += nXExcusion;
				}

				if(m_cbProvideCard!=0)
				{
					nXPos+=10;
					g_CardResource.m_SmallSpecialCard.DrawCardItem(m_cbProvideCard,nXPos,nYPos,true,m_fScale);
					g_CardResource.m_SmallSpecialCard.DrawCardItem(m_cbProvideCard,nXPos,nYPos,true,m_fScale);
					for(BYTE j=0;j<m_ArrayCard.GetCount();j++)
					{
						if(m_cbProvideCard==m_ArrayCard[j])
							g_CardResource.m_pXiaoHua->RenderEx(nXPos+4,nYPos-(26*m_fScale),0.0f,m_fScale);
					}
				}
			}
			else
			{
				int nXExcusion = g_CardResource.m_SpecialCard.GetViewWidth()-1;
				float nXPos =(float)m_ControlPoint.x+(CountArray(m_cbCardData)-m_wCardCount)*nXExcusion;
				float nYPos =(float)m_ControlPoint.y;

				//滭˿
				for (WORD i=0;i<m_wCardCount;i++)
				{
					g_CardResource.m_SpecialCard.DrawCardItem(m_cbCardData[i],nXPos,nYPos);
					g_CardResource.m_SpecialCard.DrawCardItem(m_cbCardData[i],nXPos,nYPos);
					for(BYTE j=0;j<m_ArrayCard.GetCount();j++)
					{
						if(m_cbCardData[i]==m_ArrayCard[j])
							g_CardResource.m_pHua->Render(nXPos+4,nYPos-41);
					}
					nXPos += nXExcusion;
				}

				if(m_cbProvideCard!=0)
				{
					nXPos+=POS_SPACE;
					g_CardResource.m_SpecialCard.DrawCardItem(m_cbProvideCard,nXPos,nYPos);
					g_CardResource.m_SpecialCard.DrawCardItem(m_cbProvideCard,nXPos,nYPos);
					for(BYTE j=0;j<m_ArrayCard.GetCount();j++)
					{
						if(m_cbProvideCard==m_ArrayCard[j])
							g_CardResource.m_pHua->Render(nXPos+4,nYPos-41);
					}
				}
			}
			break;
		}
	}

	return;
}
//˿
bool CTableCard::SetCardData(const BYTE cbCardData[], WORD wCardCount)
{
	//ЧС
	ASSERT(wCardCount<=CountArray(m_cbCardData));
	if (wCardCount>CountArray(m_cbCardData))
		return false;

	//˿
	m_wCardCount=wCardCount;
	CopyMemory(m_cbCardData,cbCardData,sizeof(m_cbCardData[0])*wCardCount);

	return true;
}
void CTableCard::SetProvideCard(BYTE cbCardData)
{
	m_cbProvideCard=cbCardData;
	m_cbHuIndex=0;
	m_cbUpData=0;
}
void CTableCard::SetDuiHuaCard(BYTE cbCardData)
{
	m_ArrayCard.Add(cbCardData);
}
//////////////////////////////////////////////////////////////////////////

//캯
CCardControl::CCardControl(const tstring& strName)
:hgeItemContainer(strName)
{
	//״̬
	m_bPositively=false;
	m_bDisplayItem=false;
	m_bSelectMode = false;
	m_bShowCaiShen=false;
	m_cbSelectInfoCount = 0;
	m_cbCSCardData=0;
	m_bShowPlay=true;
	m_bGameEnd=false;
	m_cbCurSelectIndex = CountArray(m_SelectCardInfo);
	ZeroMemory( m_SelectCardInfo,sizeof(m_SelectCardInfo) );
	for( BYTE i = 0; i < CountArray(m_rcSelectCard); i++ )
		m_rcSelectCard[i].SetRectEmpty();

	//λñ
	m_XCollocateMode=enXCenter;
	m_YCollocateMode=enYCenter;
	m_BenchmarkPos.SetPoint(0,0);

	//˿
	m_wCardCount=0;
	m_cbCardData=0;
	m_cbIndex=0;
	m_cbCardIndex=0;
	m_cbCaiShengIndex=0;
	m_cbCurrentIndex=0;
	m_bCurrentStart=false;
	m_cbCurrentCaiIndex=0;
	m_bStart=false;
	m_bListen=false;
	m_bHearStatus=false;
	m_wHoverItem=INVALID_ITEM;
	ZeroMemory(&m_CurrentCard,sizeof(m_CurrentCard));
	ZeroMemory(&m_CardItemArray,sizeof(m_CardItemArray));

	//
	m_ControlPoint.SetPoint(0,0);
	m_ControlSize.cy = CARD_HEIGHT+POS_SHOOT;
	m_ControlSize.cx=(CountArray(m_CardItemArray)+1)*CARD_WIDTH+POS_SPACE;

	return;
}

//
CCardControl::~CCardControl()
{
}
void CCardControl::InitCardAnimate()
{
	m_CardAnimate.InitAnimate("\\Animate\\CardAnimate.png",11,1);
}
//׼λ
void CCardControl::SetBenchmarkPos(int nXPos, int nYPos, enXCollocateMode XCollocateMode, enYCollocateMode YCollocateMode)
{
	//ñ
	m_BenchmarkPos.x=nXPos;
	m_BenchmarkPos.y=nYPos;
	m_XCollocateMode=XCollocateMode;
	m_YCollocateMode=YCollocateMode;

	//λ
	switch (m_XCollocateMode)
	{
	case enXLeft:	{ m_ControlPoint.x=m_BenchmarkPos.x; break; }
	case enXCenter: { m_ControlPoint.x=m_BenchmarkPos.x-m_ControlSize.cx/2; break; }
	case enXRight:	{ m_ControlPoint.x=m_BenchmarkPos.x-m_ControlSize.cx; break; }
	}

	//λ
	switch (m_YCollocateMode)
	{
	case enYTop:	{ m_ControlPoint.y=m_BenchmarkPos.y; break; }
	case enYCenter: { m_ControlPoint.y=m_BenchmarkPos.y-m_ControlSize.cy/2; break; }
	case enYBottom: { m_ControlPoint.y=m_BenchmarkPos.y-m_ControlSize.cy; break; }
	}

	return;
}

//׼λ
void CCardControl::SetBenchmarkPos(const CPoint & BenchmarkPos, enXCollocateMode XCollocateMode, enYCollocateMode YCollocateMode)
{
	//ñ
	m_BenchmarkPos=BenchmarkPos;
	m_XCollocateMode=XCollocateMode;
	m_YCollocateMode=YCollocateMode;

	//λ
	switch (m_XCollocateMode)
	{
	case enXLeft:	{ m_ControlPoint.x=m_BenchmarkPos.x; break; }
	case enXCenter: { m_ControlPoint.x=m_BenchmarkPos.x-m_ControlSize.cx/2; break; }
	case enXRight:	{ m_ControlPoint.x=m_BenchmarkPos.x-m_ControlSize.cx; break; }
	}

	//λ
	switch (m_YCollocateMode)
	{
	case enYTop:	{ m_ControlPoint.y=m_BenchmarkPos.y; break; }
	case enYCenter: { m_ControlPoint.y=m_BenchmarkPos.y-m_ControlSize.cy/2; break; }
	case enYBottom: { m_ControlPoint.y=m_BenchmarkPos.y-m_ControlSize.cy; break; }
	}

	return;
}

//ȡ˿
BYTE CCardControl::GetHoverCard()
{
	//ȡ˿
	if (m_wHoverItem!=INVALID_ITEM)
	{
		if(m_bHearStatus)
		{
			if (m_wHoverItem==CountArray(m_CardItemArray))
			{
				m_bShowPlay=false;
				return m_CurrentCard.cbCardData;
			}
		}
		else
		{
			if (m_wHoverItem==CountArray(m_CardItemArray))
			{
				m_bShowPlay=false;
				return m_CurrentCard.cbCardData;
			}
			else
			{
				m_bShowPlay=true;
				return m_CardItemArray[m_wHoverItem].cbCardData;
			}
		}
	}

	return 0;
}

//˿
bool CCardControl::SetCurrentCard(BYTE cbCardData)
{
	//ñ
	m_CurrentCard.bShoot=false;
	m_CurrentCard.bGrayed = false;
	m_CurrentCard.cbCardData=cbCardData;

	return true;
}
void CCardControl::SetCaiShenData(BYTE cbCardData)
{
	m_cbCSCardData=cbCardData;
}
//˿
bool CCardControl::SetCurrentCard(tagCardItem CardItem)
{
	//ñ
	m_CurrentCard = CardItem;

	return true;
}

//˿
bool CCardControl::SetCardData(const BYTE cbCardData[], WORD wCardCount, BYTE cbCurrentCard)
{
	//ЧС
	ASSERT(wCardCount<=CountArray(m_CardItemArray));
	if (wCardCount>CountArray(m_CardItemArray)) 
		return false;

	//ǰ˿
	m_CurrentCard.bShoot=false;
	m_CurrentCard.bGrayed = false;
	m_CurrentCard.bShowCard=false;
	m_CurrentCard.cbCardData=cbCurrentCard;

	//˿
	m_wCardCount=wCardCount;
	for (WORD i=0;i<m_wCardCount;i++)
	{
		m_CardItemArray[i].bShoot=false;
		m_CardItemArray[i].bGrayed = false;
		m_CardItemArray[i].bShowCard=false;
		m_CardItemArray[i].cbCardData=cbCardData[i];
	}

	return true;
}
bool CCardControl::SetSendData(BYTE cbCardData)
{
	m_cbCardData=cbCardData;
	return true;
}
//˿
bool CCardControl::AddCardData(const BYTE cbCardData[], WORD wCardCount)
{
	ASSERT( m_wCardCount+(m_CurrentCard.cbCardData!=0?1:0)+wCardCount <= MAX_COUNT );
	if( m_wCardCount+(m_CurrentCard.cbCardData!=0?1:0)+wCardCount > MAX_COUNT ) return false;

	for( WORD i = 0; i < wCardCount; i++ )
	{
		if( m_wCardCount < CountArray(m_CardItemArray) )
		{
			m_CardItemArray[m_wCardCount].bShoot = false;
			m_CardItemArray[m_wCardCount].bGrayed = false;
			m_CardItemArray[m_wCardCount].bShowCard=false;
			m_CardItemArray[m_wCardCount++].cbCardData = cbCardData[i];
		}
		else
		{
			ASSERT( i == wCardCount-1 );
			m_CurrentCard.bShoot = false;
			m_CurrentCard.bGrayed = false;
			m_CurrentCard.bShowCard=false;
			m_CurrentCard.cbCardData = cbCardData[i];
		}
	}
	return true;
}

//˿
bool CCardControl::SetCardItem(const tagCardItem CardItemArray[], WORD wCardCount)
{
	//ЧС
	ASSERT(wCardCount<=CountArray(m_CardItemArray));
	if (wCardCount>CountArray(m_CardItemArray))
		return false;

	//˿
	m_wCardCount=wCardCount;
	for (WORD i=0;i<m_wCardCount;i++)
	{
		m_CardItemArray[i] = CardItemArray[i];
	}

	return true;
}
void CCardControl::Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect)
{
	//滭׼
	int nXExcursion=m_ControlPoint.x+(CountArray(m_CardItemArray)-m_wCardCount)*CARD_WIDTH;

	int card=255;

	for(WORD i=0;i<m_wCardCount;i++)
	{
		if(m_cbCardData==m_CardItemArray[i].cbCardData)
		{
			m_CardItemArray[i].bShowCard=true;
			if(card!=255)
				m_CardItemArray[card].bShowCard=false;
			card=i;
		}

		if(m_CardItemArray[m_wCardCount-1].cbCardData!=0)
		{
			m_CardItemArray[m_wCardCount-1].bShowCard=false;
		}
	}

	//滭˿
	for (WORD i=0;i<m_wCardCount;i++)
	{
		//λ
		int nXScreenPos=nXExcursion+CARD_WIDTH*i;
		int nYScreenPos=m_ControlPoint.y+(m_CardItemArray[i].bShoot==false?POS_SHOOT:0);

		//滭˿
		BYTE cbCardData=(m_bDisplayItem==true)?m_CardItemArray[i].cbCardData:0;
		bool bCardShow=m_CardItemArray[i].bShowCard;
		if( !m_CardItemArray[i].bGrayed )
		{
			if(bCardShow==true&&m_CurrentCard.cbCardData==0)
			{
				m_CardAnimate.DrawAnimate((float)nXScreenPos-12,(float)nYScreenPos-55);
				g_CardResource.m_HandCardWhite.DrawCardItem( cbCardData,(float)nXScreenPos,(float)nYScreenPos,false);
			}
			else
			{
				m_CardAnimate.DrawAnimate((float)nXScreenPos-12,(float)nYScreenPos-55);
				g_CardResource.m_HandCardWhite.DrawCardItem( cbCardData,(float)nXScreenPos,(float)nYScreenPos);
			}
		}
		else
		{
			g_CardResource.m_HandCardGrayed.DrawCardItem( cbCardData,(float)nXScreenPos,(float)nYScreenPos );
		}
	}

	//ǰ˿
	if (m_CurrentCard.cbCardData!=0)
	{
		//λ
		int nXScreenPos=m_ControlPoint.x+CountArray(m_CardItemArray)*CARD_WIDTH+POS_SPACE;
		int nYScreenPos=m_ControlPoint.y+(m_CurrentCard.bShoot==false?POS_SHOOT:0);

		//滭˿
		BYTE cbCardData=(m_bDisplayItem==true)?m_CurrentCard.cbCardData:0;
		if( !m_CurrentCard.bGrayed )
		{
			m_CardAnimate.DrawAnimate((float)nXScreenPos-12,(float)nYScreenPos-55);
			g_CardResource.m_HandCardWhite.DrawCardItem(cbCardData,(float)nXScreenPos,(float)nYScreenPos);
		}
		else 
			g_CardResource.m_HandCardGrayed.DrawCardItem( cbCardData,(float)nXScreenPos,(float)nYScreenPos );
	}
	return;
}
void CCardControl::ReleaseInfo()
{
	m_cbIndex=0;
	m_cbCaiShengIndex=0;
	m_cbCardIndex=0;
	m_bStart=false;
	m_bCurrentStart=false;
	m_cbCurrentCaiIndex=0;
	m_cbCurrentIndex=0;
	m_bGameEnd=false;
	m_bListen=false;
	m_bHearStatus=false;
	ZeroMemory(&m_CardItemArray,sizeof(m_CardItemArray));
}
//л
WORD CCardControl::SwitchCardPoint(CPoint & MousePoint)
{
	//׼λ
	int nXPos=MousePoint.x-m_ControlPoint.x;
	int nYPos=MousePoint.y-m_ControlPoint.y;

	//Χж
	if ((nXPos<0)||(nXPos>m_ControlSize.cx)) 
		return INVALID_ITEM;
	if ((nYPos<POS_SHOOT)||(nYPos>m_ControlSize.cy)) 
		return INVALID_ITEM;

	//
	if (nXPos<CARD_WIDTH*(int)CountArray(m_CardItemArray))
	{
		WORD wViewIndex=(WORD)(nXPos/CARD_WIDTH)+m_wCardCount;
		if (wViewIndex>=CountArray(m_CardItemArray))
		{
			wViewIndex -= CountArray(m_CardItemArray);
			//Ʋǻɫ״̬,򷵻ظ
			if( !m_CardItemArray[wViewIndex].bGrayed )
				return wViewIndex;
		}
		return INVALID_ITEM;
	}

	//ǰ
	if ((m_CurrentCard.cbCardData!=0)&&(nXPos>=(m_ControlSize.cx-CARD_WIDTH))&&!m_CurrentCard.bGrayed) 
		return CountArray(m_CardItemArray);

	return INVALID_ITEM;
}

//Ϣ
bool CCardControl::OnEventSetCursor(CPoint Point, CRect &rcRePaint,bool &bSetCard)
{
	rcRePaint.SetRectEmpty();

	if( !m_bSelectMode && m_bPositively==true )
	{
		//ȡ
		WORD wHoverItem=SwitchCardPoint(Point);
		//Ӧж
		if ((m_bPositively==false)&&(m_wHoverItem!=INVALID_ITEM))
		{
			m_wHoverItem=INVALID_ITEM;
		}
		if( wHoverItem != m_wHoverItem )
		{
			//
			CRect rcOld = GetCardRect(m_wHoverItem);
			CRect rcNew = GetCardRect(wHoverItem);
			rcRePaint.UnionRect( rcOld,rcNew );
			rcRePaint.InflateRect( 0,0,40,0 );
			rcRePaint.OffsetRect( m_ControlPoint.x,m_ControlPoint.y );

			if( m_wHoverItem != INVALID_ITEM )
			{
				if( m_wHoverItem == CountArray(m_CardItemArray) )
					m_CurrentCard.bShoot = false;
				else m_CardItemArray[m_wHoverItem].bShoot = false;
				bSetCard=false;
			}
			m_wHoverItem=wHoverItem;
			if( m_wHoverItem != INVALID_ITEM )
			{
				if( m_wHoverItem == CountArray(m_CardItemArray) )
				{
					m_CurrentCard.bShoot = true;
					if(m_bListen)
						m_TingCard(m_CurrentCard.cbCardData);
				}
				else
				{
					m_CardItemArray[m_wHoverItem].bShoot = true;
					if(m_bListen)
						m_TingCard(m_CardItemArray[m_wHoverItem].cbCardData);
				}
				bSetCard=true;
			}
		}

		if( wHoverItem!=INVALID_ITEM )
		{
			return true;
		}
		else return false;
	}
	//ѡģʽ,ǰѡ
	else if( m_bSelectMode && m_bPositively )
	{
		//ػ
		if( m_cbCurSelectIndex < CountArray(m_SelectCardInfo) )
		{
			CRect rc = m_rcSelectCard[m_cbCurSelectIndex];
			rc.OffsetRect( m_ControlPoint.x,m_ControlPoint.y );
			rcRePaint = rc;
		}

		//ȡǰѡλ
		BYTE cbCurIndex = CountArray(m_SelectCardInfo);
		for( BYTE i = 0; i < m_cbSelectInfoCount; i++ )
		{
			CRect rcValid = m_rcSelectCard[i];
			rcValid.OffsetRect( m_ControlPoint.x,m_ControlPoint.y );
			if( rcValid.PtInRect(Point) )
			{
				cbCurIndex = i;
				break;
			}
		}

		//õǰ
		if( m_cbCurSelectIndex != cbCurIndex )
		{
			//Ʒǵ
			m_CurrentCard.bShoot = false;
			for( WORD i = 0; i < m_wCardCount; i++ )
				m_CardItemArray[i].bShoot = false;
			//õǰѡλ
			m_cbCurSelectIndex = cbCurIndex;
			//õǰ
			if( m_cbCurSelectIndex < CountArray(m_SelectCardInfo) )
			{
				for( BYTE i = 0; i < m_SelectCardInfo[cbCurIndex].cbCardCount; i++ )
				{
					WORD j = 0;
					for( ; j < m_wCardCount; j++ )
					{
						if( m_CardItemArray[j].cbCardData == m_SelectCardInfo[cbCurIndex].cbCardData[i] &&
							!m_CardItemArray[j].bShoot)
						{
							m_CardItemArray[j].bShoot = true;
							bSetCard=true;
							break;
						}
					}
					if( j == m_wCardCount && 
						m_CurrentCard.cbCardData == m_SelectCardInfo[cbCurIndex].cbCardData[i] )
					{
						m_CurrentCard.bShoot = true;
						bSetCard=true;
					}
				}
				//ػ
				CRect rc = m_rcSelectCard[cbCurIndex];
				rc.OffsetRect( m_ControlPoint.x,m_ControlPoint.y );
				rcRePaint |= rc;
			}
		}

		if( m_cbCurSelectIndex!=CountArray(m_SelectCardInfo) )
		{
			return true;
		}
		else return false;
	}

	return false;
}

//Ƿɫ
void CCardControl::SetAllCardGray( bool bGray )
{
	for( WORD i = 0; i < m_wCardCount; i++ )
		m_CardItemArray[i].bGrayed = bGray;

	if( m_CurrentCard.cbCardData != 0 )
		m_CurrentCard.bGrayed = bGray;
}

//ƻɫ
void CCardControl::SetCardGray( BYTE cbCardData[], BYTE cbCardCount, bool bGray )
{
	ASSERT( cbCardCount <= m_wCardCount+1 );
	if( cbCardCount > m_wCardCount+1 ) return;

	for( WORD i = 0; i < cbCardCount; i++ )
	{
		//Ӧ
		WORD j = 0;
		for( ; j < m_wCardCount; j++ )
		{
			if( m_CardItemArray[j].cbCardData == cbCardData[i] )
			{
				m_CardItemArray[j].bGrayed = bGray;
				break;
			}
		}
		if( j == m_wCardCount && m_CurrentCard.cbCardData == cbCardData[i] )
			m_CurrentCard.bGrayed = bGray;
	}
}

//ȡɫ
BYTE CCardControl::GetGrayCard( BYTE cbCardData[], BYTE cbMaxCount, bool bGetGray )
{
	//0
	ZeroMemory( cbCardData,sizeof(BYTE)*cbMaxCount );

	BYTE cbGetCount = 0;
	//ҷ
	for( WORD i = 0; i < m_wCardCount; i++ )
	{
		if( m_CardItemArray[i].bGrayed == bGetGray )
		{
			cbCardData[cbGetCount++] = m_CardItemArray[i].cbCardData;
			if( cbGetCount == cbMaxCount ) return cbGetCount;
		}
	}
	if( m_CurrentCard.bGrayed == bGetGray )
		cbCardData[cbGetCount++] = m_CurrentCard.cbCardData;

	return cbGetCount;
}

//òģʽ
void CCardControl::SetSelectMode( bool bSelectMode )
{
	if( m_bSelectMode != bSelectMode )
	{
		m_bSelectMode = bSelectMode;
		if( !m_bSelectMode )
			SetAllCardGray(false);
	}
}

//ȡλ
CPoint CCardControl::GetDispatchCardPos(BYTE cbWeaveCount)
{
	CPoint pt = m_ControlPoint;
	if(m_bHearStatus)
	{
		pt.x += CountArray(m_CardItemArray)*CARD_WIDTH+POS_SPACE;
	}
	else
	{
		if(m_wHoverItem>=(CountArray(m_CardItemArray)))
		{
			pt.x += CountArray(m_CardItemArray)*CARD_WIDTH+POS_SPACE;
		}
		else
		{
			pt.x+=(m_wHoverItem+cbWeaveCount*3)*CARD_WIDTH+POS_SPACE;
		}
	}
	return pt;
}
//ȡλ
CPoint CCardControl::GetDispatchCardPos()
{
	CPoint pt = m_ControlPoint;
	pt.x += CountArray(m_CardItemArray)*CARD_WIDTH+POS_SPACE;
	return pt;
}
//ȡλ
CPoint	CCardControl::GetCutPos(BYTE cbWeaveCount)
{
	CPoint pt=m_ControlPoint;
	BYTE card=255;
	for(WORD i=0;i<m_wCardCount;i++)
	{
		if(m_cbCardData==m_CardItemArray[i].cbCardData)
		{
			m_CardItemArray[i].bShowCard=true;
			if(card!=255)
				m_CardItemArray[card].bShowCard=false;
			card=i;
		}

		if(m_CardItemArray[m_wCardCount-1].cbCardData!=0)
		{
			m_CardItemArray[m_wCardCount-1].bShowCard=false;
		}
	}

	BYTE card2=255;
	for(BYTE i=0;i<m_wCardCount;i++)
	{
		if(m_CardItemArray[i].bShowCard)
		{
			card2=i;
		}
	}

	if(card2==m_wCardCount-1||card2==255)
	{
		m_bShowPlay=false;
	}

	//if(card!=0)
	pt.x+=(card+cbWeaveCount*3)*CARD_WIDTH;

	return pt;
}
bool CCardControl::GetShowPlay()
{
	return m_bShowPlay;
}
//갴
bool CCardControl::OnEventLeftHitCard()
{
	if(m_bGameEnd)
		return false;
	if( !m_bSelectMode )
	{
		BYTE cbHoverCard = GetHoverCard();
		if( cbHoverCard != 0 )
		{
			m_OutCard(cbHoverCard);
		}
		return cbHoverCard!=0;
	}
	//ѡģʽ
	else
	{
		//ǰѡ
		if( m_cbCurSelectIndex < CountArray(m_SelectCardInfo) )
		{
			m_CardOperate();
		}
		else return false;
	}
	return false;
}

//ȡ
CRect CCardControl::GetCardRect( WORD wItemIndex )
{
	//
	CRect rc;
	rc.SetRectEmpty();

	if( wItemIndex == INVALID_ITEM ) return rc;

	//ǰ
	if( wItemIndex == CountArray(m_CardItemArray) )
	{
		CPoint ptTopLeft( CountArray(m_CardItemArray)*CARD_WIDTH+POS_SPACE,0 );
		CPoint ptRightBottom( ptTopLeft.x+CARD_WIDTH,ptTopLeft.y+CARD_HEIGHT );
		rc.SetRect( ptTopLeft,ptRightBottom );
	}
	else
	{
		WORD wViewIndex = CountArray(m_CardItemArray)-m_wCardCount+wItemIndex;
		CPoint ptTopLeft( wViewIndex*CARD_WIDTH,0 );
		CPoint ptRightBottom( ptTopLeft.x+CARD_WIDTH,ptTopLeft.y+CARD_HEIGHT );
		rc.SetRect( ptTopLeft,ptRightBottom );
	}

	//
	rc.InflateRect( 0,0,0,POS_SHOOT );
	return rc;
}
CRect CCardControl::GetCardRect()
{
	//
	CRect rc;
	rc.SetRectEmpty();

	return rc;
}
bool CCardControl::OnInCardRect(CPoint Point)
{
	//ȡ
	WORD wHoverItem=SwitchCardPoint(Point);
	//Ӧж
	if ((wHoverItem!=INVALID_ITEM))
	{
		return true;
	}

	return false;
}
//ҳ
bool CCardControl::OnEventUserAction( const tagSelectCardInfo SelectInfo[MAX_WEAVE], BYTE cbInfoCount )
{
	//ʼ
	m_cbSelectInfoCount = cbInfoCount;
	CopyMemory( m_SelectCardInfo,SelectInfo,sizeof(tagSelectCardInfo)*cbInfoCount );

	//ƻɫ
	SetAllCardGray( true );

	//ñ
	m_bSelectMode = true;
	m_cbCurSelectIndex = CountArray(m_SelectCardInfo);

	//Ϣ
	for( BYTE i = 0; i < m_cbSelectInfoCount; i++ )
	{
		//
		m_rcSelectCard[i].SetRectEmpty();

		for( BYTE j = 0; j < m_SelectCardInfo[i].cbCardCount; j++ )
		{
			WORD k = 0;
			for( ; k < m_wCardCount; k++ )
			{
				if( m_CardItemArray[k].cbCardData == m_SelectCardInfo[i].cbCardData[j] )
				{
					CRect rcCard = GetCardRect(k);

					if( rcCard != (m_rcSelectCard[i]&rcCard) )
					{
						//ò
						m_CardItemArray[k].bGrayed = false;

						//
						m_rcSelectCard[i] |= rcCard;

						break;
					}
				}
			}
			if( k == m_wCardCount && m_CurrentCard.cbCardData == m_SelectCardInfo[i].cbCardData[j] )
			{
				//ò
				m_CurrentCard.bGrayed = false;

				//
				m_rcSelectCard[i] |= GetCardRect(CountArray(m_CardItemArray));
			}
		}
	}

	return m_cbSelectInfoCount==1;
}

//ȡҲ
void CCardControl::GetUserSelectResult( tagSelectCardInfo &SelectInfo )
{
	if( m_bSelectMode )
	{
		ASSERT( m_cbSelectInfoCount > 0 );
		if( m_cbSelectInfoCount == 0 ) return;
		if( m_cbCurSelectIndex < CountArray(m_SelectCardInfo) )
			SelectInfo = m_SelectCardInfo[m_cbCurSelectIndex];
		else SelectInfo = m_SelectCardInfo[0];
	}
	else SelectInfo.cbCardCount = 0;
	return;
}
void CCardControl::CutCardOver()
{
	m_cbCardData=0;
	m_bShowPlay=true;
	for(BYTE i=0;i<m_wCardCount;i++)
	{
		m_CardItemArray[i].bShowCard=false;
	}

	m_bCurrentStart=false;
	m_cbCurrentCaiIndex=0;
	m_cbCurrentIndex=0;
}
void CCardControl::SetListen(bool bListen)
{
	m_bListen=bListen;
}
void CCardControl::SetHearStatus(bool bListen)
{
	m_bHearStatus=bListen;
}
void CCardControl::SetShowAnimate(bool bShow)
{
	if(bShow)
		m_CardAnimate.ShowAnimate();
	else
		m_CardAnimate.HideAnimate();

}
void CCardControl::UpData()
{
	m_CardAnimate.UpData(true);
}
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
//
CCardResource						g_CardResource;						//˿Դ
//////////////////////////////////////////////////////////////////////////