#ifndef CARD_CONTROL_HEAD_FILE
#define CARD_CONTROL_HEAD_FILE

#pragma once

#include "Stdafx.h"
#include "Resource.h"
#include "GameLogic.h"
#include "DrawAnimateEx.h"
#include "cassert"

//////////////////////////////////////////////////////////////////////////

//X зʽ
enum enXCollocateMode 
{ 
	enXLeft,						//
	enXCenter,						//ж
	enXRight,						//Ҷ
};

//Y зʽ
enum enYCollocateMode 
{ 
	enYTop,							//϶
	enYCenter,						//ж
	enYBottom,						//¶
};

//ö
enum enDirection
{
	Direction_North=0,					//
	Direction_West,						//
	Direction_South,					//
	Direction_East,						//
};

//滭ƫ,ڶ,ƵĻ滭
#define Y_USER_LEFT_EXCUSION		11									//ʾ
#define Y_USER_RIGHT_EXCUSION		11									//ʾ
#define Y_TABLE_LEFT_EXCUSION		13									//ʾ
#define Y_TABLE_BOTTOM_EXCUSION		35									//ʾ
#define Y_TABLE_RIGHT_EXCUSION		26									//ʾ
#define Y_TABLE_TOP_EXCUSION		35									//ʾ
#define Y_HEAP_DOUBLE_V_EXCUSION	8									//ʾ

//////////////////////////////////////////////////////////////////////////

//˿ͼƬ
class CCardListImage
{
	//λñ
protected:
	int								m_nItemWidth;						//߶
	int								m_nItemHeight;						//

	//Դ
protected:
	MySprite						*m_pCardListImage;					//ͼƬԴ

	//
public:
	//캯
	CCardListImage();
	//
	virtual ~CCardListImage();

	//Ϣ
public:
	//ȡ
	int GetViewWidth() { return m_nItemWidth; }
	//ȡ߶
	int GetViewHeight() { return m_nItemHeight; }

	//Դ
public:
	//Դ
	bool LoadResource(HTEXTURE tex,float cbWidth,float cbHeight,bool bHuaCard=false);
	//ͷԴ
	bool DestroyResource();

	//ܺ
public:
	//滭˿
	inline bool DrawCardItem(BYTE cbCardData, float xDest, float yDest,bool bShowCard=true,float fScale=1.0f);
};

//////////////////////////////////////////////////////////////////////////

//˿Դ
class CCardResource
{
public:
	CCardListImage				m_HandCardWhite;
	CCardListImage				m_HandCardGrayed;
	CCardListImage				m_SpecialCard;
	CCardListImage				m_SmallSpecialCard;
	MySprite					*m_pHua;
	MySprite						*m_pXiaoHua;
	//
public:
	//캯
	CCardResource();
	//
	virtual ~CCardResource();

	//ܺ
public:
	//Դ
	bool LoadResource();
	//Դ
	bool DestroyResource();
};

//////////////////////////////////////////////////////////////////////////
class CHeapCard : public hgeItemContainer
{
	//Ʊ
protected:
	CPoint							m_ControlPoint;						//׼λ
	enDirection						m_CardDirection;					//˿˷
	float							m_fScale;

	//˿˱
protected:
	WORD							m_wFullCount;						//ȫĿ
	WORD							m_wMinusHeadCount;					//ͷȱ
	WORD							m_wMinusLastCount;					//βȱ

	BYTE							m_cbCardData[HEAP_FULL_COUNT];		//ֵ
	BYTE                            m_ShowingCardIndex;                 // 
	//
public:
	//캯
	CHeapCard(const tstring& strName);
	//
	virtual ~CHeapCard();

	//ܺ
public:
	//滭˿
	void Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect);
	//˿
	bool SetHeapCardInfo(WORD wMinusHeadCount, WORD wMinusLastCount);
	//÷,wIndexβֻ
	void SetCardData( WORD wIndex, BYTE cbCardData );
	//ȡλ
	CPoint GetDispatchCardPos( bool bTail );
	//ȡλ,wIndexʾβֻ
	CPoint GetDispatchCardPos( WORD wIndex );
	//ƶƳ,bTailָǷβƳ
	bool DeductionHeapCard( bool bTail );
	//÷
	void ResetCardData();
	//Ϊ,wIndexβֻ
	void SetCardEmpty( WORD wIndex, BYTE cbEmptyCount );
	//
	void SetScaleCard(float fScale) {m_fScale=fScale;}
	float GetScaleCard(){return m_fScale;}

	//ؼ
public:
	//÷
	void SetDirection(enDirection Direction) { m_CardDirection=Direction; }
	//׼λ
	void SetControlPoint(int nXPos, int nYPos) { m_ControlPoint.SetPoint(nXPos,nYPos); }
};
//////////////////////////////////////////////////////////////////////////
//class CHeapCard : public hgeItemContainer
//{
//	//Ʊ
//protected:
//	hgePoint						m_ControlPoint;						//׼λ
//	//˿˱
//protected:
//	WORD							m_wFullCount;
//	BYTE							m_cbCardCount;
//	float							m_fScale;
//	//
//public:
//	//캯
//	CHeapCard(const tstring& strName);
//	//
//	virtual ~CHeapCard();
//	//ܺ
//public:
//	//滭˿
//	void Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect);
//	//˿
//	void SetCardCount(BYTE cbCardCount);
//	//ؼ
//public:
//	//
//	void SetScaleCard(float fScale) {m_fScale=fScale;}
//	//׼λ
//	void SetControlPoint(float nXPos, float nYPos) { m_ControlPoint.x=nXPos;m_ControlPoint.y=nYPos;}
//};
//////////////////////////////////////////////////////////////////////////

class CWeaveCard : public hgeItemContainer
{
	//Ʊ
protected:
	bool							m_bDisplayItem;						//ʾ־
	CPoint							m_ControlPoint;						//׼λ
	enDirection						m_CardDirection;					//˿˷		
	BYTE							m_cbDirectionCardPos;				//˿	
	float							m_fScale;

	//˿
protected:
	WORD							m_wCardCount;						//˿Ŀ
	BYTE							m_cbCardData[4];					//˿
	BYTE							m_cbWeaveType;
	CWHArray<BYTE>					m_ArrayCard;
	bool							m_bXiao;
	bool							m_bSmall;

	//
public:
	//캯
	CWeaveCard(const tstring& strName);
	//
	virtual ~CWeaveCard();

	//ܺ
public:
	//滭˿
	void Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect);
	//˿
	bool SetCardData(const BYTE cbCardData[], WORD wCardCount,BYTE cbWeaveType);

	//ؼ
public:
	//ʾ
	void SetDisplayItem(bool bDisplayItem) { m_bDisplayItem=bDisplayItem; }
	//÷
	void SetDirection(enDirection Direction) { m_CardDirection=Direction; }
	//׼λ
	void SetControlPoint(int nXPos, int nYPos) { m_ControlPoint.SetPoint(nXPos,nYPos); }
	//
	void SetDirectionCardPos(BYTE cbPos) { m_cbDirectionCardPos = cbPos;}
	//Ի
	void SetDuiHuaCard(BYTE cbCardData,bool bXiao=false);
	//ôС
	void SetCardSize(bool bSmall){m_bSmall=bSmall;}
	//
	void SetScaleCard(float fScale) {m_fScale=fScale;}
	void ResealeInfo();

	//ڲ
private:
	//ȡ˿
	inline BYTE GetCardData(WORD wIndex);
};

//////////////////////////////////////////////////////////////////////////

class CUserCard : public hgeItemContainer
{
	//˿
protected:
	WORD							m_wCardCount;						//˿Ŀ
	bool							m_bCurrentCard;						//ǰ־
	float							m_fScale;

	//Ʊ
protected:
	CPoint							m_ControlPoint;						//׼λ
	enDirection						m_CardDirection;					//˿˷

	//
public:
	//캯
	CUserCard(const tstring& strName);
	//
	virtual ~CUserCard();

	//ܺ
public:
	//滭˿
	void Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect);
	//˿
	bool SetCurrentCard(bool bCurrentCard);
	//˿
	bool SetCardData(WORD wCardCount, bool bCurrentCard);
	//˿
	bool AddCardData(bool bCurrentCard);
	//ȡ
	WORD GetCardCount() { return m_wCardCount; }
	//Ƿеǰ
	bool IsHaveCurrentCard() { return m_bCurrentCard; }
	//ȡλ
	CPoint GetDispatchCardPos();

	//ؼ
public:
	//
	void SetScaleCard(float fScale){m_fScale=fScale;}
	//÷
	void SetDirection(enDirection Direction) { m_CardDirection=Direction; }
	//׼λ
	void SetControlPoint(int nXPos, int nYPos) { m_ControlPoint.SetPoint(nXPos,nYPos); }
	//ȡ׼λ
	CPoint GetControlPoint() {return m_ControlPoint;}
};
//////////////////////////////////////////////////////////////////////////

//
struct tagDiscardItem 
{
	BYTE				cbCardData;										//˿
	WORD				wCardIndex;										//˿
	WORD				wRowIndex;										//
	CPoint				ptExcusion;										//Ի׼λ
};

//ģ
typedef	CWHArray<tagDiscardItem>	CDiscardItemArray;

class CDiscardCard : public hgeItemContainer
{
	//˿
protected:
	BYTE							m_cbCurrentMaxCount;				//ǰ
	BYTE							m_cbMaxCount;
	BYTE							m_cbCurrentCount;					//ǰ
	CDiscardItemArray				m_ItemArray;						//˿

	//Ʊ
protected:
	CPoint							m_ControlPoint;						//׼λ
	enDirection						m_CardDirection;					//˿˷
	//
public:
	//캯
	CDiscardCard(const tstring& strName);
	//
	virtual ~CDiscardCard();

	//ܺ
public:
	//滭˿
	void Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect);
	//˿
	bool AddCardItem(BYTE cbCardData);
	//˿
	bool SetCardData(const BYTE cbCardData[], WORD wCardCount);
	//ȡһֻλ
	CPoint GetLastCardPosition();
	//ȡһ
	BYTE GetLastCard();
	//ȡλ
	CPoint GetDispatchCardPos();
	//ӶƳ,cbRemoveCountָƳĿ
	void RemoveCard( BYTE cbRemoveCount );
	//ȡ
	INT_PTR GetCardCount() { return m_ItemArray.GetCount(); }
	//ؼ
public:
	//÷
	void SetDirection(enDirection Direction);
	//׼λ
	void SetControlPoint(int nXPos, int nYPos) { m_ControlPoint.SetPoint(nXPos,nYPos); }
};

//////////////////////////////////////////////////////////////////////////

class CTableCard : public hgeItemContainer
{
	//˿
protected:
	WORD							m_wCardCount;						//˿Ŀ
	BYTE							m_cbCardData[MAX_COUNT];			//˿
	BYTE							m_cbProvideCard;
	BYTE							m_cbHuIndex;
	BYTE							m_cbUpData;
	float							m_fScale;

	//Ʊ
protected:
	CPoint							m_ControlPoint;						//׼λ
	enDirection						m_CardDirection;					//˿˷
	CWHArray<BYTE>			m_ArrayCard;
	bool							m_bSmall;

	//
public:
	//캯
	CTableCard(const tstring& strName);
	//
	virtual ~CTableCard();

	//ܺ
public:
	//滭˿
	void Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect);
	//˿
	bool SetCardData(const BYTE cbCardData[], WORD wCardCount);
	//
	void SetProvideCard(BYTE cbCardData);
	//Ի
	void SetDuiHuaCard(BYTE cbCardData);
	//ôС
	void SetCardSize(bool bSmall){m_bSmall=bSmall;}
	//
	void SetScaleCard(float fScale) {m_fScale=fScale;}
	void ResealeInfo();

	//ؼ
public:
	//÷
	void SetDirection(enDirection Direction) { m_CardDirection=Direction; }
	//׼λ
	void SetControlPoint(int nXPos, int nYPos) { m_ControlPoint.SetPoint(nXPos,nYPos); }
};
//////////////////////////////////////////////////////////////////////////

//˿˽ṹ
struct tagCardItem
{
	bool							bShoot;								//־
	bool							bGrayed;							//
	bool							bShowCard;
	BYTE							cbCardData;							//˿
};

//ѡ˿Ϣ
struct tagSelectCardInfo
{
	DWORD							wActionMask;						//
	BYTE							cbActionCard;						//
	BYTE							cbCardCount;						//ѡĿ
	BYTE							cbCardData[MAX_COUNT];				//ѡ
};

class CCardControl : public hgeItemContainer
{
	//״̬
protected:
	bool							m_bPositively;						//Ӧ־
	bool							m_bDisplayItem;						//ʾ־
	bool							m_bSelectMode;						//ѡģʽ
	BYTE							m_cbSelectInfoCount;				//ѡ˿Ŀ
	tagSelectCardInfo				m_SelectCardInfo[MAX_WEAVE];		//ѡ˿Ϣ
	CRect							m_rcSelectCard[MAX_WEAVE];			//ѡ˿
	BYTE							m_cbCurSelectIndex;					//ǰѡ
	BYTE							m_cbCSCardData;
	bool							m_bShowPlay;
	bool							m_bShowCaiShen;
	bool							m_bListen;
	bool							m_bHearStatus;

	//λñ
protected:
	CPoint							m_BenchmarkPos;						//׼λ
	enXCollocateMode				m_XCollocateMode;					//ʾģʽ
	enYCollocateMode				m_YCollocateMode;					//ʾģʽ

	//˿
protected:
	WORD							m_wCardCount;						//˿Ŀ
	WORD							m_wHoverItem;						//
	tagCardItem						m_CurrentCard;						//ǰ˿
	tagCardItem						m_CardItemArray[MAX_COUNT-1];		//˿
	BYTE							m_cbCardData;
	BYTE							m_cbCaiShengIndex;
	BYTE							m_cbIndex;
	BYTE							m_cbCardIndex;
	bool							m_bStart;
	bool							m_bCurrentStart;
	BYTE							m_cbCurrentIndex;
	BYTE							m_cbCurrentCaiIndex;
public:
	bool							m_bGameEnd;
	//Դ
protected:
	CSize							m_ControlSize;						//ؼС
	CPoint							m_ControlPoint;						//ؼλ
	CDrawAnimateEx					m_CardAnimate;
public:
	FEvent_PInt						m_OutCard;
	FEvent_Void						m_CardOperate;
	FEvent_PInt						m_TingCard;

	//
public:
	//캯
	CCardControl(const tstring& strName);
	//
	virtual ~CCardControl();

	//ѯ
public:
	void InitCardAnimate();
	//ȡ˿
	BYTE GetHoverCard();
	//ȡ˿
	BYTE GetCurrentCard() { return m_CurrentCard.cbCardData; }
	//Ƿ񲥷Ŷ
	bool GetShowPlay();
	void SetShowCaiShen(bool bShowCaiShen){m_bShowCaiShen=bShowCaiShen;}

	void ReleaseInfo();

	//˿˿
public:
	//˿
	bool SetCurrentCard(BYTE cbCardData);
	//˿
	bool SetCurrentCard(tagCardItem CardItem);
	//˿
	bool SetCardData(const BYTE cbCardData[], WORD wCardCount, BYTE cbCurrentCard);
	//˿
	bool SetCardItem(const tagCardItem CardItemArray[], WORD wCardCount);
	//˿
	bool AddCardData(const BYTE cbCardData[], WORD wCardCount);
	//˿
	bool SetSendData(BYTE cbCardData);
	BYTE GetSendData(){return m_cbCardData;};

	//ؼ
public:
	//Ӧ
	void SetPositively(bool bPositively) { m_bPositively=bPositively; }
	//ʾ
	void SetDisplayItem(bool bDisplayItem) { m_bDisplayItem=bDisplayItem; }
	//׼λ
	void SetBenchmarkPos(int nXPos, int nYPos, enXCollocateMode XCollocateMode, enYCollocateMode YCollocateMode);
	//׼λ
	void SetBenchmarkPos(const CPoint & BenchmarkPos, enXCollocateMode XCollocateMode, enYCollocateMode YCollocateMode);
	//òģʽ
	void SetSelectMode( bool bSelectMode );

	void SetCaiShenData(BYTE cbCardData);
	//ȡģʽ
	bool GetSelectMode() { return m_bSelectMode; }
	//Ƿɫ
	void SetAllCardGray( bool bGray );
	//Ƿɫ
	void SetCardGray( BYTE cbCardData[], BYTE cbCardCount, bool bGray );
	//ȡɫ
	BYTE GetGrayCard( BYTE cbCardData[], BYTE cbMaxCount, bool bGetGray );
	//ȡλ
	CPoint GetDispatchCardPos(BYTE cbWeaveCount);
	//ȡλ
	CPoint GetDispatchCardPos();
	//ȡλ
	CPoint GetCutPos(BYTE cbWeaveCount);
	//ȡҲ
	void GetUserSelectResult( tagSelectCardInfo &SelectInfo );
	//
	void CutCardOver();
	void SetListen(bool bListen);
	void SetHearStatus(bool bListen);
	void SetShowAnimate(bool bShow);
	void UpData();

	//¼
public:
	//滭˿
	void Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect);
	//Ϣ
	bool OnEventSetCursor(CPoint Point, CRect &rcRePaint,bool &bSetCard);
	//갴
	bool OnEventLeftHitCard();
	//ҳ
	bool OnEventUserAction( const tagSelectCardInfo SelectInfo[MAX_WEAVE], BYTE cbInfoCount );
	CRect GetCardRect();
	bool OnInCardRect(CPoint Point);

	//ڲ
private:
	//л
	WORD SwitchCardPoint(CPoint & MousePoint);
	//ȡ
	CRect GetCardRect( WORD wItemIndex );
};

//////////////////////////////////////////////////////////////////////////

//
extern CCardResource				g_CardResource;						//˿Դ

//////////////////////////////////////////////////////////////////////////

#endif