#include "StdAfx.h"
#include "ControlWnd.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

CControlWnd::CControlWnd(const tstring &strname, const std::string & group)
:hgeItemContainerEx(strname)
{
	m_cbActionMask=WIK_NULL;
}

CControlWnd::~CControlWnd(void)
{
}
void CControlWnd::SetControlInfo(DWORD cbAcitonMask,bool bShow)
{
	//ưť
	m_btPeng.SetState(cbAcitonMask&(WIK_PENG|WIK_PENG_LISTEN));
	m_btGang.SetState(cbAcitonMask&WIK_GANG);
	m_btChiHu.SetState(cbAcitonMask&WIK_CHI_HU);
	m_btChi.SetState(cbAcitonMask&(WIK_LEFT|WIK_CENTER|WIK_RIGHT|WIK_LEFT_LISTEN|WIK_CENTER_LISTEN|WIK_RIGHT_LISTEN));
	m_btTing.SetState(cbAcitonMask&WIK_LISTEN);

	m_cbActionMask=cbAcitonMask;

	//ƴ
	SetButtonShow((cbAcitonMask!=WIK_NULL)?SW_SHOW:SW_HIDE);
}
void CControlWnd::Init()
{
	m_btChi.LoadButtonImage("\\data\\chi.png",WIK_LEFT);
	m_btChi.m_ButtonMessage=FEvent_PInt(this,&CControlWnd::OnBnClickedChi);
	m_btTing.LoadButtonImage("\\data\\ting.png",WIK_LISTEN);
	m_btTing.m_ButtonMessage=FEvent_PInt(this,&CControlWnd::OnBnClickedTing);
	m_btPeng.LoadButtonImage("\\data\\peng.png",WIK_PENG);
	m_btPeng.m_ButtonMessage=FEvent_PInt(this,&CControlWnd::OnBnClickedPeng);
	m_btGang.LoadButtonImage("\\data\\gang.png",WIK_GANG);
	m_btGang.m_ButtonMessage=FEvent_PInt(this,&CControlWnd::OnBnClickedGang);
	m_btChiHu.LoadButtonImage("\\data\\hu.png",WIK_CHI_HU);
	m_btChiHu.m_ButtonMessage=FEvent_PInt(this,&CControlWnd::OnBnClickedChiHu);
	m_btGiveUp.LoadButtonImage("\\data\\giveup.png",WIK_NULL);
	m_btGiveUp.m_ButtonMessage=FEvent_PInt(this,&CControlWnd::OnBnClickedGiveUp);
}
void CControlWnd::SetButtonShow(BOOL bShow)
{
	m_btChi.SetShow(bShow);
	m_btTing.SetShow(bShow);
	m_btPeng.SetShow(bShow);
	m_btGang.SetShow(bShow);
	m_btChiHu.SetShow(bShow);
	m_btGiveUp.SetShow(bShow);
}
void CControlWnd::OnBnClickedPeng(int n)
{
	m_pButtonIn(WIK_PENG);
}
void CControlWnd::OnBnClickedChi(int n)
{
	m_pButtonIn(WIK_LEFT);
}
void CControlWnd::OnBnClickedTing(int n)
{
	m_pTingIn(WIK_LISTEN);
}
void CControlWnd::OnBnClickedGang(int n)
{
	m_pButtonIn(WIK_GANG);
}
void CControlWnd::OnBnClickedGiveUp(int n)
{
	m_pButtonIn(WIK_NULL);
}
void CControlWnd::OnBnClickedChiHu(int n)
{
	m_pButtonIn(WIK_CHI_HU);
}
void CControlWnd::Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect)
{
	m_btChi.DrawButton();
	m_btTing.DrawButton();
	m_btPeng.DrawButton();
	m_btGang.DrawButton();
	m_btChiHu.DrawButton();
	m_btGiveUp.DrawButton();
}
void CControlWnd::SetScorePoint(hgePoint hPoint)
{
	m_ptControlWnd=hPoint;
	m_btChi.SetPoint(CPoint((int)hPoint.x+59,(int)hPoint.y+7));
	m_btTing.SetPoint(CPoint((int)hPoint.x-96,(int)hPoint.y+7));
	m_btPeng.SetPoint(CPoint((int)hPoint.x-30,(int)hPoint.y+57));
	m_btGang.SetPoint(CPoint((int)hPoint.x-29,(int)hPoint.y-38));
	m_btChiHu.SetPoint(CPoint((int)hPoint.x,(int)hPoint.y-5));
	m_btGiveUp.SetPoint(CPoint((int)hPoint.x+118,(int)hPoint.y+7));
}
void CControlWnd::OnLButtonDown(UINT nFlags, const hgePoint& point)
{
	m_btChi.OnLButtonDown(nFlags,CPoint((int)point.x,(int)point.y));
	m_btTing.OnLButtonDown(nFlags,CPoint((int)point.x,(int)point.y));
	m_btPeng.OnLButtonDown(nFlags,CPoint((int)point.x,(int)point.y));
	m_btGang.OnLButtonDown(nFlags,CPoint((int)point.x,(int)point.y));
	m_btChiHu.OnLButtonDown(nFlags,CPoint((int)point.x,(int)point.y));
	m_btGiveUp.OnLButtonDown(nFlags,CPoint((int)point.x,(int)point.y));
}
void CControlWnd::OnLButtonUp( UINT nFlags, const hgePoint & point )
{
	m_btChi.OnLButtonUp(nFlags,CPoint((int)point.x,(int)point.y));
	m_btTing.OnLButtonUp(nFlags,CPoint((int)point.x,(int)point.y));
	m_btPeng.OnLButtonUp(nFlags,CPoint((int)point.x,(int)point.y));
	m_btGang.OnLButtonUp(nFlags,CPoint((int)point.x,(int)point.y));
	m_btChiHu.OnLButtonUp(nFlags,CPoint((int)point.x,(int)point.y));
	m_btGiveUp.OnLButtonUp(nFlags,CPoint((int)point.x,(int)point.y));
}
void CControlWnd::OnMouseMove(UINT nFlags, const hgePoint& point)
{
	m_btChi.OnMouseMove(nFlags,CPoint((int)point.x,(int)point.y));
	m_btTing.OnMouseMove(nFlags,CPoint((int)point.x,(int)point.y));
	m_btPeng.OnMouseMove(nFlags,CPoint((int)point.x,(int)point.y));
	m_btGang.OnMouseMove(nFlags,CPoint((int)point.x,(int)point.y));
	m_btChiHu.OnMouseMove(nFlags,CPoint((int)point.x,(int)point.y));
	m_btGiveUp.OnMouseMove(nFlags,CPoint((int)point.x,(int)point.y));
}