#include "StdAfx.h"
#include "DrawAnimate.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

CDrawAnimate::CDrawAnimate(const tstring& strName)
:hgeItemContainer(strName)
{
	m_phge = hgeCreate(HGE_VERSION);
	m_Texture=NULL;
	m_pSprite=NULL;
	m_fSpriteWidth=0;
	m_fSpriteHeight=0;
	m_fFrameWidth=0;
	m_fFrameHeight=0;
	m_dwFrame=0;
	m_dwSpeed=0;
	m_hgePoint=hgePoint(0.0f,0.0f);
	m_bStart=false;
	m_bRun=true;
	m_bSice=false;
	m_bShowFrame=false;
	m_cbShowFrame=255;
	m_bInit=false;
}

CDrawAnimate::~CDrawAnimate(void)
{
	if(m_pSprite)
		delete m_pSprite;
}
void CDrawAnimate::InitAnimate(HTEXTURE tex,float nWidth,float nHeight,DWORD dwFrame,bool bRun,bool bSice)
{
	m_pSprite=new MySprite(tex,0,0,nWidth,nHeight);
	m_fSpriteWidth=m_pSprite->GetWidth();
	m_fSpriteHeight=m_pSprite->GetHeight();
	m_fFrameWidth=m_fSpriteWidth/dwFrame;
	m_fFrameHeight=m_fSpriteHeight;
	
	m_dwFrame=dwFrame;
	m_bRun=bRun;
	m_bSice=bSice;
}
void CDrawAnimate::InitAnimate(const char*  StrFile,float nWidth,float nHeight,DWORD dwFrame)
{
	m_fSpriteWidth=nWidth;
	m_fSpriteHeight=nHeight;
	m_fFrameWidth=m_fSpriteWidth/dwFrame;
	m_fFrameHeight=m_fSpriteHeight;
	m_dwFrame=dwFrame;
	m_StrFile=StrFile;
	m_bRun=false;
	m_bSice=false;
	m_bInit=true;
}
void CDrawAnimate::Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect)
{

	//m_pSprite->Render(m_hgePoint.x-4000,m_hgePoint.y);
	//m_pSprite->Render(m_hgePoint.x,m_hgePoint.y+200);
	if(m_bStart&&m_dwFrame!=0)
	{
		m_pSprite->SetTextureRect(m_fFrameWidth*m_dwSpeed,0,m_fFrameWidth,m_fFrameHeight);
		m_pSprite->Render(m_hgePoint.x,m_hgePoint.y);
	}
	else if(m_bShowFrame&&m_cbShowFrame!=255)
	{
		m_pSprite->SetTextureRect(m_fFrameWidth*m_cbShowFrame,0,m_fFrameWidth,m_fFrameHeight);
		m_pSprite->Render(m_hgePoint.x,m_hgePoint.y);
	}
}
DWORD CDrawAnimate::UpData()
{
	if(m_bStart&&m_dwFrame!=0)
	{
		m_dwSpeed++;
		if(m_dwSpeed>=m_dwFrame)
		{
			m_dwSpeed=0;
			if(!m_bRun)
				Stop();
		}
	}
	return m_dwSpeed;
}
void CDrawAnimate::Start()
{
	if(m_bInit)
	{
		//AfxMessageBox(m_StrFile);
		m_Texture=m_phge->Texture_Load(m_StrFile.c_str());
		m_pSprite=new MySprite(m_Texture,0,0,m_fSpriteWidth,m_fSpriteHeight);
	}
	m_bStart=true;
	m_dwSpeed=0;
}
void CDrawAnimate::Stop()
{
	m_bStart=false;
	if(m_bSice)
	{
		if(_IsStop)
			_IsStop();
	}
	if(m_bInit)
	{
		if(!m_bShowFrame)
			m_phge->Texture_Free(m_Texture);
	}
}
void CDrawAnimate::SetPoint(hgePoint point)
{
	m_hgePoint=point;
}
void CDrawAnimate::SetShowFrame(bool bShowFrame,BYTE cbShowFrame)
{
	m_bShowFrame=bShowFrame;
	m_cbShowFrame=cbShowFrame;
}
void CDrawAnimate::FrameFree()
{
	m_phge->Texture_Free(m_Texture);
}