#include "StdAfx.h"
#include "DrawMessage.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

CDrawMessage::CDrawMessage(const tstring &strname):hgeItemContainer(strname)
{
	m_SystemString=("");
	m_fSysXpos=0;
	m_fSysYpos=0;
	m_pSprite=NULL;
	m_ItemArray.RemoveAll();
	ZeroMemory(m_bUserSay,sizeof(m_bUserSay));
	for(BYTE i=0;i<GAME_PLAYER;i++)
	{
		m_cbSayIndex[i]=255;
	}
}

CDrawMessage::~CDrawMessage(void)
{
	if(m_pSprite)
		delete m_pSprite;
	if(m_pSysFont)
		delete m_pSysFont;
	if(m_pSayFont)
		delete m_pSayFont;
	if(m_pLeftSay)
		delete m_pLeftSay;
	if(m_pRightSay)
		delete m_pRightSay;
	if(m_pMySay)
		delete m_pMySay;
}
void CDrawMessage::Init()
{
	m_pSysFont=new GfxFont("",15);
	m_pSayFont=new GfxFont("",14);
	HTEXTURE tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexMessageBack");
	m_pSprite=new MySprite(tex,0,0,1024,42);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexMessageLeftSay");
	m_pLeftSay=new MySprite(tex,0,0,148,82);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexMessageRightSay");
	m_pRightSay=new MySprite(tex,0,0,148,82);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexMessageMySay");
	m_pMySay=new MySprite(tex,0,0,148,76);
	m_fSysXpos=1060;
	m_fSysYpos=15;

	m_ptSay[0]=hgePoint(250,100);
	m_ptSay[1]=hgePoint(10,508);
}
void CDrawMessage::Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect)
{
	for(BYTE i=0;i<m_ItemArray.GetCount();i++)
	{
		DrawTextString(m_ItemArray[i].SystemString,0xFFFFB400,m_ptBack.x+m_ItemArray[i].ptExcusion.x,
			m_ptBack.y+m_ItemArray[i].ptExcusion.y);
	}

	for(BYTE i=0;i<GAME_PLAYER;i++)
	{
		//m_bUserSay[i]=true;
		if(m_bUserSay[i])
		{
			if(i==0||i==1)
			{
				m_pMySay->Render(m_ptSay[i].x,m_ptSay[i].y);
			}
			DrawTextSay(m_UserSay[i],0xFF000000,m_ptSay[i].x+74,m_ptSay[i].y+38);
		}
	}

	m_pSprite->Render(m_ptBack.x,m_ptBack.y,bClip,clipRect);
}
void CDrawMessage::Update(DWORD dwDelTick )
{
	for(BYTE i=0;i<m_ItemArray.GetCount();i++)
	{
		m_ItemArray[i].ptExcusion.x--;
		if(m_ItemArray[i].ptExcusion.x<-GetTestLong(m_ItemArray[i].SystemString))
		{
			m_ItemArray.RemoveAt(i);
		}
	}

	for(BYTE i=0;i<GAME_PLAYER;i++)
	{
		if(m_bUserSay[i])
			m_cbSayIndex[i]++;
		if(m_cbSayIndex[i]==120)
		{
			m_cbSayIndex[i]=0;
			m_bUserSay[i]=false;
		}
	}
}
long CDrawMessage::GetTestLong(const tstring &str)
{
	return (m_pSysFont->GetPrintSize(str.c_str()).cx);
}
void CDrawMessage::DrawTextSay(const tstring &str,COLORREF crText,float nXPos,float nYPos)
{
	SIZE size=m_pSayFont->GetPrintSize(str.c_str());
	float fXPos=nXPos-size.cx/2;
	float fYPos=nYPos-size.cy/2;
	m_pSayFont->SetColor(crText);
	m_pSayFont->Print(fXPos,fYPos,str.c_str());
}
void CDrawMessage::SetSystem(const tstring &strmessage)
{
	m_SystemString=strmessage;
	tagSystemItem SystemItem;
	SystemItem.ptExcusion.x=m_fSysXpos;
	SystemItem.ptExcusion.y=m_fSysYpos;
	SystemItem.SystemString=strmessage;
	m_ItemArray.Add(SystemItem);
}
void CDrawMessage::DrawTextString(const tstring &str,COLORREF crText,float nXPos,float nYPos)
{
	m_pSysFont->SetColor(crText);
	m_pSysFont->Print(nXPos,nYPos,str.c_str());
}
void CDrawMessage::SetPoint(hgePoint point)
{
	m_ptBack=point;
}
void CDrawMessage::SetUserSay(const tstring &strsay,WORD wChairID)
{
	m_UserSay[wChairID].clear();
	if(strsay.length()>42)
	{
		for(BYTE i=0;i<strsay.length();)
		{
			if(strsay[i]<0)
			{
				i+=2;
			}
			else
			{
				i++;
			}
			if(i>=38)
			{
				if(i==38)
				{
					m_UserSay[wChairID]=strsay.substr(0,i);
					m_UserSay[wChairID]+="....";
				}
				else
				{
					m_UserSay[wChairID]=strsay.substr(0,i);
					m_UserSay[wChairID]+="...";
				}
				break;
			}
		}
	}
	else
	{
		m_UserSay[wChairID]=strsay;
	}
	//for(BYTE i=0;i<m_UserSay[wChairID].length()/15;i++)
	//{
	//	//m_UserSay[wChairID].insert((i+1)*14,"\n");
	//	if(m_UserSay[wChairID][(i+1)*14]<160)
	//	{
	//		AfxMessageBox("ӢĻ");
	//		m_UserSay[wChairID].insert((i+1)*14,"\n");
	//	}
	//	else
	//	{
	//		AfxMessageBox("");
	//		m_UserSay[wChairID].insert((i+1)*15,"\n");
	//	}
	//}
	BYTE i=0;
	for(;i<m_UserSay[wChairID].length();)
	{
		if(m_UserSay[wChairID][i]<0)
		{
			i+=2;
		}
		else
		{
			i++;
		}

		if(i>=14&&m_UserSay[wChairID].length()>i)
		{
			m_UserSay[wChairID].insert(i,"\n");
			break;
		}
	}

	for(;i<m_UserSay[wChairID].length();)
	{
		if(m_UserSay[wChairID][i]<0)
		{
			i+=2;
		}
		else
		{
			i++;
		}

		if(i>=29&&m_UserSay[wChairID].length()>i)
		{
			m_UserSay[wChairID].insert(i,"\n");
			break;
		}
	}
	m_bUserSay[wChairID]=true;
	m_cbSayIndex[wChairID]=0;
}