#include "StdAfx.h"
#include "DrawTimer.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

CDrawTimer::CDrawTimer(const tstring& strName)
:hgeItemContainer(strName)
{
	ZeroMemory(m_nTimer,sizeof(m_nTimer));
	m_bEndPlay=false;
}

CDrawTimer::~CDrawTimer(void)
{
	if(m_pSTimeBack)
		delete m_pSTimeBack;
	if(m_pNTimeBack)
		delete m_pNTimeBack;
	if(m_pSTimeNumber)
		delete m_pSTimeNumber;
	if(m_pNTimeNumber)
		delete m_pNTimeNumber;
	if(m_pMeNumber)
		delete m_pMeNumber;
}
void CDrawTimer::InitTime()
{
	HTEXTURE tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexTimeBack");
	m_pSTimeBack=new CDrawAnimate("TimeBack");
	m_pSTimeBack->InitAnimate(tex,448,56,8);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexTimeBackN");
	m_pNTimeBack=new MySprite(tex,0,0,89,90);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexTimeNumberN");
	m_pNTimeNumber=new MySprite(tex,0,0,180,28);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexTimeNumber");
	m_pSTimeNumber=new MySprite(tex,0,0,270,34);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexMeTime");
	m_pMeNumber=new MySprite(tex,0,0,460,51);
}
void CDrawTimer::Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect)
{
	//m_pSArrow->Render(m_HgeTimePoint.x,m_HgeTimePoint.y);

	for(BYTE i=0;i<GAME_PLAYER;i++)
	{
		//m_nTimer[i]=10;
		if(m_nTimer[i]!=0)
		{
			if(m_bEndPlay)
			{
				DrawMeTimer(m_HgeTimePoint.x,m_HgeTimePoint.y,m_nTimer[i]);
			}
			else
			{
				if(i==0)
				{
					m_pSTimeBack->Render(ptParentOffset,bClip,clipRect);
					DrawTimer(m_HgeTimePoint.x+28,m_HgeTimePoint.y+28,m_nTimer[i]);
				}
				else
				{
					m_pNTimeBack->Render(m_HgeTimePoint.x,m_HgeTimePoint.y);
					DrawNTimer(m_HgeTimePoint.x+53,m_HgeTimePoint.y+45,m_nTimer[i]);
				}
			}
		}
	}
}
void CDrawTimer::UpData()
{
	m_pSTimeBack->UpData();
}
void CDrawTimer::UpDataTimer(WORD wTime,WORD wChairID,bool bEndPlay)
{
	m_nTimer[wChairID]=wTime;
	m_bEndPlay=bEndPlay;
	if(!bEndPlay&&wChairID==0)
	{
		if(wTime!=0)
		{
			if(!m_pSTimeBack->IsStart())
				m_pSTimeBack->Start();
		}
		else
			m_pSTimeBack->Stop();
	}
}
void CDrawTimer::DrawTimer(float nXPos,float nYPos,WORD wTime)
{
	//ȡ
	const float nNumberHeight=m_pSTimeNumber->GetHeight();
	const float nNumberWidth=27.0f;

	//Ŀ
	LONG lNumberCount=0;
	WORD wNumberTemp=wTime;
	do
	{
		lNumberCount++;
		wNumberTemp/=10;
	} while (wNumberTemp>0L);

	//λö
	float nYDrawPos=nYPos-nNumberHeight/2;
	float nXDrawPos=nXPos+(lNumberCount*nNumberWidth)/2-nNumberWidth;

	if(wTime<10)
	{
		//λö
		nYDrawPos=nYPos-nNumberHeight/2;
		nXDrawPos=nXPos+(lNumberCount*nNumberWidth)/2-nNumberWidth+1;
	}

	//滭
	//CSize SizeTimeBack(m_pSTimeBack->GetWidth()/8,m_pSTimeBack->GetHeight());
	//m_pSTimeBack->SetTextureRect(0,0,56,56);
	//m_pSTimeBack->Render(nXPos-SizeTimeBack.cx/2-25,nYPos-SizeTimeBack.cy/2-24);

	//滭
	for (LONG i=0;i<lNumberCount;i++)
	{
		//滭
		WORD wCellNumber=wTime%10;
		m_pSTimeNumber->SetTextureRect(wCellNumber*nNumberWidth,0.0f,nNumberWidth,nNumberHeight);
		m_pSTimeNumber->Render(nXDrawPos,nYDrawPos);

		//ñ
		wTime/=10;
		nXDrawPos-=nNumberWidth;
	};

	return;
}
void CDrawTimer::DrawNTimer(float nXPos,float nYPos,WORD wTime)
{
	//ȡ
	const float nNumberHeight=m_pNTimeNumber->GetHeight();
	const float nNumberWidth=18.0f;

	//Ŀ
	LONG lNumberCount=0;
	WORD wNumberTemp=wTime;
	do
	{
		lNumberCount++;
		wNumberTemp/=10;
	} while (wNumberTemp>0L);

	//λö
	float nYDrawPos=nYPos-nNumberHeight/2;
	float nXDrawPos=nXPos+(lNumberCount*nNumberWidth)/2-nNumberWidth;

	if(wTime<10)
	{
		//λö
		nYDrawPos=nYPos-nNumberHeight/2;
		nXDrawPos=nXPos+(lNumberCount*nNumberWidth)/2-nNumberWidth+1;
	}

	//滭
	//CSize SizeTimeBack(m_pSTimeBack->GetWidth()/8,m_pSTimeBack->GetHeight());
	//m_pSTimeBack->SetTextureRect(0,0,56,56);
	//m_pSTimeBack->Render(nXPos-SizeTimeBack.cx/2-25,nYPos-SizeTimeBack.cy/2-24);

	//滭
	for (LONG i=0;i<lNumberCount;i++)
	{
		//滭
		WORD wCellNumber=wTime%10;
		m_pNTimeNumber->SetTextureRect(wCellNumber*nNumberWidth,0.0f,nNumberWidth,nNumberHeight);
		m_pNTimeNumber->Render(nXDrawPos,nYDrawPos);

		//ñ
		wTime/=10;
		nXDrawPos-=nNumberWidth;
	};
	if(lNumberCount==1)
	{
		WORD wCellNumber=wTime%10;
		m_pNTimeNumber->SetTextureRect(wCellNumber*nNumberWidth,0.0f,nNumberWidth,nNumberHeight);
		m_pNTimeNumber->Render(nXDrawPos,nYDrawPos);
	}

	return;
}
void CDrawTimer::DrawMeTimer(float nXPos,float nYPos,WORD wTime)
{
	//ȡ
	const float nNumberHeight=m_pMeNumber->GetHeight();
	const float nNumberWidth=46.0f;

	//Ŀ
	LONG lNumberCount=0;
	WORD wNumberTemp=wTime;
	do
	{
		lNumberCount++;
		wNumberTemp/=10;
	} while (wNumberTemp>0L);

	//λö
	float nYDrawPos=nYPos-nNumberHeight/2;
	float nXDrawPos=nXPos+(lNumberCount*nNumberWidth)/2-nNumberWidth;

	if(wTime<10)
	{
		//λö
		nYDrawPos=nYPos-nNumberHeight/2;
		nXDrawPos=nXPos+(lNumberCount*nNumberWidth)/2-nNumberWidth+1;
	}

	//滭
	//CSize SizeTimeBack(m_pSTimeBack->GetWidth()/8,m_pSTimeBack->GetHeight());
	//m_pSTimeBack->SetTextureRect(0,0,56,56);
	//m_pSTimeBack->Render(nXPos-SizeTimeBack.cx/2-25,nYPos-SizeTimeBack.cy/2-24);

	//滭
	for (LONG i=0;i<lNumberCount;i++)
	{
		//滭
		WORD wCellNumber=wTime%10;
		m_pMeNumber->SetTextureRect(wCellNumber*nNumberWidth,0.0f,nNumberWidth,nNumberHeight);
		m_pMeNumber->Render(nXDrawPos,nYDrawPos);

		//ñ
		wTime/=10;
		nXDrawPos-=nNumberWidth;
	};

	return;
}
void CDrawTimer::SetTimePoint(hgePoint hPoint)
{
	m_HgeTimePoint=hPoint;
	m_pSTimeBack->SetPoint(m_HgeTimePoint);
}