#include "StdAfx.h"
#include "EndPlay.h"
#include "CardFile.h"

CEndPlay::CEndPlay(const tstring &strname):
hgeItemContainer(strname)
{
	m_pBack=NULL;
	m_pDuiHua=NULL;
	m_pHaiDi=NULL;
	m_pDownBack=NULL;
	m_pShowDonw=NULL;
	m_pDuiHuaWait=NULL;
	m_pHaiDiWait=NULL;
	m_ptPlayCard=hgePoint(0,0);
	m_bUpdata=false;
	m_bCanDown=false;
	m_bShowCard=false;
	m_bDuiHua=false;
	m_cbCardData.RemoveAll();
}

CEndPlay::~CEndPlay(void)
{
	if(m_pBack)
		delete m_pBack;
	if(m_pDuiHua)
		delete m_pDuiHua;
	if(m_pHaiDi)
		delete m_pHaiDi;
	if(m_pDownBack)
		delete m_pDownBack;
	if(m_pShowDonw)
		delete m_pShowDonw;
	if(m_pDuiHuaWait)
		delete m_pDuiHuaWait;
	if(m_pHaiDiWait)
		delete m_pHaiDiWait;
}
void CEndPlay::ResealeInfo()
{
	m_ptPlayCard=hgePoint(0,0);
	m_bUpdata=false;
	m_bCanDown=false;
	m_bShowCard=false;
	m_bDuiHua=false;
	m_cbCardData.RemoveAll();
}
void CEndPlay::Init()
{
	HTEXTURE tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexPlayBack");
	m_pBack=new MySprite(tex,0,0,796,230);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexDuiHua");
	m_pDuiHua=new MySprite(tex,0,0,465,166);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexHaiDi");
	m_pHaiDi=new MySprite(tex,0,0,483,153);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexTingBack");
	m_pDownBack=new MySprite(tex,0,0,1024,85);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexClickReq");
	m_pShowDonw=new MySprite(tex,0,0,316,82);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexDuiHuaWait");
	m_pDuiHuaWait=new MySprite(tex,0,0,803,64);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexHaiDiWait");
	m_pHaiDiWait=new MySprite(tex,0,0,869,67);
}
void CEndPlay::Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect)
{
	if(m_bShowCard)
	{
		m_pBack->Render(110,250);
		if(m_bDuiHua)
			m_pDuiHua->Render(280,85);
		else
			m_pHaiDi->Render(265,105);

		BYTE cbCardData;
		float fXPos,fYPos;
		for(BYTE i=0;i<m_cbCardData.GetCount();i++)
		{
			cbCardData=m_cbCardData[i].bShow?m_cbCardData[i].cbCardData:0;
			fXPos=m_cbCardData[i].rcCard.x1;
			fYPos=m_cbCardData[i].rcCard.y1;
			if(m_cbCardData[i].bGrayed)
				g_CardResource.m_HandCardGrayed.DrawCardItem(cbCardData,fXPos,fYPos);
			else
				g_CardResource.m_HandCardWhite.DrawCardItem(cbCardData,fXPos,fYPos);
		}

		if(m_bCanDown)
		{
			m_pDownBack->Render(0,490);
			m_pShowDonw->Render(350,492);
		}
	}
	else
	{
		m_pDownBack->Render(0,340);
		if(m_bDuiHua)
			m_pDuiHuaWait->Render(90,350);
		else
			m_pHaiDiWait->Render(70,350);
	}
}
void CEndPlay::Update(DWORD dwDelTick )
{
	if(m_bShowCard)
	{
		if(m_bUpdata==true)
		{
			m_ptPlayCard.x-=50.0f;
			if(m_ptPlayCard.x<=167)
			{
				m_ptPlayCard.x=167;
				m_bUpdata=false;
				m_bCanDown=true;
			}
			SetCardPoint();
		}
	}
}
void CEndPlay::SetCardPoint()
{
	float fWidth=(float)g_CardResource.m_HandCardWhite.GetViewWidth();
	float fHeight=(float)g_CardResource.m_HandCardWhite.GetViewHeight();
	for (BYTE i=0;i<10;i++)
	{
		m_cbCardData[i].rcCard.x1=(m_ptPlayCard.x+i*(fWidth+18));
		m_cbCardData[i].rcCard.y1=m_ptPlayCard.y;
		m_cbCardData[i].rcCard.x2=m_cbCardData[i].rcCard.x1+fWidth;
		m_cbCardData[i].rcCard.y2=m_cbCardData[i].rcCard.y1+fHeight;
	}
}
void CEndPlay::SetPlayCard(bool bShowCard,bool bDuiHua,BYTE cbCardData[10])
{
	//AfxMessageBox("SetPlayCard");
	m_bShowCard=bShowCard;
	m_bDuiHua=bDuiHua;
	m_cbCardData.RemoveAll();
	tagCardInfo CardInfo;

	m_ptPlayCard.x=1024;
	m_ptPlayCard.y=325;

	float fWidth=(float)g_CardResource.m_HandCardWhite.GetViewWidth();
	float fHeight=(float)g_CardResource.m_HandCardWhite.GetViewHeight();

	for(BYTE i=0;i<10;i++)
	{
		CardInfo.cbCardData=cbCardData[i];
		CardInfo.rcCard.x1=(m_ptPlayCard.x+i*(fWidth+12));
		CardInfo.rcCard.y1=m_ptPlayCard.y;
		CardInfo.rcCard.x2=CardInfo.rcCard.x1+fWidth;
		CardInfo.rcCard.y2=CardInfo.rcCard.y1+fHeight;
		CardInfo.bShow=false;
		CardInfo.bGrayed=true;
		m_cbCardData.Add(CardInfo);
	}
}
void CEndPlay::SetShowCard(BYTE cbCardData[10])
{
	for(BYTE i=0;i<10;i++)
	{
		if(m_cbCardData[i].cbCardData==cbCardData[i])
		{
			m_cbCardData[i].bShow=true;
			m_cbCardData[i].bGrayed=false;
		}
	}

	m_ptPlayCard.x=167;
	m_bUpdata=false;
	m_bCanDown=true;
	SetCardPoint();
}
void CEndPlay::SetStart()
{
	m_bUpdata=true;
	m_bCanDown=false;
}
void CEndPlay::SetCanDown(bool bCanDown)
{
	m_bCanDown=bCanDown;
}
void CEndPlay::OnLButtonUp(UINT nFlags, const hgePoint& point)
{
	if(m_bShowCard)
	{
		if(m_bCanDown)
		{
			for(BYTE i=0;i<10;i++)
			{
				if((m_cbCardData[i].rcCard.TestPoint(point.x,point.y))&&(!m_cbCardData[i].bShow))
				{
					m_cbCardData[i].bShow=true;
					m_cbCardData[i].bGrayed=false;
					m_ShowCard(m_cbCardData[i].cbCardData);
				}
			}
		}
	}
}
void CEndPlay::Stustee()
{
	for(BYTE i=0;i<10;i++)
	{
		if(!m_cbCardData[i].bShow)
		{
			m_cbCardData[i].bShow=true;
			m_cbCardData[i].bGrayed=false;
			m_ShowCard(m_cbCardData[i].cbCardData);
			return;
		}
	}
}
void CEndPlay::SetAllShow()
{
	if(m_bShowCard)
	{
		for(BYTE i=0;i<10;i++)
		{
			m_cbCardData[i].bShow=true;
		}
	}
}