#include "stdafx.h"
#include "FrameAnimate.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

TL_FrameAnimate::TL_FrameAnimate() : m_pFrameAni(0)
{
}

const std::string TL_FrameAnimate::GetAniID( int effId ) const
{
    char buf[255] = { 0 };
    sprintf( buf, "%04d", effId );
    return buf;
}

FramesAnimate * TL_FrameAnimate::GetFramesAni()
{
    if ( !m_pFrameAni )
        m_pFrameAni = new FramesAnimate( "", "" );

    return m_pFrameAni;
}

hgeAnimateController * TL_FrameAnimate::GetFramesAnimate( hgeAnimateController * pAni, const std::string & id, const ParaList * paras )
{
    if ( !pAni )
        pAni = GetFramesAni();

    FramesAnimate * pFA = dynamic_cast<FramesAnimate *>(pAni);
    ASSERT( pFA );

    pFA->GetItemObj()->SetModulColorRed(1);
    pFA->GetItemObj()->SetModulColorGreen(1);
    pFA->GetItemObj()->SetModulColorBlue(1);
    pFA->GetItemObj()->SetAlpha(1);
    pFA->GetItemObj()->SetPosition( hgePoint(0, 0) );
    pFA->GetItemObj()->SetSize( hgePoint(0, 0) );

    // ʽ
    std::string aniName  = "ani" + id;
    
    // ֡
    size_t groupSize = hgeTextureManager::instance().GetGroupSize( aniName );

//#ifdef _DEBUG
    // жǷڶԴ
     if ( !/*hgeAnimateControllerManager::instance().GetAnimateData( aniName )*/
         hgeTextureManager::instance().GetTextureBy( aniName, 0 ) )
     {
         // ʹΪĬ
         TRACE( "KunlunFrameAniamte::GetFramesAnimate not found %s, using aniDefault\n", aniName.c_str() );
         aniName  = "aniDefault";
         groupSize = hgeTextureManager::instance().GetGroupSize( aniName );
     }
//#endif

    // ֡
    const std::string groupFmt =  aniName+ "%d";
    return hgeAnimateUtil::GetFramesAnimate( pAni, aniName, groupFmt, 0, groupSize, paras );
}

hgeAnimateController * TL_FrameAnimate::GetFramesAnimate( hgeItemBase * pRef, const std::string & id, FramesAnimate * pAni )
{
    ASSERT(pAni);
    const ParaList * paras = NULL;

    std::string aniId = id;

    // вο
    if ( pRef )
    {
        static ParaList pl;
        pl.clear();
        pl["$parent"] = util::ptr_2_str( pRef );
        pl["$aligncenter"] = "true";
        paras = &pl;

        // ǷΪppPlayerPanelSelf
        if ( pRef->GetName() == "ppPlayerPanelSelf" )
        {
            // ԼǷرӦaniXXXOwnʹô
            if ( hgeTextureManager::instance().GetTextureBy( "ani" + id + "Own", 0 ) )
            {
                aniId = id + "Own";
            }
        }
        // ǷΪppPlayerPanelOpp
        else if ( pRef->GetName() == "ppPlayerPanelOpp" )
        {
            // ǶԷǷرӦaniXXXOppʹô
            if ( hgeTextureManager::instance().GetTextureBy( "ani" + id + "Opp", 0 ) )
            {
                aniId = id + "Opp";
            }
        }
    }

    return GetFramesAnimate( pAni, aniId, paras );
}

hgeAnimateController * TL_FrameAnimate::GetFramesAnimate( const hgePoint & pos, const std::string & id, FramesAnimate * pAni )
{
    ASSERT(pAni);
    ParaList paras;

    paras["$left"] = util::num_2_str( pos.x );
    paras["$top"] = util::num_2_str( pos.y );

    return GetFramesAnimate( pAni, id, &paras );
}


SingleImageAnimate * TL_FrameAnimate::CreateSingleImageAni( const std::string & defineName, const std::string & aniName, 
                                                              const std::string & widgetName, const ParaList * pparas, bool bManaged )
{
    SingleImageAnimate * pAni = new SingleImageAnimate( widgetName );

    hgeItemImage * pImg = NULL;

    WidgetFactory::instance().createWidget( pImg, defineName );

    ASSERT( pImg );

    pAni->BindItemObj( pImg, true );

    if ( !aniName.empty() )
    {
        ParaList paras(pparas ? (*pparas) : ParaList());
        
        if ( !util::find_in_map( paras, "$obj" ) )
        {
            paras["$obj"] = util::ptr_2_str(pImg);
        }

        hgeAnimateControllerManager::instance().ApplyAnimateController( pAni, aniName, &paras );
    }

    if ( bManaged )
    {
        hgeAnimateControllerManager::instance().InsertAnimateController( pAni );
    }

    return pAni;
}




