#include "StdAfx.h"
#include "guidatamanager.h"
//#include "EmotionSetting.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

TL_GUIDataManager::TL_GUIDataManager(void): 
  _pFont( NULL )
, m_pGameResManager( NULL )
, m_pCommonResManager( NULL )
, m_pWebAddrDoc( NULL )
{
	SAFE;    
	_phge = hgeCreate(HGE_VERSION);
	UNSAFE;
}

TL_GUIDataManager::~TL_GUIDataManager(void)
{
	SAFE;   

	if(_phge)
	{
		_phge->Release();
	}
	UNSAFE;
}

TL_GUIDataManager& TL_GUIDataManager::Instance()
{
	SAFE;

	static TL_GUIDataManager Inst;
	return Inst;

	UNSAFE;
}
void TL_GUIDataManager::InitRes()
{
	SAFE;
	//@@Դ
	tstring fileName				= TheFileManager->GetDataDir() + ("Texture/Texture.cfg");

	m_pGameResManager     = new hgeResourceManager(fileName.c_str());

	_pFont					= m_pGameResManager->GetFont("fntCn1"); 

    ResHelper::addResourceManager( m_pGameResManager );

	//m_pWebAddrDoc = new TiXmlDocument();

	UNSAFE;
}
void TL_GUIDataManager::ReleaseRes()
{
	SAFE;

    if(m_pGameResManager)
    {
        delete m_pGameResManager;
        m_pGameResManager = NULL;
    }
    
	if(m_pCommonResManager)
	{
		delete m_pCommonResManager;
		m_pCommonResManager = NULL;
	}

	if( m_pWebAddrDoc )
	{
		delete m_pWebAddrDoc;
		m_pWebAddrDoc = NULL;
	}

	UNSAFE;
}

hgeResourceManager* TL_GUIDataManager::GetNewResManager()
{
	return m_pCommonResManager;
}

hgeResourceManager* TL_GUIDataManager::GetGameResManager()
{
	return  m_pGameResManager;
}
hgeFont* TL_GUIDataManager::GetHgeFont()
{
	return _pFont;
}

//@@ ַ
bool    TL_GUIDataManager::LoadWebAddress(tstring  webAddress)
{
	//tstring strAddr = TheFileManager->GetDataDir() + _T("Game/UIWebAddress.xml");
	tstring strAddr = TheFileManager->GetDataDir() + webAddress;

	int size = 0;
	void* data = _phge->OpenFileRead(strAddr.c_str(), &size);
	if(data && size)
	{
		char* p = new char[size+1];
		memcpy(p, data, size);
		p[size] = 0;

		m_pWebAddrDoc->Parse((const char*)p);

		delete[] p;

		_phge->Resource_Free(data);
		return !m_pWebAddrDoc->Error();
	}

	if( m_pWebAddrDoc )
	{
		if( !m_pWebAddrDoc->LoadFile( strAddr.c_str() ) )
		{
			ASSERT_DESC( "UIController_Login::LoadFile can't load file" );
			return false;
		}
	}

	return true;
}

tstring	TL_GUIDataManager::GetWebAddress( tstring node )
{
	TiXmlElement* element = m_pWebAddrDoc->RootElement();
	tstring strRet = "";
	if( element )
	{
		element = element->FirstChildElement();
		while( element )
		{
			const char * p = element->Attribute( node.c_str() );
			if(  p != NULL )
			{
				strRet = p ;
				break; 
			}
			else
			{
				element = element->NextSiblingElement();
			}
		}
	}

	return strRet;
}


//@@СϷԴ
void TL_GUIDataManager::InitGameRes( tstring ResFile,tstring ResFileAdd/*=_T("")*/ )
{
	//@@ϷԴ

	if(!m_pGameResManager)
		m_pGameResManager     = new hgeResourceManager(ResFile.c_str());
	else
		m_pGameResManager->AddScript( ResFile.c_str() );

	if(!ResFileAdd.empty())
	{

		m_pGameResManager->AddScript( ResFileAdd.c_str() );
	}

	   ResHelper::addResourceManager( m_pGameResManager );
}
//@@ض
void TL_GUIDataManager::LoadAniamateTextureXML( tstring ResFile )
{
	hgeTextureManager::instance().LoadCfgFile(ResFile);
}
