#include "StdAfx.h"
#include "GameLogic.h"
#include "math.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//ofstream SparrowLogic("SparrowLogicTP.log");

//////////////////////////////////////////////////////////////////////////

//̬
bool		CChiHuRight::m_bInit = false;
DWORD		CChiHuRight::m_dwRightMask[MAX_RIGHT_COUNT];

//캯
CChiHuRight::CChiHuRight()
{
	ZeroMemory( m_dwRight,sizeof(m_dwRight) );
	m_cbMingGangCount=0;
	m_cbAnGangCount=0;

	if( !m_bInit )
	{
		m_bInit = true;
		for( BYTE i = 0; i < CountArray(m_dwRightMask); i++ )
		{
			if( 0 == i )
				m_dwRightMask[i] = 0;
			else
				m_dwRightMask[i] = (DWORD(pow(2.0,i-1)))<<28;
		}
	}
}

//ֵ
CChiHuRight & CChiHuRight::operator = ( DWORD dwRight )
{
	DWORD dwOtherRight = 0;
	//֤Ȩλ
	if( !IsValidRight( dwRight ) )
	{
		//֤ȡȨλ
		ASSERT( IsValidRight( ~dwRight ) );
		if( !IsValidRight( ~dwRight ) ) return *this;
		dwRight = ~dwRight;
		dwOtherRight = MASK_CHI_HU_RIGHT;
	}

	for( BYTE i = 0; i < CountArray(m_dwRightMask); i++ )
	{
		if( (dwRight&m_dwRightMask[i]) || (i==0&&dwRight<0x10000000) )
			m_dwRight[i] = dwRight&MASK_CHI_HU_RIGHT;
		else m_dwRight[i] = dwOtherRight;
	}

	return *this;
}

//
CChiHuRight & CChiHuRight::operator &= ( DWORD dwRight )
{
	bool bNavigate = false;
	//֤Ȩλ
	if( !IsValidRight( dwRight ) )
	{
		//֤ȡȨλ
		ASSERT( IsValidRight( ~dwRight ) );
		if( !IsValidRight( ~dwRight ) ) return *this;
		//Ȩλ
		DWORD dwHeadRight = (~dwRight)&0xF0000000;
		DWORD dwTailRight = dwRight&MASK_CHI_HU_RIGHT;
		dwRight = dwHeadRight|dwTailRight;
		bNavigate = true;
	}

	for( BYTE i = 0; i < CountArray(m_dwRightMask); i++ )
	{
		if( (dwRight&m_dwRightMask[i]) || (i==0&&dwRight<0x10000000) )
		{
			m_dwRight[i] &= (dwRight&MASK_CHI_HU_RIGHT);
		}
		else if( !bNavigate )
			m_dwRight[i] = 0;
	}

	return *this;
}

//
CChiHuRight & CChiHuRight::operator |= ( DWORD dwRight )
{
	//֤Ȩλ
	if( !IsValidRight( dwRight ) ) return *this;

	for( BYTE i = 0; i < CountArray(m_dwRightMask); i++ )
	{
		if( (dwRight&m_dwRightMask[i]) || (i==0&&dwRight<0x10000000) )
		{
			m_dwRight[i] |= (dwRight&MASK_CHI_HU_RIGHT);
			break;
		}
	}

	return *this;
}

//
CChiHuRight CChiHuRight::operator & ( DWORD dwRight )
{
	CChiHuRight chr = *this;
	return (chr &= dwRight);
}

//
CChiHuRight CChiHuRight::operator & ( DWORD dwRight ) const
{
	CChiHuRight chr = *this;
	return (chr &= dwRight);
}

//
CChiHuRight CChiHuRight::operator | ( DWORD dwRight )
{
	CChiHuRight chr = *this;
	return chr |= dwRight;
}

//
CChiHuRight CChiHuRight::operator | ( DWORD dwRight ) const
{
	CChiHuRight chr = *this;
	return chr |= dwRight;
}

//
bool CChiHuRight::operator == ( DWORD dwRight ) const
{
	CChiHuRight chr;
	chr = dwRight;
	return (*this)==chr;
}

//
bool CChiHuRight::operator == ( const CChiHuRight chr ) const
{
	for( WORD i = 0; i < CountArray( m_dwRight ); i++ )
	{
		if( m_dwRight[i] != chr.m_dwRight[i] ) return false;
	}
	return true;
}

//
bool CChiHuRight::operator != ( DWORD dwRight ) const
{
	CChiHuRight chr;
	chr = dwRight;
	return (*this)!=chr;
}

//
bool CChiHuRight::operator != ( const CChiHuRight chr ) const
{
	return !((*this)==chr);
}

//ǷȨλΪ
bool CChiHuRight::IsEmpty()
{
	for( BYTE i = 0; i < CountArray(m_dwRight); i++ )
		if( m_dwRight[i] ) return false;
	return true;
}

//ȨλΪ
void CChiHuRight::SetEmpty()
{
	ZeroMemory( m_dwRight,sizeof(m_dwRight) );
	return;
}

//ȡȨλֵ
BYTE CChiHuRight::GetRightData( DWORD dwRight[], BYTE cbMaxCount )
{
	ASSERT( cbMaxCount >= CountArray(m_dwRight) );
	if( cbMaxCount < CountArray(m_dwRight) ) return 0;

	CopyMemory( dwRight,m_dwRight,sizeof(DWORD)*CountArray(m_dwRight) );
	return CountArray(m_dwRight);
}

//Ȩλֵ
bool CChiHuRight::SetRightData( const DWORD dwRight[], BYTE cbRightCount )
{
	ASSERT( cbRightCount <= CountArray(m_dwRight) );
	if( cbRightCount > CountArray(m_dwRight) ) return false;

	ZeroMemory( m_dwRight,sizeof(m_dwRight) );
	CopyMemory( m_dwRight,dwRight,sizeof(DWORD)*cbRightCount );
	
	return true;
}

//λǷȷ
bool CChiHuRight::IsValidRight( DWORD dwRight )
{
	DWORD dwRightHead = dwRight & 0xF0000000;
	for( BYTE i = 0; i < CountArray(m_dwRightMask); i++ )
		if( m_dwRightMask[i] == dwRightHead ) return true;
	return false;
}

//////////////////////////////////////////////////////////////////////////

//̬

//˿   Ͳ з 
const BYTE CGameLogic::m_cbCardDataArray[MAX_REPERTORY]=
{
	0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,						//
	0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,						//
	0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,						//
	0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,						//
	0x31,0x32,0x33,0x34,0x35,0x36,0x37,						      		//
	0x31,0x32,0x33,0x34,0x35,0x36,0x37,								    //
	0x31,0x32,0x33,0x34,0x35,0x36,0x37,                     			//
	0x31,0x32,0x33,0x34,0x35,0x36,0x37,									//
	0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f								//ﶬ÷
};

//////////////////////////////////////////////////////////////////////////

//캯
CGameLogic::CGameLogic()
{
	m_cbMagicIndex = MAX_INDEX;
}

//
CGameLogic::~CGameLogic()
{
}

//˿
void CGameLogic::RandCardData(BYTE cbCardData[], BYTE cbMaxCount)
{
	//׼
	BYTE cbCardDataTemp[CountArray(m_cbCardDataArray)];
	CopyMemory(cbCardDataTemp,m_cbCardDataArray,sizeof(m_cbCardDataArray));

	//˿
	BYTE cbRandCount=0,cbPosition=0;
	do
	{
		cbPosition=rand()%(cbMaxCount-cbRandCount);
		cbCardData[cbRandCount++]=cbCardDataTemp[cbPosition];
		cbCardDataTemp[cbPosition]=cbCardDataTemp[cbMaxCount-cbRandCount];
	} while (cbRandCount<cbMaxCount);

	return;
}

//˿
void CGameLogic::RandCardData(const BYTE cbCardData[], BYTE cbCardCount, BYTE cbRandData[])
{
	if( cbCardCount == 0 ) return;

	//׼
	BYTE cbCardDataTemp[MAX_COUNT];
	CopyMemory(cbCardDataTemp,cbCardData,sizeof(BYTE)*cbCardCount);

	//˿
	BYTE cbRandCount=0,cbPosition=0;
	do
	{
		cbPosition=rand()%(cbCardCount-cbRandCount);
		cbRandData[cbRandCount++]=cbCardDataTemp[cbPosition];
		cbCardDataTemp[cbPosition]=cbCardDataTemp[cbCardCount-cbRandCount];
	} while (cbRandCount<cbCardCount);

	return;
}

//ɾ˿
bool CGameLogic::RemoveCard(BYTE cbCardIndex[MAX_INDEX], BYTE cbRemoveCard)
{
	//Ч˿
	ASSERT(IsValidCard(cbRemoveCard));
	ASSERT(cbCardIndex[SwitchToCardIndex(cbRemoveCard)]>0);

	//ɾ˿
	BYTE cbRemoveIndex=SwitchToCardIndex(cbRemoveCard);
	if (cbCardIndex[cbRemoveIndex]>0)
	{
		cbCardIndex[cbRemoveIndex]--;
		return true;
	}

	//ʧЧ
	ASSERT(FALSE);

	return false;
}

//ɾ˿
bool CGameLogic::RemoveCard(BYTE cbCardIndex[MAX_INDEX], const BYTE cbRemoveCard[], BYTE cbRemoveCount)
{
	//ɾ˿
	for (BYTE i=0;i<cbRemoveCount;i++)
	{
		//Ч˿
		ASSERT(IsValidCard(cbRemoveCard[i]));
		ASSERT(cbCardIndex[SwitchToCardIndex(cbRemoveCard[i])]>0);

		//ɾ˿
		BYTE cbRemoveIndex=SwitchToCardIndex(cbRemoveCard[i]);
		if (cbCardIndex[cbRemoveIndex]==0)
		{
			//
			ASSERT(FALSE);

			//ԭɾ
			for (BYTE j=0;j<i;j++) 
			{
				ASSERT(IsValidCard(cbRemoveCard[j]));
				cbCardIndex[SwitchToCardIndex(cbRemoveCard[j])]++;
			}

			return false;
		}
		else 
		{
			//ɾ˿
			--cbCardIndex[cbRemoveIndex];
		}
	}

	return true;
}

//ɾ˿
bool CGameLogic::RemoveCard(BYTE cbCardData[], BYTE cbCardCount, const BYTE cbRemoveCard[], BYTE cbRemoveCount)
{
	//
	ASSERT(cbCardCount<=MAX_COUNT);
	ASSERT(cbRemoveCount<=cbCardCount);

	//
	BYTE cbDeleteCount=0,cbTempCardData[MAX_COUNT];
	if (cbCardCount>CountArray(cbTempCardData))
		return false;
	CopyMemory(cbTempCardData,cbCardData,cbCardCount*sizeof(cbCardData[0]));

	//˿
	for (BYTE i=0;i<cbRemoveCount;i++)
	{
		for (BYTE j=0;j<cbCardCount;j++)
		{
			if (cbRemoveCard[i]==cbTempCardData[j])
			{
				cbDeleteCount++;
				cbTempCardData[j]=0;
				break;
			}
		}
	}

	//ɹж
	if (cbDeleteCount!=cbRemoveCount) 
	{
		ASSERT(FALSE);
		return false;
	}

	//˿
	BYTE cbCardPos=0;
	for (BYTE i=0;i<cbCardCount;i++)
	{
		if (cbTempCardData[i]!=0) 
			cbCardData[cbCardPos++]=cbTempCardData[i];
	}

	return true;
}
//
bool CGameLogic::IsMagicCard( BYTE cbCardData )
{
	if( m_cbMagicIndex != MAX_INDEX )
		return SwitchToCardIndex(cbCardData) == m_cbMagicIndex;
	return false;
}
//Чж
bool CGameLogic::IsValidCard(BYTE cbCardData)
{
	BYTE cbValue=(cbCardData&MASK_VALUE);
	BYTE cbColor=(cbCardData&MASK_COLOR)>>4;
	return (((cbValue>=1)&&(cbValue<=9)&&(cbColor<=2))||((cbValue>=1)&&(cbValue<=0x0f)&&(cbColor==3)));
}

//˿Ŀ
BYTE CGameLogic::GetCardCount(const BYTE cbCardIndex[MAX_INDEX])
{
	//Ŀͳ
	BYTE cbCardCount=0;
	for (BYTE i=0;i<MAX_INDEX;i++) 
		cbCardCount+=cbCardIndex[i];

	return cbCardCount;
}

//ȡ
BYTE CGameLogic::GetWeaveCard(DWORD cbWeaveKind, BYTE cbCenterCard, BYTE cbCardBuffer[4])
{
	//˿
	switch (cbWeaveKind)
	{
	case WIK_LEFT:		//Ʋ
	case WIK_LEFT_LISTEN:
		{
			//ñ
			cbCardBuffer[0]=cbCenterCard;
			cbCardBuffer[1]=cbCenterCard+1;
			cbCardBuffer[2]=cbCenterCard+2;

			return 3;
		}
	case WIK_RIGHT:		//Ʋ
	case WIK_RIGHT_LISTEN:
		{
			//ñ
			cbCardBuffer[0]=cbCenterCard-2;
			cbCardBuffer[1]=cbCenterCard-1;
			cbCardBuffer[2]=cbCenterCard;

			return 3;
		}
	case WIK_CENTER:	//Ʋ
	case WIK_CENTER_LISTEN:
		{
			//ñ
			cbCardBuffer[0]=cbCenterCard-1;
			cbCardBuffer[1]=cbCenterCard;
			cbCardBuffer[2]=cbCenterCard+1;

			return 3;
		}
	case WIK_PENG:		//Ʋ
	case WIK_PENG_LISTEN:
		{
			//ñ
			cbCardBuffer[0]=cbCenterCard;
			cbCardBuffer[1]=cbCenterCard;
			cbCardBuffer[2]=cbCenterCard;

			return 3;
		}
	case WIK_GANG:		//Ʋ
		{
			//ñ
			cbCardBuffer[0]=cbCenterCard;
			cbCardBuffer[1]=cbCenterCard;
			cbCardBuffer[2]=cbCenterCard;
			cbCardBuffer[3]=cbCenterCard;

			return 4;
		}
	default:
		{
			ASSERT(FALSE);
		}
	}

	return 0;
}

//ȼ
BYTE CGameLogic::GetUserActionRank(BYTE cbUserAction)
{
	//Ƶȼ
	if (cbUserAction&WIK_CHI_HU) { return 5; }

	//ȼ
	if (cbUserAction&(WIK_LEFT_LISTEN|WIK_CENTER_LISTEN|WIK_RIGHT_LISTEN|WIK_PENG_LISTEN)) { return 4; }

	//Ƶȼ
	if (cbUserAction&WIK_GANG) { return 3; }

	//Ƶȼ
	if (cbUserAction&WIK_PENG) { return 2; }

	//Ƶȼ
	if (cbUserAction&(WIK_RIGHT|WIK_CENTER|WIK_LEFT)) { return 1; }

	return 0;
}

//Ƶȼ
WORD CGameLogic::GetChiHuActionRank(const CChiHuRight & ChiHuRight,const CChiHuRight & ChiHuHigh,
									const CChiHuRight & ChiHuNew,BYTE cbCardData)
{
	WORD wFanShu = 0;

//	SparrowLogic<<"GetChiHuActionRank"<<endl;
//	SparrowLogic<<"cbCardData"<<(WORD)cbCardData<<endl;
	//
	if( !(ChiHuRight&CHR_ZI_MO).IsEmpty())
	{
		wFanShu += 1;
//		SparrowLogic<<"CHR_ZI_MO"<<endl;
	}
	if( !(ChiHuRight&CHR_YI_BAN_GAO).IsEmpty())
	{
		wFanShu +=1;
//		SparrowLogic<<"CHR_YI_BAN_GAO"<<endl;
	}
	if( !(ChiHuRight&CHR_LIAN_6).IsEmpty())
	{
		wFanShu +=1;
//		SparrowLogic<<"CHR_LIAN_6"<<endl;
	}
	if( !(ChiHuRight&CHR_LAO_SHAO_F).IsEmpty())
	{
		wFanShu +=1;
//		SparrowLogic<<"CHR_LAO_SHAO_F"<<endl;
	}
	if( !(ChiHuRight&CHR_DAN_DIAO).IsEmpty())
	{
		wFanShu +=1;
//		SparrowLogic<<"CHR_DAN_DIAO"<<endl;
	}
	if( !(ChiHuRight&CHR_YAO_JIU_KE).IsEmpty())
	{
		wFanShu +=1;
//		SparrowLogic<<"CHR_YAO_JIU_KE"<<endl;
	}
	if( !(ChiHuRight&CHR_TING_CARD).IsEmpty())
	{
		wFanShu +=1;
//		SparrowLogic<<"CHR_TING_CARD"<<endl;
	}
	if(!(ChiHuNew&CHR_BIAN_ZHANG).IsEmpty())
	{
		wFanShu +=1;
//		SparrowLogic<<"CHR_BIAN_ZHANG"<<endl;
	}
	if(!(ChiHuNew&CHR_KAN_ZHANG).IsEmpty())
	{
		wFanShu +=1;
//		SparrowLogic<<"CHR_KAN_ZHANG"<<endl;
	}
	//
	if( !(ChiHuRight&CHR_MING_GANG).IsEmpty())
	{
		wFanShu += (1 * ChiHuRight.m_cbMingGangCount);
//		SparrowLogic<<"CHR_MING_GANG"<<endl;
	}
	//
	if( !(ChiHuRight&CHR_AN_GANG).IsEmpty())
	{
		wFanShu += (2 * ChiHuRight.m_cbAnGangCount);
//		SparrowLogic<<"CHR_AN_GANG"<<endl;
	}
	if( !(ChiHuRight&CHR_MEN_QI_QING).IsEmpty())
	{
		wFanShu +=2;
//		SparrowLogic<<"CHR_MEN_QI_QING"<<endl;
	}
	if( !(ChiHuRight&CHR_DOUBLE_ANKE).IsEmpty())
	{
		wFanShu +=2;
//		SparrowLogic<<"CHR_DOUBLE_ANKE"<<endl;
	}
	if( !(ChiHuRight&CHR_DUAN_YAOJIU).IsEmpty())
	{
		wFanShu +=2;
//		SparrowLogic<<"CHR_DUAN_YAOJIU"<<endl;
	}
	if( !(ChiHuRight&CHR_PING_HE).IsEmpty())
	{
		wFanShu +=2;
//		SparrowLogic<<"CHR_PING_HE"<<endl;
	}
	if( !(ChiHuRight&CHR_JIAN_KE).IsEmpty())
	{
		wFanShu +=2;
//		SparrowLogic<<"CHR_JIAN_KE"<<endl;
	}
	if( !(ChiHuRight&CHR_LI_ZHI).IsEmpty())
	{
		wFanShu +=2;
//		SparrowLogic<<"CHR_LI_ZHI"<<endl;
	}
	if( !(ChiHuRight&CHR_QUAN_DAI_YAO).IsEmpty())
	{
		wFanShu+=4;
//		SparrowLogic<<"CHR_QUAN_DAI_YAO"<<endl;
	}
	if( !(ChiHuRight&CHR_MENQING_ZIMO).IsEmpty())
	{
		wFanShu+=4;
//		SparrowLogic<<"CHR_MENQING_ZIMO"<<endl;
	}
	if( !(ChiHuRight&CHR_JUE_ZHANG).IsEmpty())
	{
		wFanShu+=4;
//		SparrowLogic<<"CHR_JUE_ZHANG"<<endl;
	}
	if( !(ChiHuRight&CHR_DOUBLE_JIAN_KE).IsEmpty())
	{
		wFanShu+=6;
//		SparrowLogic<<"CHR_DOUBLE_JIAN_KE"<<endl;
	}
	if( !(ChiHuRight&CHR_HUN_YI_SE).IsEmpty())
	{
		wFanShu+=6;
//		SparrowLogic<<"CHR_HUN_YI_SE"<<endl;
	}
	if( !(ChiHuRight&CHR_SI_GUI_YI).IsEmpty())
	{
		wFanShu+=2;
//		SparrowLogic<<"CHR_SI_GUI_YI"<<endl;
	}
	if( !(ChiHuRight&CHR_QUAN_QIU).IsEmpty())
	{
		wFanShu+=6;
//		SparrowLogic<<"CHR_QUAN_QIU"<<endl;
	}
	if( !(ChiHuRight&CHR_PENG_PENG).IsEmpty())
	{
		wFanShu+=6;
//		SparrowLogic<<"CHR_PENG_PENG"<<endl;
	}
	if( !(ChiHuRight&CHR_MIAO_SHOU).IsEmpty())
	{
		wFanShu+=8;
//		SparrowLogic<<"CHR_MIAO_SHOU"<<endl;
	}
	if( !(ChiHuRight&CHR_HAI_DI).IsEmpty())
	{
		wFanShu+=8;
//		SparrowLogic<<"CHR_HAI_DI"<<endl;
	}
	if( !(ChiHuRight&CHR_GANG_KAI).IsEmpty())
	{
		wFanShu+=8;
//		SparrowLogic<<"CHR_GANG_KAI"<<endl;
	}
	if( !(ChiHuRight&CHR_QIANG_GANG).IsEmpty())
	{
		wFanShu+=8;
//		SparrowLogic<<"CHR_QIANG_GANG"<<endl;
	}
	if( !(ChiHuHigh&CHR_SAN_FENG_KE).IsEmpty())
	{
		wFanShu+=12;
//		SparrowLogic<<"CHR_SAN_FENG_KE"<<endl;
	}
	if( !(ChiHuHigh&CHR_THREE_ANKE).IsEmpty())
	{
		wFanShu+=16;
//		SparrowLogic<<"CHR_THREE_ANKE"<<endl;
	}
	if( !(ChiHuHigh&CHR_QING_LONG).IsEmpty())
	{
		wFanShu+=16;
//		SparrowLogic<<"CHR_QING_LONG"<<endl;
	}
	if( !(ChiHuHigh&CHR_YISE_SANBU).IsEmpty())
	{
		wFanShu+=16;
//		SparrowLogic<<"CHR_YISE_SANBU"<<endl;
	}

	if( !(ChiHuHigh&CHR_QI_DUI).IsEmpty())
	{
		wFanShu+=24;
//		SparrowLogic<<"CHR_QI_DUI"<<endl;
	}
	if( !(ChiHuHigh&CHR_QING_YI_SE).IsEmpty())
	{
		wFanShu+=24;
//		SparrowLogic<<"CHR_QING_YI_SE"<<endl;
	}
	if( !(ChiHuHigh&CHR_YISE_SANTONG).IsEmpty())
	{
		wFanShu+=24;
//		SparrowLogic<<"CHR_YISE_SANTONG"<<endl;
	}
	if( !(ChiHuHigh&CHR_YISE_SIBU).IsEmpty())
	{
		wFanShu+=32;
//		SparrowLogic<<"CHR_YISE_SIBU"<<endl;
	}
	if( !(ChiHuHigh&CHR_QING_LAOTOU).IsEmpty())
	{
		wFanShu+=32;
//		SparrowLogic<<"CHR_QING_LAOTOU"<<endl;
	}
	if( !(ChiHuHigh&CHR_LONG_QI_DUI).IsEmpty())
	{
		wFanShu+=32;
//		SparrowLogic<<"CHR_LONG_QI_DUI"<<endl;
	}
	if( !(ChiHuHigh&CHR_YISE_SITONG).IsEmpty())
	{
		wFanShu+=48;
//		SparrowLogic<<"CHR_YISE_SITONG"<<endl;
	}
	if( !(ChiHuHigh&CHR_YISE_SIJIE).IsEmpty())
	{
		wFanShu+=48;
//		SparrowLogic<<"CHR_YISE_SIJIE"<<endl;
	}

	if( !(ChiHuHigh&CHR_XIAO_SI_XI).IsEmpty())
	{
		wFanShu+=64;
//		SparrowLogic<<"CHR_XIAO_SI_XI"<<endl;
	}
	if( !(ChiHuHigh&CHR_XIAO_SAN_YUAN).IsEmpty())
	{
		wFanShu+=64;
//		SparrowLogic<<"CHR_XIAO_SAN_YUAN"<<endl;
	}
	if( !(ChiHuHigh&CHR_ZI_YI_SE).IsEmpty())
	{
		wFanShu+=64;
//		SparrowLogic<<"CHR_ZI_YI_SE"<<endl;
	}
	if( !(ChiHuHigh&CHR_SI_AN_KE).IsEmpty())
	{
		wFanShu+=64;
//		SparrowLogic<<"CHR_SI_AN_KE"<<endl;
	}
	if( !(ChiHuHigh&CHR_YISE_SHUANG_LONG).IsEmpty())
	{
		wFanShu+=64;
//		SparrowLogic<<"CHR_YISE_SHUANG_LONG"<<endl;
	}
	if( !(ChiHuHigh&CHR_TIAN_HU).IsEmpty())
	{
		wFanShu+=64;
//		SparrowLogic<<"CHR_TIAN_HU"<<endl;
	}
	if( !(ChiHuHigh&CHR_DI_HU).IsEmpty())
	{
		wFanShu+=64;
//		SparrowLogic<<"CHR_DI_HU"<<endl;
	}
	if( !(ChiHuHigh&CHR_DA_SI_XI).IsEmpty())
	{
		wFanShu+=88;
//		SparrowLogic<<"CHR_DA_SI_XI"<<endl;
	}
	if( !(ChiHuHigh&CHR_DA_SAN_YUAN).IsEmpty())
	{
		wFanShu+=88;
//		SparrowLogic<<"CHR_DA_SAN_YUAN"<<endl;
	}
	if( !(ChiHuHigh&CHR_JIU_LIAN).IsEmpty())
	{
		wFanShu+=88;
//		SparrowLogic<<"CHR_JIU_LIAN"<<endl;
	}
	if( !(ChiHuHigh&CHR_SHI_BA).IsEmpty())
	{
		wFanShu+=88;
//		SparrowLogic<<"CHR_SHI_BA"<<endl;
	}
	if( !(ChiHuHigh&CHR_LIAN_QI_DUI).IsEmpty())
	{
		wFanShu+=88;
//		SparrowLogic<<"CHR_LIAN_QI_DUI"<<endl;
	}
	if( !(ChiHuHigh&CHR_DA_5).IsEmpty())
	{
		wFanShu+=88;
//		SparrowLogic<<"CHR_DA_5"<<endl;
	}
	if( !(ChiHuHigh&CHR_XIAO_5).IsEmpty())
	{
		wFanShu+=88;
//		SparrowLogic<<"CHR_XIAO_5"<<endl;
	}
   
	return wFanShu;
}

//ж
DWORD CGameLogic::EstimateEatCard(const BYTE cbCardIndex[MAX_INDEX], BYTE cbCurrentCard, const tagWeaveItem WeaveItem[], BYTE cbWeaveCount,WORD wProvideUser)
{
	//Ч
	ASSERT(IsValidCard(cbCurrentCard));

	//ж
	if ( cbCurrentCard>=0x31 ) 
		return WIK_NULL;

	//
	BYTE cbExcursion[3]={0,1,2};
	DWORD cbItemKind[3]={WIK_LEFT,WIK_CENTER,WIK_RIGHT};

	//ж
	BYTE cbEatKind=0,cbFirstIndex=0;
	BYTE cbCurrentIndex=SwitchToCardIndex(cbCurrentCard);
	for (BYTE i=0;i<CountArray(cbItemKind);i++)
	{
		BYTE cbValueIndex=cbCurrentIndex%9;
		if ((cbValueIndex>=cbExcursion[i])&&((cbValueIndex-cbExcursion[i])<=6))
		{
			//ж
			cbFirstIndex=cbCurrentIndex-cbExcursion[i];

			if ((cbCurrentIndex!=cbFirstIndex)&&(cbCardIndex[cbFirstIndex]==0))
				continue;
			if ((cbCurrentIndex!=(cbFirstIndex+1))&&(cbCardIndex[cbFirstIndex+1]==0))
				continue;
			if ((cbCurrentIndex!=(cbFirstIndex+2))&&(cbCardIndex[cbFirstIndex+2]==0))
				continue;

			//
			cbEatKind|=cbItemKind[i];
		}
	}

	//Ƿ
	if( cbEatKind != WIK_NULL )
	{
		BYTE cbCardIndexTemp[MAX_INDEX];
		tagWeaveItem wi[4];
		CopyMemory( wi,WeaveItem,sizeof(tagWeaveItem)*cbWeaveCount );
		DWORD wListenKind[3] = {WIK_LEFT_LISTEN,WIK_CENTER_LISTEN,WIK_RIGHT_LISTEN};
		for( BYTE i = 0; i < CountArray(cbItemKind); i++ )
		{
			if( cbEatKind & cbItemKind[i] )
			{
				CopyMemory( cbCardIndexTemp,cbCardIndex,sizeof(cbCardIndexTemp) );
				cbCardIndexTemp[SwitchToCardIndex(cbCurrentCard)]++;
				BYTE cbCardData[3];
				GetWeaveCard( cbItemKind[i],cbCurrentCard,cbCardData );
				RemoveCard( cbCardIndexTemp,cbCardData,3 );
				wi[cbWeaveCount].cbCenterCard = cbCurrentCard;
				wi[cbWeaveCount].cbWeaveKind = cbItemKind[i];
				CopyMemory(wi[cbWeaveCount].cbCardData,cbCardData,sizeof(cbCardData));
				if( WIK_NULL != AnalyseTingCard(cbCardIndexTemp,wi,cbWeaveCount+1) )
					cbEatKind |= wListenKind[i];
			}
		}
	}

	return cbEatKind;
}

//ж
DWORD CGameLogic::EstimatePengCard(const BYTE cbCardIndex[MAX_INDEX], BYTE cbCurrentCard,const tagWeaveItem WeaveItem[], BYTE cbWeaveCount,WORD wProvideUser)
{
	//Ч
	ASSERT(IsValidCard(cbCurrentCard));

	BYTE wAction = WIK_NULL;

	//ж
	if( cbCardIndex[SwitchToCardIndex(cbCurrentCard)]>=2 ) wAction = WIK_PENG;

	//Ƿ
	if( wAction != WIK_NULL )
	{
		BYTE cbCardIndexTemp[MAX_INDEX];
		CopyMemory( cbCardIndexTemp,cbCardIndex,sizeof(cbCardIndexTemp) );
		cbCardIndexTemp[SwitchToCardIndex(cbCurrentCard)] -= 2;
		tagWeaveItem wi[4];
		CopyMemory( wi,WeaveItem,sizeof(tagWeaveItem)*cbWeaveCount );
		wi[cbWeaveCount].cbCenterCard = cbCurrentCard;
		wi[cbWeaveCount].cbWeaveKind = WIK_PENG;
		BYTE cbCardData[3];
		GetWeaveCard( WIK_PENG,cbCurrentCard,cbCardData );
		CopyMemory(wi[cbWeaveCount].cbCardData,cbCardData,sizeof(cbCardData));
		if( WIK_NULL != AnalyseTingCard(cbCardIndexTemp,wi,cbWeaveCount+1) )
			wAction |= WIK_PENG_LISTEN;
	}

	return wAction;
}
//Ʒ
BYTE CGameLogic::AnalyseTingCard(BYTE cbCardIndex[MAX_INDEX], tagWeaveItem WeaveItem[], BYTE cbItemCount)
{
	//
	CChiHuRight ChiHuResult;
	ZeroMemory(&ChiHuResult,sizeof(ChiHuResult));
	CChiHuRight ChiHuHigh;
	ZeroMemory(&ChiHuHigh,sizeof(ChiHuHigh));
	CChiHuRight ChiHuNew;
	ZeroMemory(&ChiHuNew,sizeof(ChiHuNew));

	//˿
	BYTE cbCardIndexTemp[MAX_INDEX];
	CopyMemory(cbCardIndexTemp,cbCardIndex,sizeof(cbCardIndexTemp));

	//Ʒ
	for (BYTE i=0;i<MAX_INDEX;i++)
	{
		//ƹ
		if (cbCardIndexTemp[i]==0)
			continue;

		//ƴ
		cbCardIndexTemp[i]--;

		//ж
		for (BYTE j=0;j<MAX_INDEX;j++)
		{
			//Ʒ
			BYTE cbCurrentCard=SwitchToCardData(j);
			BYTE cbHuCardKind=AnalyseChiHuCard(cbCardIndexTemp,WeaveItem,cbItemCount,cbCurrentCard,ChiHuResult,ChiHuHigh,
				ChiHuNew);

			//ж
			if (cbHuCardKind!=WIK_NULL) 
				return WIK_LISTEN;
		}

		//ԭ
		cbCardIndexTemp[i]++;
	}

	return WIK_NULL;
}

//ж
BYTE CGameLogic::EstimateGangCard(const BYTE cbCardIndex[MAX_INDEX], BYTE cbCurrentCard,const tagWeaveItem WeaveItem[], BYTE cbWeaveCount,WORD wProvideUser)
{
	//Ч
	ASSERT(IsValidCard(cbCurrentCard));

	//ж
	return (cbCardIndex[SwitchToCardIndex(cbCurrentCard)]==3)?WIK_GANG:WIK_NULL;
}

//Ʒ
BYTE CGameLogic::AnalyseGangCard(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[], BYTE cbWeaveCount, tagGangCardResult & GangCardResult)
{
	//ñ
	BYTE cbActionMask=WIK_NULL;
	ZeroMemory(&GangCardResult,sizeof(GangCardResult));

		//ϸ
	for (BYTE i=0;i<MAX_INDEX;i++)
	{
		if (cbCardIndex[i]==4)
		{
			cbActionMask|=WIK_GANG;
			GangCardResult.cbCardData[GangCardResult.cbCardCount++]=SwitchToCardData(i);
		}
	}

	//ϸ
	for (BYTE i=0;i<cbWeaveCount;i++)
	{
		if (WeaveItem[i].cbWeaveKind==WIK_PENG)
		{
			if (cbCardIndex[SwitchToCardIndex(WeaveItem[i].cbCenterCard)]==1)
			{
				cbActionMask|=WIK_GANG;
				GangCardResult.cbCardData[GangCardResult.cbCardCount++]=WeaveItem[i].cbCenterCard;
			}
		}
	}

	return cbActionMask;
}

//Ժ
BYTE CGameLogic::AnalyseChiHuCard(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[], BYTE cbWeaveCount,
								  BYTE cbCurrentCard, CChiHuRight &ChiHuRight,CChiHuRight &ChiHuHigh,CChiHuRight &ChiHuNew)
{
	//
	BYTE cbChiHuKind=WIK_NULL;
	CAnalyseItemArray AnalyseItemArray;

	//ñ
	AnalyseItemArray.RemoveAll();
	ChiHuRight.SetEmpty();
	ChiHuHigh.SetEmpty();
	ChiHuNew.SetEmpty();

	//˿
	BYTE cbCardIndexTemp[MAX_INDEX];
	CopyMemory(cbCardIndexTemp,cbCardIndex,sizeof(cbCardIndexTemp));

	//cbCurrentCardһΪ0			!!!!!!!!!
	ASSERT( cbCurrentCard != 0 );
	if( cbCurrentCard == 0 ) return WIK_NULL;

	//˿
	if (cbCurrentCard!=0)
		cbCardIndexTemp[SwitchToCardIndex(cbCurrentCard)]++;

	if(IsQiXiaoDui(cbCardIndex,WeaveItem,cbWeaveCount,cbCurrentCard))
		ChiHuHigh |= CHR_QI_DUI;

	//˿
	AnalyseCard(cbCardIndexTemp,WeaveItem,cbWeaveCount,AnalyseItemArray);

	BYTE cbCardEye=MAX_INDEX;
	//Ʒ
	if (AnalyseItemArray.GetCount()>0)
	{
		//ͷ
		for (INT_PTR i=0;i<AnalyseItemArray.GetCount();i++)
		{
			//
			tagAnalyseItem * pAnalyseItem=&AnalyseItemArray[i];

			//
			if( IsPengPeng(pAnalyseItem) ) 
				ChiHuRight |= CHR_PENG_PENG;
			else
				ChiHuRight |= CHR_PING_HU;	
			cbCardEye=pAnalyseItem->cbCardEye;

			if(IsQingLaoTou(pAnalyseItem))
				ChiHuHigh |=CHR_QING_LAOTOU;
		}
		//
		if( (ChiHuRight.m_cbAnGangCount=CalcAnGang(WeaveItem,cbWeaveCount))>0 )
			ChiHuRight |= CHR_AN_GANG;
		//
		if( (ChiHuRight.m_cbMingGangCount=CalcMingGang(WeaveItem,cbWeaveCount))>0 )
			ChiHuRight |= CHR_MING_GANG;
	}

	if( !ChiHuRight.IsEmpty() )
		cbChiHuKind = WIK_CHI_HU;
	if( !ChiHuHigh.IsEmpty())
		cbChiHuKind = WIK_CHI_HU;

	if( cbChiHuKind == WIK_CHI_HU )
	{
		bool bXManGuan=false,bDManGuan=false;
		if(IsDaSiXi(cbCardIndexTemp,WeaveItem,cbWeaveCount))
		{
			ChiHuHigh |=CHR_DA_SI_XI;
			bDManGuan=true;
		}
		if(IsDaSanYuan(cbCardIndexTemp,WeaveItem,cbWeaveCount))
		{
			ChiHuHigh |=CHR_DA_SAN_YUAN;
			bDManGuan=true;
		}
		if(IsJiuLian(cbCardIndex,WeaveItem,cbWeaveCount))
		{
			ChiHuHigh |=CHR_JIU_LIAN;
			bDManGuan=true;
		}
		if(IsShiBa(WeaveItem,cbWeaveCount))
		{
			ChiHuHigh |=CHR_SHI_BA;
			bDManGuan=true;
		}
		if(IsLianQiDui(cbCardIndex,WeaveItem,cbWeaveCount,cbCurrentCard))
		{
			ChiHuHigh |=CHR_LIAN_QI_DUI;
			bDManGuan=true;
		}
		if(IsDaYu5(cbCardIndexTemp,WeaveItem,cbWeaveCount))
		{
			ChiHuHigh |=CHR_DA_5;
			bDManGuan=true;
		}
		if(IsXiaoYu5(cbCardIndexTemp,WeaveItem,cbWeaveCount))
		{
			ChiHuHigh |=CHR_XIAO_5;
			bDManGuan=true;
		}
		if(!bDManGuan)
		{
			if(IsXiaoSiXi(cbCardIndexTemp,WeaveItem,cbWeaveCount,cbCardEye))
			{
				ChiHuHigh |=CHR_XIAO_SI_XI;
				bXManGuan=true;
			}
			if(IsXiaoSanYuan(cbCardIndexTemp,WeaveItem,cbWeaveCount,cbCardEye))
			{
				ChiHuHigh |=CHR_XIAO_SAN_YUAN;
				bXManGuan=true;
			}
			if(IsZiYiSe(cbCardIndexTemp,WeaveItem,cbWeaveCount))
			{
				ChiHuHigh |=CHR_ZI_YI_SE;
				bXManGuan=true;
			}
			if(IsSiAnKe(cbCardIndexTemp,WeaveItem,cbWeaveCount,cbCurrentCard,false))
			{
				ChiHuHigh |=CHR_SI_AN_KE;
				bXManGuan=true;
			}
			if(IsYiSeShuangLong(cbCardIndexTemp,WeaveItem,cbWeaveCount,cbCardEye))
			{
				ChiHuHigh |=CHR_YISE_SHUANG_LONG;
				bXManGuan=true;
			}
		}
		if(!bXManGuan&&!bDManGuan)
		{
			if(IsYiBanGao(cbCardIndexTemp,WeaveItem,cbWeaveCount))
				ChiHuRight |= CHR_YI_BAN_GAO;
			if(IsLian6(cbCardIndexTemp,WeaveItem,cbWeaveCount))
				ChiHuRight |= CHR_LIAN_6;
			if(IsLaoShaoF(cbCardIndexTemp,WeaveItem,cbWeaveCount))
				ChiHuRight |= CHR_LAO_SHAO_F;
			if(cbWeaveCount==MAX_WEAVE)
				ChiHuRight |= CHR_QUAN_QIU;
			if(IsMenQianQing(WeaveItem,cbWeaveCount))
				ChiHuRight |= CHR_MEN_QI_QING;
			if(IsDoubleAnKe(cbCardIndexTemp,WeaveItem,cbWeaveCount,cbCurrentCard,false))
				ChiHuRight |= CHR_DOUBLE_ANKE;
			if(IsDuanYaoJiu(cbCardIndexTemp,WeaveItem,cbWeaveCount))
				ChiHuRight |= CHR_DUAN_YAOJIU;
			if(IsPingHe(cbCardIndexTemp,WeaveItem,cbWeaveCount))
				ChiHuRight |= CHR_PING_HE;
			if(IsQuanDaiYao(cbCardIndexTemp,WeaveItem,cbWeaveCount))
				ChiHuRight |= CHR_QUAN_DAI_YAO;
			if(IsYaoJiuKe(cbCardIndexTemp,WeaveItem,cbWeaveCount,cbCardEye))
				ChiHuRight |= CHR_YAO_JIU_KE;
			if(IsDoubleJianKe(cbCardIndexTemp,WeaveItem,cbWeaveCount,cbCardEye))
				ChiHuRight |= CHR_DOUBLE_JIAN_KE;
			else if(IsJianKe(cbCardIndexTemp,WeaveItem,cbWeaveCount,cbCardEye))
				ChiHuRight |= CHR_JIAN_KE;
			if(IsSiGuiYi(cbCardIndexTemp,WeaveItem,cbWeaveCount))
				ChiHuRight |= CHR_SI_GUI_YI;
			if(cbCardEye==cbCurrentCard)
				ChiHuRight |= CHR_DAN_DIAO;
			if(IsSanFengKe(cbCardIndexTemp,WeaveItem,cbWeaveCount,cbCardEye))
				ChiHuHigh |= CHR_SAN_FENG_KE;
			if(IsThreeAnKe(cbCardIndexTemp,WeaveItem,cbWeaveCount,cbCurrentCard,false))
				ChiHuHigh |= CHR_THREE_ANKE;
			if(IsQingLong(cbCardIndex,WeaveItem,cbWeaveCount,cbCurrentCard))
				ChiHuHigh |= CHR_QING_LONG;
			if(IsYiSeSanBu(cbCardIndexTemp,WeaveItem,cbWeaveCount))
				ChiHuHigh |= CHR_YISE_SANBU;
			if(IsQingYiSe(cbCardIndex,WeaveItem,cbWeaveCount,cbCurrentCard))
				ChiHuHigh  |= CHR_QING_YI_SE;
			else
				ChiHuRight  |= CHR_HUN_YI_SE;
			if(IsYiSeSiBu(cbCardIndexTemp,WeaveItem,cbWeaveCount))
				ChiHuHigh  |= CHR_YISE_SIBU;
			if(IsYiSeSanTong(cbCardIndexTemp,WeaveItem,cbWeaveCount))
				ChiHuHigh  |= CHR_YISE_SANTONG;
			if(IsLongQiDui(cbCardIndex,WeaveItem,cbWeaveCount,cbCurrentCard))
				ChiHuHigh  |= CHR_LONG_QI_DUI;
			if(IsYiSeSiTong(cbCardIndexTemp,WeaveItem,cbWeaveCount))
				ChiHuHigh  |= CHR_YISE_SITONG;
			if(IsYiSeSiJie(cbCardIndexTemp,WeaveItem,cbWeaveCount))
				ChiHuHigh  |= CHR_YISE_SIJIE;
			if(IsBianZhang(cbCardIndexTemp,WeaveItem,cbWeaveCount,cbCardEye,cbCurrentCard))
				ChiHuNew   |= CHR_BIAN_ZHANG;
			if(IsChunQuanDaiYao(cbCardIndexTemp,WeaveItem,cbWeaveCount))
				ChiHuHigh  |=CHR_CHUN_QUAN_DAI_YI;
		}
	}

	return cbChiHuKind;
}


//˿ת
BYTE CGameLogic::SwitchToCardData(BYTE cbCardIndex)
{
	ASSERT(cbCardIndex<MAX_INDEX);
	if( cbCardIndex < 27 )
		return ((cbCardIndex/9)<<4)|(cbCardIndex%9+1);
	else return (0x30|(cbCardIndex-27+1));
}

//˿ת
BYTE CGameLogic::SwitchToCardIndex(BYTE cbCardData)
{
	ASSERT(IsValidCard(cbCardData));
	return ((cbCardData&MASK_COLOR)>>4)*9+(cbCardData&MASK_VALUE)-1;
}

//˿ת
BYTE CGameLogic::SwitchToCardData(const BYTE cbCardIndex[MAX_INDEX], BYTE cbCardData[MAX_COUNT])
{
	//ת˿
	BYTE cbPosition=0;
	for (BYTE i=0;i<MAX_INDEX;i++)
	{
		if( i == INDEX_REPLACE_CARD ) continue;
		if (cbCardIndex[i]!=0)
		{
			for (BYTE j=0;j<cbCardIndex[i];j++)
			{
				ASSERT(cbPosition<MAX_COUNT);
				cbCardData[cbPosition++]=SwitchToCardData(i);
			}
		}
	}

	return cbPosition;
}

//˿ת
BYTE CGameLogic::SwitchToCardIndex(const BYTE cbCardData[], BYTE cbCardCount, BYTE cbCardIndex[MAX_INDEX])
{
	//ñ
	ZeroMemory(cbCardIndex,sizeof(BYTE)*MAX_INDEX);

	//ת˿
	for (BYTE i=0;i<cbCardCount;i++)
	{
		ASSERT(IsValidCard(cbCardData[i]));
		cbCardIndex[SwitchToCardIndex(cbCardData[i])]++;
	}

	return cbCardCount;
}

//˿
bool CGameLogic::AnalyseCard(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[], BYTE cbWeaveCount, CAnalyseItemArray & AnalyseItemArray)
{
	//Ŀ
	BYTE cbCardCount=GetCardCount(cbCardIndex);

	//ЧĿ
	ASSERT((cbCardCount>=2)&&(cbCardCount<=MAX_COUNT)&&((cbCardCount-2)%3==0));
	if ((cbCardCount<2)||(cbCardCount>MAX_COUNT)||((cbCardCount-2)%3!=0))
		return false;

	//
	BYTE cbKindItemCount=0;
	tagKindItem KindItem[27*2+28];
	ZeroMemory(KindItem,sizeof(KindItem));

	//ж
	BYTE cbLessKindItem=(cbCardCount-2)/3;
	ASSERT((cbLessKindItem+cbWeaveCount)==MAX_WEAVE);

	//ж
	if (cbLessKindItem==0)
	{
		//Ч
		ASSERT((cbCardCount==2)&&(cbWeaveCount==MAX_WEAVE));

		//ж
		for (BYTE i=0;i<MAX_INDEX;i++)
		{
			if (cbCardIndex[i]==2 || 
				( m_cbMagicIndex != MAX_INDEX && i != m_cbMagicIndex && cbCardIndex[m_cbMagicIndex]+cbCardIndex[i]==2 ) )
			{
				//
				tagAnalyseItem AnalyseItem;
				ZeroMemory(&AnalyseItem,sizeof(AnalyseItem));

				//ý
				for (BYTE j=0;j<cbWeaveCount;j++)
				{
					AnalyseItem.cbWeaveKind[j]=WeaveItem[j].cbWeaveKind;
					AnalyseItem.cbCenterCard[j]=WeaveItem[j].cbCenterCard;
					CopyMemory( AnalyseItem.cbCardData[j],WeaveItem[j].cbCardData,sizeof(WeaveItem[j].cbCardData) );
				}
				AnalyseItem.cbCardEye=SwitchToCardData(i);
				if( cbCardIndex[i] == 2)
					AnalyseItem.bMagicEye = false;
				else 
					AnalyseItem.bMagicEye = true;

				//
				AnalyseItemArray.Add(AnalyseItem);

				return true;
			}
		}

		return false;
	}

	//ַ
	BYTE cbMagicCardIndex[MAX_INDEX];
	CopyMemory(cbMagicCardIndex,cbCardIndex,sizeof(cbMagicCardIndex));
	//в
	BYTE cbMagicCardCount = 0;
	if( m_cbMagicIndex != MAX_INDEX )
	{
		cbMagicCardCount = cbCardIndex[m_cbMagicIndex];
		//дƣת
		if( INDEX_REPLACE_CARD != MAX_INDEX )
		{
			cbMagicCardIndex[m_cbMagicIndex] = cbMagicCardIndex[INDEX_REPLACE_CARD];
			cbMagicCardIndex[INDEX_REPLACE_CARD] = cbMagicCardCount;
		}
	}
	if (cbCardCount>=3)
	{
		for (BYTE i=0;i<MAX_INDEX;i++)
		{
			//ͬж
			//ǲ,ҲС3,򲻽
			if( cbMagicCardIndex[i] >= 3 || ( cbMagicCardIndex[i]+cbMagicCardCount >= 3 &&
				( ( INDEX_REPLACE_CARD!=MAX_INDEX && i != INDEX_REPLACE_CARD ) || ( INDEX_REPLACE_CARD==MAX_INDEX && i != m_cbMagicIndex ) ) )
				)
			{
				int nTempIndex = cbMagicCardIndex[i];
				do
				{
					ASSERT( cbKindItemCount < CountArray(KindItem) );
					BYTE cbIndex = i;
					BYTE cbCenterCard = SwitchToCardData(i);
					//ǲҲд,򻻳ɴ
					if( i == m_cbMagicIndex && INDEX_REPLACE_CARD != MAX_INDEX )
					{
						cbIndex = INDEX_REPLACE_CARD;
						cbCenterCard = SwitchToCardData(INDEX_REPLACE_CARD);
					}
					KindItem[cbKindItemCount].cbWeaveKind=WIK_PENG;
					KindItem[cbKindItemCount].cbCenterCard=cbCenterCard;
					KindItem[cbKindItemCount].cbValidIndex[0] = nTempIndex>0?cbIndex:m_cbMagicIndex;
					KindItem[cbKindItemCount].cbValidIndex[1] = nTempIndex>1?cbIndex:m_cbMagicIndex;
					KindItem[cbKindItemCount].cbValidIndex[2] = nTempIndex>2?cbIndex:m_cbMagicIndex;
					cbKindItemCount++;

					//ǲ,˳
					if( i == INDEX_REPLACE_CARD || (i == m_cbMagicIndex && INDEX_REPLACE_CARD == MAX_INDEX) )
						break;

					nTempIndex -= 3;
					//պôȫ˳
					if( nTempIndex == 0 ) break;

				}while( nTempIndex+cbMagicCardCount >= 3 );
			}

			//ж
			if ((i<(MAX_INDEX-17))&&((i%9)<7))
			{
				//ֻҪ3˳ڵ3,
				if( cbMagicCardCount+cbMagicCardIndex[i]+cbMagicCardIndex[i+1]+cbMagicCardIndex[i+2] >= 3 )
				{
					BYTE cbIndex[3] = { cbMagicCardIndex[i],cbMagicCardIndex[i+1],cbMagicCardIndex[i+2] };
					int nMagicCountTemp = cbMagicCardCount;
					BYTE cbValidIndex[3];
					while( nMagicCountTemp+cbIndex[0]+cbIndex[1]+cbIndex[2] >= 3 )
					{
						for( BYTE j = 0; j < CountArray(cbIndex); j++ )
						{
							if( cbIndex[j] > 0 ) 
							{
								cbIndex[j]--;
								cbValidIndex[j] = (i+j==m_cbMagicIndex&&INDEX_REPLACE_CARD!=MAX_INDEX)?INDEX_REPLACE_CARD:i+j;
							}
							else 
							{
								nMagicCountTemp--;
								cbValidIndex[j] = m_cbMagicIndex;
							}
						}
						if( nMagicCountTemp >= 0 )
						{
							ASSERT( cbKindItemCount < CountArray(KindItem) );
							KindItem[cbKindItemCount].cbWeaveKind=WIK_LEFT;
							KindItem[cbKindItemCount].cbCenterCard=SwitchToCardData(i);
							CopyMemory( KindItem[cbKindItemCount].cbValidIndex,cbValidIndex,sizeof(cbValidIndex) );
							cbKindItemCount++;
						}
						else break;
					}
				}
			}
		}
	}

	//Ϸ
	if (cbKindItemCount>=cbLessKindItem)
	{
		//
		BYTE cbCardIndexTemp[MAX_INDEX];
		ZeroMemory(cbCardIndexTemp,sizeof(cbCardIndexTemp));

		//
		BYTE cbIndex[MAX_WEAVE];
		for( BYTE i = 0; i < CountArray(cbIndex); i++ )
			cbIndex[i] = i;
		tagKindItem * pKindItem[MAX_WEAVE];
		ZeroMemory(&pKindItem,sizeof(pKindItem));
		tagKindItem KindItemTemp[CountArray(KindItem)];
		if( m_cbMagicIndex != MAX_INDEX )
			CopyMemory( KindItemTemp,KindItem,sizeof(KindItem) );

		//ʼ
		do
		{
			//ñ
			CopyMemory(cbCardIndexTemp,cbCardIndex,sizeof(cbCardIndexTemp));
			cbMagicCardCount = 0;
			if( m_cbMagicIndex != MAX_INDEX )
			{
				CopyMemory( KindItem,KindItemTemp,sizeof(KindItem) );
			}

			for (BYTE i=0;i<cbLessKindItem;i++)
				pKindItem[i]=&KindItem[cbIndex[i]];

			//ж
			bool bEnoughCard=true;

			for (BYTE i=0;i<cbLessKindItem*3;i++)
			{
				//ж
				BYTE cbCardIndex=pKindItem[i/3]->cbValidIndex[i%3]; 
				if (cbCardIndexTemp[cbCardIndex]==0)
				{
					if( m_cbMagicIndex != MAX_INDEX && cbCardIndexTemp[m_cbMagicIndex] > 0 )
					{
						cbCardIndexTemp[m_cbMagicIndex]--;
						pKindItem[i/3]->cbValidIndex[i%3] = m_cbMagicIndex;
					}
					else
					{
						bEnoughCard=false;
						break;
					}
				}
				else cbCardIndexTemp[cbCardIndex]--;
			}

			//ж
			if (bEnoughCard==true)
			{
				//ж
				BYTE cbCardEye=0;
				bool bMagicEye = false;
				if( GetCardCount(cbCardIndexTemp) == 2 )
				{
					for (BYTE i=0;i<MAX_INDEX;i++)
					{
						if (cbCardIndexTemp[i]==2)
						{
							cbCardEye=SwitchToCardData(i);
							if( m_cbMagicIndex != MAX_INDEX && i == m_cbMagicIndex ) bMagicEye = true;
							break;
						}
						else if( i!=m_cbMagicIndex && 
							m_cbMagicIndex != MAX_INDEX && cbCardIndexTemp[i]+cbCardIndexTemp[m_cbMagicIndex]==2 )
						{
							cbCardEye = SwitchToCardData(i);
							bMagicEye = true;
						}
					}
				}

				//
				if (cbCardEye!=0)
				{
					//
					tagAnalyseItem AnalyseItem;
					ZeroMemory(&AnalyseItem,sizeof(AnalyseItem));

					//
					for (BYTE i=0;i<cbWeaveCount;i++)
					{
						AnalyseItem.cbWeaveKind[i]=WeaveItem[i].cbWeaveKind;
						AnalyseItem.cbCenterCard[i]=WeaveItem[i].cbCenterCard;
						GetWeaveCard( WeaveItem[i].cbWeaveKind,WeaveItem[i].cbCenterCard,AnalyseItem.cbCardData[i] );
					}

					//
					for (BYTE i=0;i<cbLessKindItem;i++) 
					{
						AnalyseItem.cbWeaveKind[i+cbWeaveCount]=pKindItem[i]->cbWeaveKind;
						AnalyseItem.cbCenterCard[i+cbWeaveCount]=pKindItem[i]->cbCenterCard;
						AnalyseItem.cbCardData[cbWeaveCount+i][0] = SwitchToCardData(pKindItem[i]->cbValidIndex[0]);
						AnalyseItem.cbCardData[cbWeaveCount+i][1] = SwitchToCardData(pKindItem[i]->cbValidIndex[1]);
						AnalyseItem.cbCardData[cbWeaveCount+i][2] = SwitchToCardData(pKindItem[i]->cbValidIndex[2]);
					}

					//
					AnalyseItem.cbCardEye=cbCardEye;
					AnalyseItem.bMagicEye = bMagicEye;

					//
					AnalyseItemArray.Add(AnalyseItem);
				}
			}

			//
			if (cbIndex[cbLessKindItem-1]==(cbKindItemCount-1))
			{
				BYTE i=cbLessKindItem-1;
				for (;i>0;i--)
				{
					if ((cbIndex[i-1]+1)!=cbIndex[i])
					{
						BYTE cbNewIndex=cbIndex[i-1];
						for (BYTE j=(i-1);j<cbLessKindItem;j++) 
							cbIndex[j]=cbNewIndex+j-i+2;
						break;
					}
				}
				if (i==0)
					break;
			}
			else
				cbIndex[cbLessKindItem-1]++;
		} while (true);

	}

	return (AnalyseItemArray.GetCount()>0);
}


//,ֵ
bool CGameLogic::SortCardList( BYTE cbCardData[MAX_COUNT], BYTE cbCardCount )
{
	//Ŀ
	if (cbCardCount==0||cbCardCount>MAX_COUNT) return false;

	//
	bool bSorted=true;
	BYTE cbSwitchData=0,cbLast=cbCardCount-1;
	do
	{
		bSorted=true;
		for (BYTE i=0;i<cbLast;i++)
		{
			if (cbCardData[i]>cbCardData[i+1])
			{
				//ñ־
				bSorted=false;

				//˿
				cbSwitchData=cbCardData[i];
				cbCardData[i]=cbCardData[i+1];
				cbCardData[i+1]=cbSwitchData;
			}	
		}
		cbLast--;
	} while(bSorted==false);

	return true;
}
bool CGameLogic::SortCardList(BYTE cbCardData[MAX_COUNT], BYTE cbCardCount,bool bSort)
{
	if(cbCardCount==0||cbCardCount>MAX_COUNT) return false;

	if(bSort)
	{
		//AfxMessageBox("С");
		//
		bool bSorted=true;
		BYTE cbSwitchData=0,cbLast=cbCardCount-1;
		do
		{
			bSorted=true;
			for (BYTE i=0;i<cbLast;i++)
			{
				if (cbCardData[i]>cbCardData[i+1])
				{
					//ñ־
					bSorted=false;

					//˿
					cbSwitchData=cbCardData[i];
					cbCardData[i]=cbCardData[i+1];
					cbCardData[i+1]=cbSwitchData;
				}	
			}
			cbLast--;
		} while(bSorted==false);
	}
	else
	{
		//AfxMessageBox("С");
		//
		bool bSorted=true;
		BYTE cbSwitchData=0,cbLast=cbCardCount-1;
		do
		{
			bSorted=true;
			for (BYTE i=0;i<cbLast;i++)
			{
				if ((cbCardData[i]+SwitchCard(cbCardData[i]))<(cbCardData[i+1]+SwitchCard(cbCardData[i+1])))

				{
					//ñ־
					bSorted=false;

					//˿
					cbSwitchData=cbCardData[i];
					cbCardData[i]=cbCardData[i+1];
					cbCardData[i+1]=cbSwitchData;
				}	
			}
			cbLast--;
		} while(bSorted==false);
	}

	return true;
}
BYTE CGameLogic::SwitchCard(BYTE cbCardData)
{
	if(cbCardData>=0x01&&cbCardData<=0x09)
	{
		return 0x80;
	}
	else if(cbCardData>=0x11&&cbCardData<=0x19)
	{
		return 0x50;
	}
	else if(cbCardData>=0x21&&cbCardData<=0x29)
	{
		return 0x20;
	}

	return 0x00;
}

/*
// 
*/
//
BYTE CGameLogic::CalcMingGang( const tagWeaveItem WeaveItem[], BYTE cbWeaveCount)
{
	BYTE cbMingGangCount=0;
	for( BYTE i = 0; i < cbWeaveCount; i++ )
	{
		if( WeaveItem[i].cbWeaveKind==WIK_GANG && WeaveItem[i].cbPublicCard==TRUE)
			cbMingGangCount++;
	}
	return cbMingGangCount;
}

//
BYTE CGameLogic::CalcAnGang( const tagWeaveItem WeaveItem[], BYTE cbWeaveCount )
{
	BYTE cbAnGangCount=0;
	for( BYTE i = 0; i < cbWeaveCount; i++ )
	{
		if( WeaveItem[i].cbWeaveKind == WIK_GANG && !WeaveItem[i].cbPublicCard )
			cbAnGangCount++;
	}
	return cbAnGangCount;
}

//////////////////////////////////////////////////////////////////////////
//һ
bool CGameLogic::IsYiBanGao(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount)
{
	CAnalyseItemArray AnalyseItemArray;
	AnalyseItemArray.RemoveAll();

	AnalyseCard(cbCardIndex,WeaveItem,cbWeaveCount,AnalyseItemArray);

	if(AnalyseItemArray.GetCount()>0)
	{
		for(INT_PTR i=0;i<AnalyseItemArray.GetCount();i++)
		{
			tagAnalyseItem * pAnalyseItem=&AnalyseItemArray[i];


			for(BYTE j=0;j<MAX_WEAVE;j++)
			{
				if(pAnalyseItem->cbWeaveKind[j]&(WIK_LEFT|WIK_RIGHT|WIK_CENTER|
					WIK_LEFT_LISTEN|WIK_CENTER_LISTEN|WIK_RIGHT_LISTEN))
				{
					BYTE cbCardBufferI[3];
					GetWeaveCard(pAnalyseItem->cbWeaveKind[j],pAnalyseItem->cbCenterCard[j],cbCardBufferI);
					BYTE temp=0;
					for (BYTE z=0;z<MAX_WEAVE;z++)
					{
						if(pAnalyseItem->cbWeaveKind[z]&(WIK_LEFT|WIK_RIGHT|WIK_CENTER|
							WIK_LEFT_LISTEN|WIK_CENTER_LISTEN|WIK_RIGHT_LISTEN))
						{
							BYTE cbCardBufferZ[3];
							GetWeaveCard(pAnalyseItem->cbWeaveKind[z],pAnalyseItem->cbCenterCard[z],cbCardBufferZ);
							if(cbCardBufferI[1]==cbCardBufferZ[1])
							{
								temp++;
							}
						}
					}
					if(temp==2)
					{
						return true;
					}
				}
			}
		}
	}

	return false;
}
//6
bool CGameLogic::IsLian6(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount)
{
	CAnalyseItemArray AnalyseItemArray;
	AnalyseItemArray.RemoveAll();

	AnalyseCard(cbCardIndex,WeaveItem,cbWeaveCount,AnalyseItemArray);

	if(AnalyseItemArray.GetCount()>0)
	{
		for(INT_PTR i=0;i<AnalyseItemArray.GetCount();i++)
		{
			tagAnalyseItem * pAnalyseItem=&AnalyseItemArray[i];
			for(BYTE j=0;j<MAX_WEAVE;j++)
			{
				if(pAnalyseItem->cbWeaveKind[j]&(WIK_LEFT|WIK_RIGHT|WIK_CENTER|
					WIK_LEFT_LISTEN|WIK_CENTER_LISTEN|WIK_RIGHT_LISTEN))
				{
					for (BYTE z=0;z<MAX_WEAVE;z++)
					{
						if(pAnalyseItem->cbWeaveKind[z]&(WIK_LEFT|WIK_RIGHT|WIK_CENTER|
							WIK_LEFT_LISTEN|WIK_CENTER_LISTEN|WIK_RIGHT_LISTEN))
						{
							if((pAnalyseItem->cbCardData[z][2]-pAnalyseItem->cbCardData[j][2])==3)
							{
								return true;
							}
						}
					}
				}
			}
		}
	}

	return false;
}
//ٸ
bool CGameLogic::IsLaoShaoF(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount)
{
	CAnalyseItemArray AnalyseItemArray;
	AnalyseItemArray.RemoveAll();

	AnalyseCard(cbCardIndex,WeaveItem,cbWeaveCount,AnalyseItemArray);

	if(AnalyseItemArray.GetCount()>0)
	{
		for(INT_PTR i=0;i<AnalyseItemArray.GetCount();i++)
		{
			bool bShao=false,bLao=false;
			tagAnalyseItem * pAnalyseItem=&AnalyseItemArray[i];
			for(BYTE j=0;j<MAX_WEAVE;j++)
			{
				if(pAnalyseItem->cbWeaveKind[j]&(WIK_LEFT|WIK_RIGHT|WIK_CENTER|
					WIK_LEFT_LISTEN|WIK_CENTER_LISTEN|WIK_RIGHT_LISTEN))
				{
					if(pAnalyseItem->cbCardData[j][0]==0x01)
						bShao=true;
					if(pAnalyseItem->cbCardData[j][2]==0x09)
						bLao=true;
				}
			}
			if(bLao&&bShao)
				return true;
		}
	}

	return false;
}
//ǰ
bool CGameLogic::IsMenQianQing( const tagWeaveItem WeaveItem[], BYTE cbWeaveCount )
{
	for( BYTE i = 0; i < cbWeaveCount; i++ )
	{
		if( WeaveItem[i].cbWeaveKind != WIK_GANG || WeaveItem[i].cbPublicCard )
			return false;
	}
	return true;
}
//˫
bool CGameLogic::IsDoubleAnKe(const BYTE cbCardIndex[MAX_INDEX],const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount,
							  BYTE cbCurrentCard,bool bZiMo)
{
	CAnalyseItemArray AnalyseItemArray;
	AnalyseItemArray.RemoveAll();

	AnalyseCard(cbCardIndex,WeaveItem,cbWeaveCount,AnalyseItemArray);

	if(AnalyseItemArray.GetCount()>0)
	{
		for(INT_PTR i=0;i<AnalyseItemArray.GetCount();i++)
		{
			tagAnalyseItem * pAnalyseItem=&AnalyseItemArray[i];
			BYTE temp=0;
			//ѳϲ
			for( BYTE j = cbWeaveCount; j < CountArray(pAnalyseItem->cbWeaveKind); j++ )
			{
				if(pAnalyseItem->cbWeaveKind[j]&(WIK_PENG|WIK_PENG_LISTEN))
				{
					if(bZiMo)
					{
						temp++;
					}
					else
					{
						if(pAnalyseItem->cbCenterCard[j]!=cbCurrentCard)
						{
							temp++;
						}
					}
				}
			}
			if(temp==2)
				return true;
		}
	}

	return false;
}
//۾
bool CGameLogic::IsDuanYaoJiu(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount)
{
	if(cbCardIndex[0]>0)
		return false;
	if(cbCardIndex[8]>0)
		return false;
	for(BYTE i=27;i<MAX_INDEX;i++)
	{
		if(cbCardIndex[i]>0)
			return false;
	}

	for(BYTE i=0;i<cbWeaveCount;i++)
	{
		for(BYTE j=0;j<4;j++)
		{
			if(WeaveItem[i].cbCardData[j]==0x01||WeaveItem[i].cbCardData[j]==0x09)
				return false;
			if(WeaveItem[i].cbCardData[j]>0x30)
				return false;
		}
	}

	return true;
}
//ƽ
bool CGameLogic::IsPingHe(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount)
{
	CAnalyseItemArray AnalyseItemArray;
	AnalyseItemArray.RemoveAll();

	AnalyseCard(cbCardIndex,WeaveItem,cbWeaveCount,AnalyseItemArray);

	if(AnalyseItemArray.GetCount()>0)
	{
		for(INT_PTR i=0;i<AnalyseItemArray.GetCount();i++)
		{
			tagAnalyseItem * pAnalyseItem=&AnalyseItemArray[i];
			BYTE cbtemp=0;
			if(pAnalyseItem->cbCardEye>0x09)
				return false;
			for(BYTE j=0;j<MAX_WEAVE;j++)
			{
				if(pAnalyseItem->cbWeaveKind[j]&(WIK_LEFT|WIK_CENTER|WIK_RIGHT|
					WIK_LEFT_LISTEN|WIK_CENTER_LISTEN|WIK_RIGHT_LISTEN))
				{
					cbtemp++;
				}
			}
			if(cbtemp==4)
				return true;
		}
	}

	return false;
}
//ȫ
bool CGameLogic::IsQuanDaiYao(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount)
{
	CAnalyseItemArray AnalyseItemArray;
	AnalyseItemArray.RemoveAll();

	AnalyseCard(cbCardIndex,WeaveItem,cbWeaveCount,AnalyseItemArray);

	if(AnalyseItemArray.GetCount()>0)
	{
		for(INT_PTR i=0;i<AnalyseItemArray.GetCount();i++)
		{
			tagAnalyseItem * pAnalyseItem=&AnalyseItemArray[i];
			BYTE cbTemp=0;
			if(pAnalyseItem->cbCardEye==0x01||pAnalyseItem->cbCardEye==0x09||
				pAnalyseItem->cbCardEye>0x30)
				cbTemp++;
			for(BYTE j=0;j<MAX_WEAVE;j++)
			{
				for(BYTE z=0;z<4;z++)
				{
					if(pAnalyseItem->cbCardData[j][z]==0x01||pAnalyseItem->cbCardData[j][z]==0x09||
						pAnalyseItem->cbCardData[j][z]>0x30)
					{
						cbTemp++;
						break;
					}
				}
			}
			if(cbTemp==5)
				return true;
		}
	}

	return false;
}
//۾ſ
bool CGameLogic::IsYaoJiuKe(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount,BYTE cbCardEye)
{
	if(cbCardEye==MAX_INDEX)
		return false;
	for(BYTE i=0;i<cbWeaveCount;i++)
	{
		if(WeaveItem[i].cbWeaveKind&(WIK_PENG|WIK_GANG))
		{
			if(WeaveItem[i].cbCenterCard==0x01||WeaveItem[i].cbCenterCard==0x09)
				return true;
		}
	}

	BYTE Index=SwitchToCardIndex(cbCardEye);
	if(cbCardIndex[0]==3&&Index!=0)
		return true;
	if(cbCardIndex[8]==3&&Index!=8)
		return true;

	return false;
}
//
bool CGameLogic::IsJianKe(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount,BYTE cbCardEye)
{
	if(cbCardEye==MAX_INDEX)
		return false;
	for(BYTE i=0;i<cbWeaveCount;i++)
	{
		if(WeaveItem[i].cbWeaveKind&(WIK_PENG|WIK_GANG|WIK_PENG_LISTEN))
		{
			if(WeaveItem[i].cbCenterCard>0x34&&WeaveItem[i].cbCenterCard<0x38)
			{
				return true;
			}
		}
	}

	BYTE Index=SwitchToCardIndex(cbCardEye);
	for(BYTE i=31;i<34;i++)
	{
		if(cbCardIndex[i]==3&&Index!=i)
			return true;
	}
	return false;
}
//˫
bool CGameLogic::IsDoubleJianKe(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount,BYTE cbCardEye)
{
	if(cbCardEye==MAX_INDEX)
		return false;
	BYTE temp=0;
	for(BYTE i=0;i<cbWeaveCount;i++)
	{
		if(WeaveItem[i].cbWeaveKind&(WIK_PENG|WIK_GANG|WIK_PENG_LISTEN))
		{
			if(WeaveItem[i].cbCenterCard>0x34&&WeaveItem[i].cbCenterCard<0x38)
			{
				temp++;
			}
		}
	}

	BYTE Index=SwitchToCardIndex(cbCardEye);
	for(BYTE i=31;i<34;i++)
	{
		if(cbCardIndex[i]==3&&Index!=i)
			temp++;
	}

	if(temp==2)
		return true;

	return false;
}
//Ĺһ
bool CGameLogic::IsSiGuiYi(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount)
{
	//˿
	BYTE cbCardIndexTemp[MAX_INDEX];
	CopyMemory(cbCardIndexTemp,cbCardIndex,sizeof(cbCardIndexTemp));
	for(BYTE i=0;i<cbWeaveCount;i++)
	{
		if(WeaveItem[i].cbWeaveKind!=WIK_GANG)
		{
			for(BYTE j=0;j<3;j++)
			{
				cbCardIndexTemp[SwitchToCardIndex(WeaveItem[i].cbCardData[j])]++;
			}
		}
	}

	for(BYTE i=0;i<MAX_INDEX;i++)
	{
		if(cbCardIndexTemp[i]==4)
		{
			return true;
		}
	}

	return false;
}
//
bool CGameLogic::IsPengPeng( const tagAnalyseItem *pAnalyseItem )
{
	for( BYTE i = 0; i < CountArray(pAnalyseItem->cbWeaveKind); i++ )
	{
		if( pAnalyseItem->cbWeaveKind[i]&(WIK_LEFT|WIK_CENTER|WIK_RIGHT|
			WIK_LEFT_LISTEN|WIK_CENTER_LISTEN|WIK_RIGHT_LISTEN) )
			return false;
	}
	return true;
}
//
bool CGameLogic::IsSanFengKe(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount,BYTE cbCardEye)
{
	if(cbCardEye==MAX_INDEX)
		return false;
	BYTE temp=0;
	for(BYTE i=0;i<cbWeaveCount;i++)
	{
		if(WeaveItem[i].cbWeaveKind&(WIK_PENG|WIK_GANG|WIK_PENG_LISTEN))
		{
			if(WeaveItem[i].cbCenterCard>0x30&&WeaveItem[i].cbCenterCard<0x35)
			{
				temp++;
			}
		}
	}

	BYTE Index=SwitchToCardIndex(cbCardEye);
	for(BYTE i=27;i<31;i++)
	{
		if(cbCardIndex[i]==3&&Index!=i)
			temp++;
	}

	if(temp==3)
		return true;

	return false;
}
//
bool CGameLogic::IsThreeAnKe(const BYTE cbCardIndex[MAX_INDEX],const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount,
							 BYTE cbCurrentCard,bool bZiMo)
{
	CAnalyseItemArray AnalyseItemArray;
	AnalyseItemArray.RemoveAll();

	AnalyseCard(cbCardIndex,WeaveItem,cbWeaveCount,AnalyseItemArray);

	if(AnalyseItemArray.GetCount()>0)
	{
		for(INT_PTR i=0;i<AnalyseItemArray.GetCount();i++)
		{
			tagAnalyseItem * pAnalyseItem=&AnalyseItemArray[i];
			BYTE temp=0;
			//ѳϲ
			for( BYTE j = cbWeaveCount; j < CountArray(pAnalyseItem->cbWeaveKind); j++ )
			{
				if(pAnalyseItem->cbWeaveKind[j]&(WIK_PENG|WIK_PENG_LISTEN))
				{
					if(bZiMo)
					{
						temp++;
					}
					else
					{
						if(pAnalyseItem->cbCenterCard[j]!=cbCurrentCard)
						{
							temp++;
						}
					}
				}
			}
			if(temp==3)
				return true;
		}
	}

	return false;
}
//
bool CGameLogic::IsQingLong(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount,const BYTE cbCurrentCard)
{
	if(!IsQingYiSe(cbCardIndex,WeaveItem,cbWeaveCount,cbCurrentCard))
		return false;
	CAnalyseItemArray AnalyseItemArray;
	AnalyseItemArray.RemoveAll();

	//˿
	BYTE cbCardIndexTemp[MAX_INDEX];
	CopyMemory(cbCardIndexTemp,cbCardIndex,sizeof(cbCardIndexTemp));

	//cbCurrentCardһΪ0			!!!!!!!!!
	ASSERT( cbCurrentCard != 0 );
	if( cbCurrentCard == 0 ) return false;

	//˿
	if (cbCurrentCard!=0)
		cbCardIndexTemp[SwitchToCardIndex(cbCurrentCard)]++;

	AnalyseCard(cbCardIndexTemp,WeaveItem,cbWeaveCount,AnalyseItemArray);

	if(AnalyseItemArray.GetCount()>0)
	{
		for(INT_PTR i=0;i<AnalyseItemArray.GetCount();i++)
		{
			tagAnalyseItem * pAnalyseItem=&AnalyseItemArray[i];
			bool bOne=false,bTwo=false,bThree=false;
			for(BYTE j=0;j<MAX_WEAVE;j++)
			{

				if(pAnalyseItem->cbWeaveKind[j]&(WIK_LEFT|WIK_CENTER|WIK_RIGHT|
					WIK_LEFT_LISTEN|WIK_CENTER_LISTEN|WIK_RIGHT_LISTEN))
				{
					if(pAnalyseItem->cbCardData[j][0]==0x01&&pAnalyseItem->cbCardData[j][1]==0x02&&
						pAnalyseItem->cbCardData[j][2]==0x03)
					{
						bOne=true;
					}
					if(pAnalyseItem->cbCardData[j][0]==0x04&&pAnalyseItem->cbCardData[j][1]==0x05&&
						pAnalyseItem->cbCardData[j][2]==0x06)
					{
						bTwo=true;
					}
					if(pAnalyseItem->cbCardData[j][0]==0x07&&pAnalyseItem->cbCardData[j][1]==0x08&&
						pAnalyseItem->cbCardData[j][2]==0x09)
					{
						bThree=true;
					}
				}
			}

			if(bOne&&bTwo&&bThree)
			{
				return true;
			}
		}
	}

	return false;
}
//һɫ
bool CGameLogic::IsYiSeSanBu(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount)
{
	CAnalyseItemArray AnalyseItemArray;
	AnalyseItemArray.RemoveAll();

	AnalyseCard(cbCardIndex,WeaveItem,cbWeaveCount,AnalyseItemArray);

	if(AnalyseItemArray.GetCount()>0)
	{
		for(INT_PTR i=0;i<AnalyseItemArray.GetCount();i++)
		{
			tagAnalyseItem * pAnalyseItem=&AnalyseItemArray[i];
			BYTE card[4]={255},count=0;
			for(BYTE j=0;j<MAX_WEAVE;j++)
			{
				if(pAnalyseItem->cbWeaveKind[j]&(WIK_LEFT|WIK_CENTER|WIK_RIGHT|
					WIK_LEFT_LISTEN|WIK_CENTER_LISTEN|WIK_RIGHT_LISTEN))
				{
					BYTE cbCardBuffer[3];
					GetWeaveCard(pAnalyseItem->cbWeaveKind[j],pAnalyseItem->cbCenterCard[j],cbCardBuffer);
					card[count++]=cbCardBuffer[1];
				}
			}

			if(count<3)
				return false;
			SortCardList(card,count);
			BYTE temp=0;
			bool bOne=false,bTwo=false;
			for(BYTE j=0;j<count-1;j++)
			{
				if(card[j+1]-card[j]==1)
					temp++;
				else
					break;
			}
			if(temp==2)
				bOne=true;
			temp=0;
			for(BYTE j=0;j<count-1;j++)
			{
				if(card[j+1]-card[j]==2)
					temp++;
				else
					break;
			}
			if(temp==2)
				bTwo=true;

			if(bOne||bTwo)
				return true;
		}
	}

	return false;
}
//߶
BYTE CGameLogic::IsQiXiaoDui(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[], const BYTE cbWeaveCount,const BYTE cbCurrentCard)
{
	//ж
	if (cbWeaveCount!=0) return 0;

	//Ŀ
	BYTE cbReplaceCount = 0;

	//ʱ
	BYTE cbCardIndexTemp[MAX_INDEX];
	CopyMemory(cbCardIndexTemp,cbCardIndex,sizeof(cbCardIndexTemp));

	//
	BYTE cbCurrentIndex = SwitchToCardIndex(cbCurrentCard);
	cbCardIndexTemp[cbCurrentIndex]++;

	//㵥
	for (BYTE i=0;i<MAX_INDEX;i++)
	{
		BYTE cbCardCount=cbCardIndexTemp[i];

		//ƹ
		if( i == m_cbMagicIndex ) continue;

		//ͳ
		if( cbCardCount == 1 || cbCardCount == 3 ) 	cbReplaceCount++;
	}

	//Ʋ
	if( m_cbMagicIndex != MAX_INDEX && cbReplaceCount > cbCardIndexTemp[m_cbMagicIndex] ||
		m_cbMagicIndex == MAX_INDEX && cbReplaceCount > 0 )
		return 0;
	if(cbReplaceCount>0)
		return 1;
	else
		return 2;
}
//һɫ
bool CGameLogic::IsQingYiSe(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[], const BYTE cbItemCount,const BYTE cbCurrentCard)
{
	//ж
	BYTE cbCardColor=0xFF;

	for (BYTE i=0;i<MAX_INDEX;i++)
	{
		if(i==m_cbMagicIndex) continue;
		if (cbCardIndex[i]!=0)
		{
			//ɫж
			if (cbCardColor!=0xFF)
				return false;

			//ûɫ
			cbCardColor=(SwitchToCardData(i)&MASK_COLOR);

			//
			i=(i/9+1)*9-1;
		}
	}

	//ֻ
	if( cbCardColor == 0xFF )
	{
		ASSERT( m_cbMagicIndex != MAX_INDEX && cbCardIndex[m_cbMagicIndex] > 0 );
		//
		ASSERT( cbItemCount > 0 );
		cbCardColor = WeaveItem[0].cbCenterCard&MASK_COLOR;
	}

	if((cbCurrentCard&MASK_COLOR)!=cbCardColor && !IsMagicCard(cbCurrentCard) ) return false;

	//ж
	for (BYTE i=0;i<cbItemCount;i++)
	{
		BYTE cbCenterCard=WeaveItem[i].cbCenterCard;
		if ((cbCenterCard&MASK_COLOR)!=cbCardColor)	return false;
	}

	return true;
}
//һɫͬ˳
bool CGameLogic::IsYiSeSanTong(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount)
{
	CAnalyseItemArray AnalyseItemArray;
	AnalyseItemArray.RemoveAll();

	AnalyseCard(cbCardIndex,WeaveItem,cbWeaveCount,AnalyseItemArray);

	if(AnalyseItemArray.GetCount()>0)
	{
		for(INT_PTR i=0;i<AnalyseItemArray.GetCount();i++)
		{
			tagAnalyseItem * pAnalyseItem=&AnalyseItemArray[i];


			for(BYTE j=0;j<MAX_WEAVE;j++)
			{
				if(pAnalyseItem->cbWeaveKind[j]&(WIK_LEFT|WIK_RIGHT|WIK_CENTER|
					WIK_LEFT_LISTEN|WIK_CENTER_LISTEN|WIK_RIGHT_LISTEN))
				{
					BYTE cbCardBufferI[3];
					GetWeaveCard(pAnalyseItem->cbWeaveKind[j],pAnalyseItem->cbCenterCard[j],cbCardBufferI);
					BYTE temp=0;
					for (BYTE z=0;z<MAX_WEAVE;z++)
					{
						if(pAnalyseItem->cbWeaveKind[z]&(WIK_LEFT|WIK_RIGHT|WIK_CENTER|
							WIK_LEFT_LISTEN|WIK_CENTER_LISTEN|WIK_RIGHT_LISTEN))
						{
							BYTE cbCardBufferZ[3];
							GetWeaveCard(pAnalyseItem->cbWeaveKind[z],pAnalyseItem->cbCenterCard[z],cbCardBufferZ);
							if(cbCardBufferI[1]==cbCardBufferZ[1])
							{
								temp++;
							}
						}
					}
					if(temp==3)
					{
						return true;
					}
				}
			}
		}
	}

	return false;
}
//һɫĲ
bool CGameLogic::IsYiSeSiBu(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount)
{
	CAnalyseItemArray AnalyseItemArray;
	AnalyseItemArray.RemoveAll();

	AnalyseCard(cbCardIndex,WeaveItem,cbWeaveCount,AnalyseItemArray);

	if(AnalyseItemArray.GetCount()>0)
	{
		for(INT_PTR i=0;i<AnalyseItemArray.GetCount();i++)
		{
			tagAnalyseItem * pAnalyseItem=&AnalyseItemArray[i];
			BYTE card[4]={255},count=0;
			for(BYTE j=0;j<MAX_WEAVE;j++)
			{
				if(pAnalyseItem->cbWeaveKind[j]&(WIK_LEFT|WIK_CENTER|WIK_RIGHT|
					WIK_LEFT_LISTEN|WIK_CENTER_LISTEN|WIK_RIGHT_LISTEN))
				{
					BYTE cbCardBuffer[3];
					GetWeaveCard(pAnalyseItem->cbWeaveKind[j],pAnalyseItem->cbCenterCard[j],cbCardBuffer);
					card[count++]=cbCardBuffer[1];
				}
				else
				{
					return false;
				}
			}

			if(count<4)
				return false;
			SortCardList(card,count);
			BYTE temp=0;
			bool bOne=false,bTwo=false;
			for(BYTE j=0;j<count-1;j++)
			{
				if(card[j+1]-card[j]==1)
					temp++;
				else
					break;
			}
			if(temp==3)
				bOne=true;
			temp=0;
			for(BYTE j=0;j<count-1;j++)
			{
				if(card[j+1]-card[j]==2)
					temp++;
				else
					break;
			}
			if(temp==3)
				bTwo=true;

			if(bOne||bTwo)
				return true;
		}
	}

	return false;
}
//ͷ
bool CGameLogic::IsQingLaoTou(const tagAnalyseItem *pAnalyseItem )
{
	if(!IsPengPeng(pAnalyseItem))
		return false;

	for( BYTE i = 0; i < CountArray(pAnalyseItem->cbWeaveKind); i++ )
	{
		if( pAnalyseItem->cbCenterCard[i]!=0x01&&pAnalyseItem->cbCenterCard[i]!=0x09&&
			pAnalyseItem->cbCenterCard[i]!=0x11&&pAnalyseItem->cbCenterCard[i]!=0x19&&
			pAnalyseItem->cbCenterCard[i]!=0x21&&pAnalyseItem->cbCenterCard[i]!=0x29&&
			pAnalyseItem->cbCenterCard[i]<0x31)
			return false;
		if( pAnalyseItem->cbCardEye!=0x01&&pAnalyseItem->cbCardEye!=0x09&&
			pAnalyseItem->cbCardEye!=0x11&&pAnalyseItem->cbCardEye!=0x19&&
			pAnalyseItem->cbCardEye!=0x21&&pAnalyseItem->cbCardEye!=0x29&&
			pAnalyseItem->cbCardEye<0x31&&!pAnalyseItem->bMagicEye)
			return false;
	}
	return true;
}
//ȫ
bool CGameLogic::IsChunQuanDaiYao(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount)
{
	CAnalyseItemArray AnalyseItemArray;
	AnalyseItemArray.RemoveAll();

	AnalyseCard(cbCardIndex,WeaveItem,cbWeaveCount,AnalyseItemArray);

	if(AnalyseItemArray.GetCount()>0)
	{
		for(INT_PTR i=0;i<AnalyseItemArray.GetCount();i++)
		{
			tagAnalyseItem * pAnalyseItem=&AnalyseItemArray[i];
			BYTE cbTemp=0;
			if(pAnalyseItem->cbCardEye==0x01||pAnalyseItem->cbCardEye==0x09)
				cbTemp++;
			for(BYTE j=0;j<MAX_WEAVE;j++)
			{
				for(BYTE z=0;z<4;z++)
				{
					if(pAnalyseItem->cbCardData[j][z]==0x01||pAnalyseItem->cbCardData[j][z]==0x09)
					{
						cbTemp++;
						break;
					}
				}
			}
			if(cbTemp==5)
				return true;
		}
	}

	return false;
}
//߶
bool CGameLogic::IsLongQiDui(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount,const BYTE cbCurrentCard)
{
	if(!IsQiXiaoDui(cbCardIndex,WeaveItem,cbWeaveCount,cbCurrentCard))
		return false;

	//ʱ
	BYTE cbCardIndexTemp[MAX_INDEX];
	CopyMemory(cbCardIndexTemp,cbCardIndex,sizeof(cbCardIndexTemp));

	cbCardIndexTemp[SwitchToCardIndex(cbCurrentCard)]++;

	for(BYTE i=0;i<MAX_INDEX;i++)
	{
		if(cbCardIndexTemp[i]==4)
			return true;
	}
	return false;
}
//һɫͬ˳
bool CGameLogic::IsYiSeSiTong(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount)
{
	CAnalyseItemArray AnalyseItemArray;
	AnalyseItemArray.RemoveAll();

	AnalyseCard(cbCardIndex,WeaveItem,cbWeaveCount,AnalyseItemArray);

	if(AnalyseItemArray.GetCount()>0)
	{
		for(INT_PTR i=0;i<AnalyseItemArray.GetCount();i++)
		{
			tagAnalyseItem * pAnalyseItem=&AnalyseItemArray[i];


			for(BYTE j=0;j<MAX_WEAVE;j++)
			{
				if(pAnalyseItem->cbWeaveKind[j]&(WIK_LEFT|WIK_RIGHT|WIK_CENTER|
					WIK_LEFT_LISTEN|WIK_CENTER_LISTEN|WIK_RIGHT_LISTEN))
				{
					BYTE cbCardBufferI[3];
					GetWeaveCard(pAnalyseItem->cbWeaveKind[j],pAnalyseItem->cbCenterCard[j],cbCardBufferI);
					BYTE temp=0;
					for (BYTE z=0;z<MAX_WEAVE;z++)
					{
						if(pAnalyseItem->cbWeaveKind[z]&(WIK_LEFT|WIK_RIGHT|WIK_CENTER|
							WIK_LEFT_LISTEN|WIK_CENTER_LISTEN|WIK_RIGHT_LISTEN))
						{
							BYTE cbCardBufferZ[3];
							GetWeaveCard(pAnalyseItem->cbWeaveKind[z],pAnalyseItem->cbCenterCard[z],cbCardBufferZ);
							if(cbCardBufferI[1]==cbCardBufferZ[1])
							{
								temp++;
							}
						}
					}
					if(temp==4)
					{
						return true;
					}
				}
			}
		}
	}

	return false;
}
//һɫĽڸ
bool CGameLogic::IsYiSeSiJie(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount)
{
	CAnalyseItemArray AnalyseItemArray;
	AnalyseItemArray.RemoveAll();

	AnalyseCard(cbCardIndex,WeaveItem,cbWeaveCount,AnalyseItemArray);

	if(AnalyseItemArray.GetCount()>0)
	{
		for(INT_PTR i=0;i<AnalyseItemArray.GetCount();i++)
		{
			tagAnalyseItem * pAnalyseItem=&AnalyseItemArray[i];
			BYTE temp=0,cbCard[4]={0};
			for(BYTE j=0;j<MAX_WEAVE;j++)
			{
				if((pAnalyseItem->cbWeaveKind[j]&(WIK_PENG|WIK_GANG|WIK_PENG_LISTEN)))
				{
					cbCard[temp++]=pAnalyseItem->cbCenterCard[j];
				}
				else
				{
					return false;
				}
			}
			if(temp<4)
				return false;
			SortCardList(cbCard,temp);
			BYTE count=0;
			for(BYTE j=0;j<temp-1;j++)
			{
				if(cbCard[j+1]-cbCard[j]==1)
					count++;
			}

			if(count==3)
				return true;
		}
	}

	return false;
}
//Сϲ
bool CGameLogic::IsXiaoSiXi(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount,BYTE cbCardEye)
{
	if(cbCardEye==MAX_INDEX)
		return false;
	BYTE cbTemp=0;
	if(cbCardEye>0x30&&cbCardEye<0x35)
	{
		cbTemp++;
	}
	for(BYTE i=27;i<31;i++)
	{
		if(cbCardIndex[i]>=3)
			cbTemp++;
	}
	for(BYTE i=0;i<cbWeaveCount;i++)
	{
		if(WeaveItem[i].cbWeaveKind&(WIK_PENG|WIK_GANG|WIK_PENG_LISTEN))
		{
			if(WeaveItem[i].cbCenterCard>0x30&&WeaveItem[i].cbCenterCard<0x35)
				cbTemp++;
		}
	}
	if(cbTemp==4)
		return true;

	return false;
}
//СԪ
bool CGameLogic::IsXiaoSanYuan(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount,BYTE cbCardEye)
{
	if(cbCardEye==MAX_INDEX)
		return false;
	BYTE cbTemp=0;
	if(cbCardEye>0x34&&cbCardEye<0x38)
	{
		cbTemp++;
	}
	for(BYTE i=31;i<34;i++)
	{
		if(cbCardIndex[i]>=3)
			cbTemp++;
	}
	for(BYTE i=0;i<cbWeaveCount;i++)
	{
		if(WeaveItem[i].cbWeaveKind&(WIK_PENG|WIK_GANG|WIK_PENG_LISTEN))
		{
			if(WeaveItem[i].cbCenterCard>0x34&&WeaveItem[i].cbCenterCard<0x38)
				cbTemp++;
		}
	}
	if(cbTemp==3)
		return true;

	return false;
}
//һɫ
bool CGameLogic::IsZiYiSe(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount)
{
	for (BYTE i=0;i<MAX_INDEX;i++)
	{
		if (cbCardIndex[i]!=0)
		{
			if(i<27)
				return false;
		}
	}

	//ж
	for (BYTE i=0;i<cbWeaveCount;i++)
	{
		BYTE cbCenterCard=WeaveItem[i].cbCenterCard;
		if (SwitchToCardIndex(cbCenterCard)<27)	return false;
	}

	return true;
}
//İ
bool CGameLogic::IsSiAnKe(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount,
						  BYTE cbCurrentCard,bool bZiMo)
{
	if(!IsMenQianQing(WeaveItem,cbWeaveCount))
		return false;

	CAnalyseItemArray AnalyseItemArray;
	AnalyseItemArray.RemoveAll();

	AnalyseCard(cbCardIndex,WeaveItem,cbWeaveCount,AnalyseItemArray);

	if(AnalyseItemArray.GetCount()>0)
	{
		for(INT_PTR i=0;i<AnalyseItemArray.GetCount();i++)
		{
			tagAnalyseItem * pAnalyseItem=&AnalyseItemArray[i];
			BYTE temp=0;
			for(BYTE j=0;j<MAX_WEAVE;j++)
			{
				if(pAnalyseItem->cbWeaveKind[j]&(WIK_PENG|WIK_PENG_LISTEN))
				{
					if(bZiMo)
					{
						temp++;
					}
					else
					{
						if(pAnalyseItem->cbCenterCard[j]!=cbCurrentCard)
						{
							temp++;
						}
					}
				}
			}

			if(temp==4)
				return true;
		}
	}

	return false;

}
//һɫ˫
bool CGameLogic::IsYiSeShuangLong(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount,BYTE cbCardEye)
{
	if(cbCardEye==MAX_INDEX&&cbCardEye!=0x05)
		return false;
	CAnalyseItemArray AnalyseItemArray;
	AnalyseItemArray.RemoveAll();

	AnalyseCard(cbCardIndex,WeaveItem,cbWeaveCount,AnalyseItemArray);

	if(AnalyseItemArray.GetCount()>0)
	{
		for(INT_PTR i=0;i<AnalyseItemArray.GetCount();i++)
		{
			BYTE cbShao=0,cbLao=0;
			tagAnalyseItem * pAnalyseItem=&AnalyseItemArray[i];
			for(BYTE j=0;j<MAX_WEAVE;j++)
			{
				if(pAnalyseItem->cbWeaveKind[j]&(WIK_LEFT|WIK_RIGHT|WIK_CENTER|
					WIK_LEFT_LISTEN|WIK_CENTER_LISTEN|WIK_RIGHT_LISTEN))
				{
					if(pAnalyseItem->cbCardData[j][0]==0x01)
						cbShao++;
					if(pAnalyseItem->cbCardData[j][2]==0x09)
						cbLao++;
				}
			}
			if(cbShao==2&&cbLao==2)
				return true;
		}
	}

	return false;
}
//ϲ
bool CGameLogic::IsDaSiXi(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount)
{
	BYTE cbTemp=0;
	for(BYTE i=27;i<31;i++)
	{
		if(cbCardIndex[i]>=3)
			cbTemp++;
	}
	for(BYTE i=0;i<cbWeaveCount;i++)
	{
		if(WeaveItem[i].cbWeaveKind&(WIK_PENG|WIK_GANG|WIK_PENG_LISTEN))
		{
			if(WeaveItem[i].cbCenterCard>0x30&&WeaveItem[i].cbCenterCard<0x35)
				cbTemp++;
		}
	}
	if(cbTemp==4)
		return true;

	return false;
}
//Ԫ
bool CGameLogic::IsDaSanYuan(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount)
{
	BYTE cbTemp=0;
	for(BYTE i=31;i<34;i++)
	{
		if(cbCardIndex[i]>=3)
			cbTemp++;
	}
	for(BYTE i=0;i<cbWeaveCount;i++)
	{
		if(WeaveItem[i].cbWeaveKind&(WIK_PENG|WIK_GANG|WIK_PENG_LISTEN))
		{
			if(WeaveItem[i].cbCenterCard>0x34&&WeaveItem[i].cbCenterCard<0x38)
				cbTemp++;
		}
	}
	if(cbTemp==3)
		return true;

	return false;
}
//
bool CGameLogic::IsJiuLian(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount)
{
	if(!IsMenQianQing(WeaveItem,cbWeaveCount))
		return false;
	if(cbCardIndex[0]!=3||cbCardIndex[8]!=3)
		return false;
	for(BYTE i=1;i<8;i++)
	{
		if(cbCardIndex[i]!=1)
			return false;
	}

	return true;
}
//ʮ޺
bool CGameLogic::IsShiBa(const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount)
{
	BYTE temp=0;
	for(BYTE i=0;i<cbWeaveCount;i++)
	{
		if(WeaveItem[i].cbWeaveKind==WIK_GANG)
			temp++;
	}
	if(temp==4)
		return true;
	return false;
}
//߶
bool CGameLogic::IsLianQiDui(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount,const BYTE cbCurrentCard)
{
	if(!IsQiXiaoDui(cbCardIndex,WeaveItem,cbWeaveCount,cbCurrentCard))
		return false;

	//ʱ
	BYTE cbCardIndexTemp[MAX_INDEX];
	CopyMemory(cbCardIndexTemp,cbCardIndex,sizeof(cbCardIndexTemp));
	cbCardIndexTemp[SwitchToCardIndex(cbCurrentCard)]++;

	BYTE temp=MAX_INDEX;
	for(BYTE i=0;i<MAX_INDEX;i++)
	{
		if(cbCardIndexTemp[i]==2)
		{
			temp=i;
			break;
		}
	}

	if(temp>3)
		return false;

	for(BYTE i=temp;i<temp+7;i++)
	{
		if(cbCardIndexTemp[i]!=2)
			return false;
	}

	return true;
}
//5
bool CGameLogic::IsDaYu5(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount)
{
	for(BYTE i=0;i<cbWeaveCount;i++)
	{
		if(WeaveItem[i].cbWeaveKind==WIK_GANG)
		{
			for(BYTE j=0;j<4;j++)
			{
				if(WeaveItem[i].cbCardData[j]<=0x05||WeaveItem[i].cbCardData[j]>0x09)
				{
					return false;
				}
			}
		}
		else
		{
			for(BYTE j=0;j<3;j++)
			{
				if(WeaveItem[i].cbCardData[j]<=0x05||WeaveItem[i].cbCardData[j]>0x09)
				{
					return false;
				}
			}
		}
	}

	for(BYTE i=0;i<MAX_INDEX;i++)
	{
		if(cbCardIndex[i]!=0)
		{
			if(i<5||i>8)
				return false;
		}
	}

	return true;
}
//С5
bool CGameLogic::IsXiaoYu5(const BYTE cbCardIndex[MAX_INDEX], const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount)
{
	for(BYTE i=0;i<cbWeaveCount;i++)
	{
		if(WeaveItem[i].cbWeaveKind==WIK_GANG)
		{
			for(BYTE j=0;j<4;j++)
			{
				if(WeaveItem[i].cbCardData[j]>=0x05)
				{
					return false;
				}
			}
		}
		else
		{
			for(BYTE j=0;j<3;j++)
			{
				if(WeaveItem[i].cbCardData[j]>=0x05)
				{
					return false;
				}
			}
		}
	}

	for(BYTE i=0;i<MAX_INDEX;i++)
	{
		if(cbCardIndex[i]!=0)
		{
			if(i>3)
				return false;
		}
	}

	return true;
}
//////////////////////////////////////////////////////////////////////////
//
bool CGameLogic::IsBianZhang(const BYTE cbCardIndex[MAX_INDEX],const tagWeaveItem WeaveItem[],const BYTE cbWeaveCount, BYTE cbCardEye,BYTE cbCurrentCard)
{
	if(cbCurrentCard!=0x03&&cbCurrentCard!=0x07)
	{
		return false;
	}

	CAnalyseItemArray AnalyseItemArray;
	AnalyseItemArray.RemoveAll();

	AnalyseCard(cbCardIndex,WeaveItem,cbWeaveCount,AnalyseItemArray);

	if(AnalyseItemArray.GetCount()>0)
	{
		for(INT_PTR i=0;i<AnalyseItemArray.GetCount();i++)
		{
			tagAnalyseItem * pAnalyseItem=&AnalyseItemArray[i];
			//ѳϲ
			for( BYTE i = cbWeaveCount; i < CountArray(pAnalyseItem->cbWeaveKind); i++ )
			{
				//˿
				if( !(pAnalyseItem->cbWeaveKind[i]&(WIK_LEFT|WIK_LEFT_LISTEN|WIK_CENTER|WIK_CENTER_LISTEN|WIK_RIGHT|
					WIK_RIGHT_LISTEN)) )
					continue;

				//Ƿеǰ
				for( BYTE j = 0; j < 3; j++ )
				{
					if( pAnalyseItem->cbCardData[i][j] == cbCurrentCard )
					{
						if( j == 0 && (pAnalyseItem->cbCenterCard[i]&MASK_VALUE) == 7 ||
							j == 2 && (pAnalyseItem->cbCenterCard[i]&MASK_VALUE) == 1)
						{
							return true;
						}
					}
				}
			}
		}
	}

	return false;
}