#include "StdAfx.h"
#include "GameOption.h"
#include "GameWindow.h"
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

extern TL_Gwindow* g_pGWindow;
CGameOption::CGameOption(const tstring &strname)
:hgeItemContainer(strname)
{
	m_pBack=NULL;
	for(BYTE i=0;i<3;i++)
	{
		m_bChechBox[i]=false;
		m_pCheckBox[i]=NULL;
	}
	m_ptTempPoint=hgePoint(0,0);
//	m_bLButtonDown=false;
	m_pOk=NULL;
	m_pCancel=NULL;
	m_pClose=NULL;
}

CGameOption::~CGameOption(void)
{
	if(m_pBack)
		delete m_pBack;
	if(m_pOk)
		delete m_pOk;
	if(m_pCancel)
		delete m_pCancel;
	if(m_pClose)
		delete m_pClose;
	for(BYTE i=0;i<4;i++)
	{
		if(m_pCheckBox[i])
			delete m_pCheckBox[i];
	}
}
void CGameOption::Init()
{
	HTEXTURE tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexGameOption_Back");
	m_pBack=new MySprite(tex,0,0,325,270);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexGameOption_CheckBox");
	for(BYTE i=0;i<4;i++)
	{
		m_pCheckBox[i]=new MySprite(tex,0,0,46,24);
	}
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexGameOption_Ok");
	m_pOk=new hgeItemButton("OK",tex,hgePoint(0,0),hgePoint(88,28),TRUE,4,TRUE);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexGameOption_Cancel");
	m_pCancel=new hgeItemButton("Cancel",tex,hgePoint(0,0),hgePoint(88,28),TRUE,4,TRUE);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexGameOption_Close");
	m_pClose=new hgeItemButton("Close",tex,hgePoint(0,0),hgePoint(),TRUE,4,TRUE);
	m_bChechBox[0]=true;
	m_bEnableSound=m_bChechBox[0];
	m_bChechBox[1]=m_bAllowLookon;
	//m_bAllowLookon=m_bChechBox[1];
	m_bChechBox[2]=true;
	m_bEanbleAnimate=m_bChechBox[2];
	m_bChechBox[3]=true;
	m_bBackSound=m_bChechBox[3];
}
void CGameOption::Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect)
{
	m_pBack->Render(m_ptBack.x,m_ptBack.y);
	for(BYTE i=0;i<4;i++)
	{
		m_pCheckBox[i]->SetTextureRect(!m_bChechBox[i]?23:0,0,23,24);
		m_pCheckBox[i]->Render(m_ptCheckBox[i].x,m_ptCheckBox[i].y);
	}
	m_pOk->Render(m_ptOk,bClip,clipRect);
	m_pCancel->Render(m_ptCancel,bClip,clipRect);
	m_pClose->Render(m_ptClose,bClip,clipRect);
}
void CGameOption::SetPoint(hgePoint point)
{
	m_ptBack=point;
	for(BYTE i=0;i<4;i++)
	{
		m_ptCheckBox[i].x=m_ptBack.x+140;
		m_ptCheckBox[i].y=m_ptBack.y+76+i*33;
	}
	m_rcCheckBox[0].x1=m_ptCheckBox[0].x;
	m_rcCheckBox[0].x2=m_ptCheckBox[0].x+23;
	m_rcCheckBox[0].y1=m_ptCheckBox[0].y;
	m_rcCheckBox[0].y2=m_ptCheckBox[0].y+24;

	m_rcCheckBox[1].x1=m_ptCheckBox[1].x;
	m_rcCheckBox[1].x2=m_ptCheckBox[1].x+23;
	m_rcCheckBox[1].y1=m_ptCheckBox[1].y;
	m_rcCheckBox[1].y2=m_ptCheckBox[1].y+24;

	m_rcCheckBox[2].x1=m_ptCheckBox[2].x;
	m_rcCheckBox[2].x2=m_ptCheckBox[2].x+23;
	m_rcCheckBox[2].y1=m_ptCheckBox[2].y;
	m_rcCheckBox[2].y2=m_ptCheckBox[2].y+24;

	m_rcCheckBox[3].x1=m_ptCheckBox[3].x;
	m_rcCheckBox[3].x2=m_ptCheckBox[3].x+23;
	m_rcCheckBox[3].y1=m_ptCheckBox[3].y;
	m_rcCheckBox[3].y2=m_ptCheckBox[3].y+24;

	m_ptClose.x=m_ptBack.x+282;
	m_ptClose.y=m_ptBack.y+15;
	m_rcClose.x1=m_ptClose.x;
	m_rcClose.x2=m_ptClose.x+64;
	m_rcClose.y1=m_ptClose.y;
	m_rcClose.y2=m_ptClose.y+16;

	m_ptOk.x=m_ptBack.x+40+25;
	m_ptOk.y=m_ptBack.y+120+105;
	m_rcOk.x1=m_ptOk.x;
	m_rcOk.y1=m_ptOk.y;
	m_rcOk.x2=m_ptOk.x+88;
	m_rcOk.y2=m_ptOk.y+28;
	m_ptCancel.x=m_ptBack.x+145+25;
	m_ptCancel.y=m_ptBack.y+120+105;
	m_rcCancel.x1=m_ptCancel.x;
	m_rcCancel.y1=m_ptCancel.y;
	m_rcCancel.x2=m_ptCancel.x+88;
	m_rcCancel.y2=m_ptCancel.y+28;
}
void CGameOption::OnLButtonDown(UINT nFlags, const hgePoint& point)
{
	if(m_rcCheckBox[0].TestPoint(point.x,point.y))
	{
		m_bChechBox[0]=!m_bChechBox[0];
		m_bEnableSound=m_bChechBox[0];
	}
	if(m_rcCheckBox[1].TestPoint(point.x,point.y))
	{
		m_bChechBox[1]=!m_bChechBox[1];
		m_bAllowLookon=m_bChechBox[1];
	}
	if(m_rcCheckBox[2].TestPoint(point.x,point.y))
	{
		m_bChechBox[2]=!m_bChechBox[2];
		m_bEanbleAnimate=m_bChechBox[2];
	}
	if(m_rcCheckBox[3].TestPoint(point.x,point.y))
	{
		m_bChechBox[3]=!m_bChechBox[3];
		m_bBackSound=m_bChechBox[3];
	}
	if(m_rcOk.TestPoint(point.x,point.y))
	{
		m_pOk->OnLButtonDown(nFlags,point);
	}
	if(m_rcCancel.TestPoint(point.x,point.y))
	{
		m_pCancel->OnLButtonDown(nFlags,point);
	}
	if(m_rcClose.TestPoint(point.x,point.y))
	{
		m_pClose->OnLButtonDown(nFlags,point);
	}
	//m_ptTempPoint.x=point.x;
	//m_ptTempPoint.y=point.y;
//	m_bLButtonDown=true;
}
void CGameOption::OnLButtonUp(UINT nFlags, const hgePoint& point)
{
	//if(m_bLButtonDown)
	{
		if(m_rcOk.TestPoint(point.x,point.y))
		{
			m_pOk->OnLButtonUp(nFlags,point);
		}
		if(m_rcCancel.TestPoint(point.x,point.y))
		{
			m_pCancel->OnLButtonUp(nFlags,point);
		}
		if(m_rcClose.TestPoint(point.x,point.y))
		{
			m_pClose->OnLButtonUp(nFlags,point);
		}
		//m_ptBack.x+=(point.x-m_ptTempPoint.x);
		//m_ptBack.y+=(point.y-m_ptTempPoint.y);
		//SetPoint(m_ptBack);
		//m_bLButtonDown=false;
	}
}
void CGameOption::OnMouseMove(UINT nFlags, const hgePoint& point)
{
	//if(m_bLButtonDown)
	{
		if(m_rcOk.TestPoint(point.x,point.y))
		{
			m_pOk->OnMouseMove(nFlags,point);
		}
		if(m_rcCancel.TestPoint(point.x,point.y))
		{
			m_pCancel->OnMouseMove(nFlags,point);
		}
		if(m_rcClose.TestPoint(point.x,point.y))
		{
			m_pClose->OnMouseMove(nFlags,point);
		}
		//m_ptBack.x+=(point.x-m_ptTempPoint.x);
		//m_ptBack.y+=(point.y-m_ptTempPoint.y);
		//SetPoint(m_ptBack);
		m_ptTempPoint.x=point.x;
		m_ptTempPoint.y=point.y;
	}
}