#include "StdAfx.h"
#include "GameScore.h"
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

CGameScore::CGameScore(const tstring& strName)
:hgeItemContainer(strName)
{
	m_phge = hgeCreate(HGE_VERSION);
	m_pButtonContinue=NULL;
	//m_pPageUp=NULL;
	//m_pPageDown=NULL;
	m_pBaseNumber=NULL;
	m_pWin=NULL;
	m_pWinNum=NULL;
	m_pLost=NULL;
	m_pLostNum=NULL;
	m_pHuangZhuang=NULL;
	m_pAll=NULL;
	m_pAllFan=NULL;
	m_pAllFanNum=NULL;
	m_pFan=NULL;
	m_pFanNum=NULL;
	m_pDaManGuan=NULL;
	m_pXiaoManGuan=NULL;
	m_pTimeNumber=NULL;
	m_pYiMan=NULL;
	ZeroMemory( &m_ScoreInfo,sizeof(m_ScoreInfo) );

	m_lCellScore=1;
	m_wTime=0;
	m_bPlaySound=true;
	m_cbWeaveCount=0;
	m_cbChiHuIndex=0;
	m_cbChiHuCount=0;
	m_cbChiHuJiSuan=0;
	m_bChiHuUpdata=false;
	m_bUpdata=false;
	m_bFanDraw=false;
	m_bLButtonDown=false;
	m_cbType=0;
	m_cbPage=0;
	m_cbPageCount=0;
	m_dwFanCount=0;
	m_ptScorePos=hgePoint(0,0);

	for(BYTE i=0;i<MAX_WEAVE;i++)
	{
		m_pWeaveCard[i]=NULL;
	}

	m_ChiHuRight.SetEmpty();
	m_ChiHuHigh.SetEmpty();
	m_ChiHuNew.SetEmpty();
	m_ArrayTypeInfo.RemoveAll();
	m_ArrayCard.RemoveAll();
}

CGameScore::~CGameScore(void)
{
	if(m_pBaseNumber)
		delete m_pBaseNumber;
	if(m_pWin)
		delete m_pWin;
	if(m_pWinNum)
		delete m_pWinNum;
	if(m_pLost)
		delete m_pLost;
	if(m_pLostNum)
		delete m_pLostNum;
	if(m_pButtonContinue)
		delete m_pButtonContinue;
	//if(m_pPageUp)
	//	delete m_pPageUp;
	//if(m_pPageDown)
	//	delete m_pPageDown;
	if(m_pHuangZhuang)
		delete m_pHuangZhuang;
	if(m_pAll)
		delete m_pAll;
	if(m_pAllFan)
		delete m_pAllFan;
	if(m_pAllFanNum)
		delete m_pAllFanNum;
	if(m_pFan)
		delete m_pFan;
	if(m_pFanNum)
		delete m_pFanNum;
	if(m_pDaManGuan)
		delete m_pDaManGuan;
	if(m_pXiaoManGuan)
		delete m_pXiaoManGuan;
	if(m_pYiMan)
		delete m_pYiMan;
	if(m_pTimeNumber)
		delete m_pTimeNumber;
	for(BYTE i=0;i<MAX_WEAVE;i++)
	{
		if(m_pWeaveCard[i]!=NULL)
			delete m_pWeaveCard[i];
	}

	for(INT_PTR i=0;i<m_ArrayTypeInfo.GetCount();i++)
	{
		if(m_ArrayTypeInfo[i].pSprite)
			delete m_ArrayTypeInfo[i].pSprite;
	}
	m_ArrayTypeInfo.RemoveAll();
}
void CGameScore::InitData(const char* strFile)
{
	HTEXTURE tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexBaseNum");
	m_pBaseNumber=new MySprite(tex,0,0,200,25);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexWin");
	m_pWin=new MySprite(tex,0,0,151,67);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexWinNum");
	m_pWinNum=new MySprite(tex,0,0,220,26);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexLose");
	m_pLost=new MySprite(tex,0,0,159,54);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexLoseNum");
	m_pLostNum=new MySprite(tex,0,0,220,26);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexScoreHuangZhuang");
	m_pHuangZhuang=new MySprite(tex,0,0,252,119);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexScoreall");
	m_pAll=new MySprite(tex,0,0,44,26);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexScoreallFan");
	m_pAllFan=new MySprite(tex,0,0,20,26);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexScoreallFanNum");
	m_pAllFanNum=new MySprite(tex,0,0,216,27);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexScoreFan");
	m_pFan=new MySprite(tex,0,0,21,50);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexScoreFanNum");
	m_pFanNum=new MySprite(tex,0,0,190,50);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexScoreDaManGuan");
	m_pDaManGuan=new MySprite(tex,0,0,90,50);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexScoreXiaoManGuan");
	m_pXiaoManGuan=new MySprite(tex,0,0,90,50);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexScoreYiMan");
	m_pYiMan=new MySprite(tex,0,0,225,106);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexEndTime");
	m_pTimeNumber=new MySprite(tex,0,0,180,20);

	m_ImageBackUp.LoadImage("\\gameend\\ScoreBackUp.png");
	m_ImageBackMiddle.LoadImage("\\gameend\\ScoreBackMiddle.png");
	m_ImageBackDown.LoadImage("\\gameend\\ScoreBackDown.png");
	m_ImageRedouble.LoadImage("\\gameend\\Redouble.png");
	m_ImageRedoubleNum.LoadImage("\\gameend\\RedoubleNum.png");
	m_ImageScoreNumber.LoadImage("\\gameend\\allFanNum.png");
	m_ImageLine.LoadImage("\\gameend\\ScoreLine.png");

	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexContinue");
	m_pButtonContinue=new hgeItemButton("ButtonContinue",tex,hgePoint(0,0),hgePoint(232,90),true,4);
	//tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexPageUp");
	//m_pPageUp=new hgeItemButton("PageUp",tex,hgePoint(0,0),hgePoint(68,51),true,4);
	//m_pPageUp->_OnPress=FEvent_PItemV2(this,&CGameScore::OnPageUp);
	//m_pPageUp->SetDoHitTest(TRUE);
	//tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexPageDown");
	//m_pPageDown=new hgeItemButton("PageDown",tex,hgePoint(0,0),hgePoint(68,51),true,4);
	//m_pPageDown->_OnPress=FEvent_PItemV2(this,&CGameScore::OnPageDonw);
	//m_pPageDown->SetDoHitTest(TRUE);

	for(BYTE i=0;i<MAX_WEAVE;i++)
	{
		m_pWeaveCard[i]=new CWeaveCard("WeaveCard");
		m_pWeaveCard[i]->SetDisplayItem(true);
		m_pWeaveCard[i]->SetDirection(Direction_South);
		m_pWeaveCard[i]->SetCardSize(true);
	}

	m_fXScore=256;
	m_fYScore=163;

	m_ptContinue=hgePoint(400,527);

	m_StrFile=strFile;
}
//λ
void CGameScore::RestorationData()
{
	ZeroMemory( &m_ScoreInfo,sizeof(m_ScoreInfo) );
	m_lCellScore=1;
	m_wTime=0;
	m_bHuangZhuang=false;
	m_cbChiHuIndex=0;
	m_cbChiHuCount=0;
	m_cbChiHuJiSuan=0;
	m_bChiHuUpdata=false;
	m_bUpdata=false;
	m_bFanDraw=false;
	m_bLButtonDown=false;
	m_cbType=0;
	m_cbPage=0;
	m_cbPageCount=0;
	m_dwFanCount=0;
	m_ptScorePos=hgePoint(0,0);
	m_fXScore=256;
	m_fYScore=163;
	m_ChiHuRight.SetEmpty();
	m_ChiHuHigh.SetEmpty();
	m_ChiHuNew.SetEmpty();
	for(BYTE i=0;i<MAX_WEAVE;i++)
	{
		m_pWeaveCard[i]->SetCardData(NULL,0,0);
		m_pWeaveCard[i]->ResealeInfo();
	}

	for(INT_PTR i=0;i<m_ArrayTypeInfo.GetCount();i++)
	{
		if(m_ArrayTypeInfo[i].pSprite)
			delete m_ArrayTypeInfo[i].pSprite;
		m_phge->Texture_Free(m_ArrayTypeInfo[i].texture);
	}
	m_ArrayTypeInfo.RemoveAll();
	m_ArrayCard.RemoveAll();
}
void CGameScore::Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect)
{
		if(!m_bHuangZhuang)
		{
			m_ImageBackUp.DrawImage(m_ptScorePos.x,m_ptScorePos.y);
			float fYPos=m_ptScorePos.y+m_ImageBackUp.GetHeight();
			DWORD cbCount=0;
			for(;cbCount<80+50;cbCount++)
			{
				m_ImageBackMiddle.DrawImage(m_ptScorePos.x,fYPos+(cbCount*m_ImageBackMiddle.GetHeight()));
			}
			m_ImageLine.DrawImage(m_ptScorePos.x+64,fYPos+36);
			int dwCount=m_ArrayTypeInfo.GetCount()-2;
			if(dwCount>0)
			{
				for(;cbCount<130+(dwCount/2+dwCount%2)*42;cbCount++)
				{
					m_ImageBackMiddle.DrawImage(m_ptScorePos.x,fYPos+(cbCount*m_ImageBackMiddle.GetHeight()));
				}
			}

			DWORD dwIndex=0;
			for(INT_PTR i=0;i<m_ArrayTypeInfo.GetCount();i++)
			{
				{
					m_ArrayTypeInfo[i].pSprite->Render((float)m_ptScorePos.x+34+(dwIndex%2*242),
						(float)m_ptScorePos.y+112+(dwIndex/2*40));
					DrawNumberFan(m_ArrayTypeInfo[i].cbFan,(float)m_ptScorePos.x+34+(dwIndex%2*242)+140,
						(float)m_ptScorePos.y+115+(dwIndex/2*38),m_pFanNum,190,50,m_pFan);
				}
				dwIndex++;
			}

			fYPos=fYPos+cbCount*m_ImageBackMiddle.GetHeight();
			m_ImageBackDown.DrawImage(m_ptScorePos.x,fYPos);

			//m_wTime=10;
			if(m_wTime<=10&&m_wTime!=0)
				DrawTimer(m_ptScorePos.x+432,fYPos+65,m_wTime);

			//if(m_cbType>0)
			{
				m_pAll->Render(m_ptScorePos.x+294,fYPos-30);
				if(m_dwFanCount>=88)
				{
					DrawNumberFan(88+m_ScoreInfo.dwFanShu,m_ptScorePos.x+384,fYPos-30,m_pAllFanNum,216,27,m_pAllFan,true,true);
				}
				else
					DrawNumberFan(m_dwFanCount+m_ScoreInfo.dwFanShu,m_ptScorePos.x+384,fYPos-30,m_pAllFanNum,216,27,m_pAllFan,true,true);
				m_ImageRedouble.DrawImage(m_ptScorePos.x+40,fYPos-30);
				DrawNumberString(m_ScoreInfo.dwFanShu,m_ptScorePos.x+146,fYPos-30,m_ImageRedoubleNum,false,true);
			}

			if(m_ScoreInfo.lGameGold[1]>0)
			{
				m_pWin->Render(m_ptScorePos.x+181,m_ptScorePos.y-53);
			}
			else if(m_ScoreInfo.lGameGold[1]<0)
			{
				m_pLost->Render(m_ptScorePos.x+181,m_ptScorePos.y-53);
			}
			m_pAll->Render(m_ptScorePos.x+164,fYPos+5);
			DrawNumberString(m_ScoreInfo.lGameGold[1],m_ptScorePos.x+224,fYPos+5,m_ImageScoreNumber,true,false);

			float nXPos=(float)m_ptScorePos.x+22+((13-m_ScoreInfo.cbCardCount)*(g_CardResource.m_SmallSpecialCard.GetViewWidth()))+m_cbWeaveCount*2;
			float nYPos=m_ptScorePos.y+44;
			for(BYTE i=0;i<m_ScoreInfo.cbCardCount;i++)
			{
				g_CardResource.m_SmallSpecialCard.DrawCardItem(m_ScoreInfo.cbCardData[i],nXPos,nYPos);
				nXPos+=g_CardResource.m_SmallSpecialCard.GetViewWidth();
			}
			if(m_ScoreInfo.cbProvideCard!=0)
			{
				g_CardResource.m_SmallSpecialCard.DrawCardItem(m_ScoreInfo.cbProvideCard,nXPos+5,nYPos);
			}

			for(BYTE i=0;i<m_cbWeaveCount;i++)
			{
				m_pWeaveCard[i]->Render(ptParentOffset,bClip,clipRect);
			}

			float fYContinue=fYPos+11;
			SetContinuePos(hgePoint(m_ptScorePos.x+140,fYContinue));
			m_pButtonContinue->Render(m_ptContinue,bClip,clipRect);
		}
		else
		{
			m_ImageBackUp.DrawImage(m_ptScorePos.x,m_ptScorePos.y);
			float fYPos=m_ptScorePos.y+m_ImageBackUp.GetHeight();
			DWORD cbCount=0;
			for(;cbCount<162;cbCount++)
			{
				m_ImageBackMiddle.DrawImage(m_ptScorePos.x,fYPos+(cbCount*m_ImageBackMiddle.GetHeight()));
			}
			m_ImageLine.DrawImage(m_ptScorePos.x+64,fYPos+36);
			fYPos=fYPos+cbCount*m_ImageBackMiddle.GetHeight();
			m_ImageBackDown.DrawImage(m_ptScorePos.x,fYPos);
			m_pHuangZhuang->Render(m_ptScorePos.x+129,m_ptScorePos.y+107);

			if(m_ScoreInfo.lGameGold[1]>0)
			{
				m_pWin->Render(m_ptScorePos.x+181,m_ptScorePos.y-53);
			}
			else if(m_ScoreInfo.lGameGold[1]<0)
			{
				m_pLost->Render(m_ptScorePos.x+181,m_ptScorePos.y-53);
			}
			m_pAll->Render(m_ptScorePos.x+164,fYPos+5);
			DrawNumberString(m_ScoreInfo.lGameGold[1],m_ptScorePos.x+224,fYPos+5,m_ImageScoreNumber,true,false);

			float nXPos=(float)m_ptScorePos.x+24+((14-m_ScoreInfo.cbCardCount)*(g_CardResource.m_SmallSpecialCard.GetViewWidth()))+m_cbWeaveCount*2;
			float nYPos=m_ptScorePos.y+44;
			for(BYTE i=0;i<m_ScoreInfo.cbCardCount;i++)
			{
				g_CardResource.m_SmallSpecialCard.DrawCardItem(m_ScoreInfo.cbCardData[i],nXPos,nYPos);
				nXPos+=g_CardResource.m_SmallSpecialCard.GetViewWidth();
			}
			if(m_ScoreInfo.cbProvideCard!=0)
			{
				g_CardResource.m_SmallSpecialCard.DrawCardItem(m_ScoreInfo.cbProvideCard,nXPos+5,nYPos);
			}

			for(BYTE i=0;i<m_cbWeaveCount;i++)
			{
				m_pWeaveCard[i]->Render(ptParentOffset,bClip,clipRect);
			}

			float fYContinue=fYPos+11;
			SetContinuePos(hgePoint(m_ptScorePos.x+140,fYContinue));
			m_pButtonContinue->Render(m_ptContinue,bClip,clipRect);
		}
}
//û
void CGameScore::SetScoreInfo(const tagScoreInfo & ScoreInfo, const tagWeaveInfo & WeaveInfo,const BYTE cbMingGangCount,const BYTE cbAnGangCount,
							  const CChiHuRight &ChiHuRight ,const CChiHuRight &ChiHuHigh,const CChiHuRight &ChiHuNew,
							  LONG lCellScore,WORD wMeChairID)
{
	m_ScoreInfo=ScoreInfo;
	m_ChiHuRight=ChiHuRight;
	m_ChiHuHigh=ChiHuHigh;
	m_ChiHuNew=ChiHuNew;
	m_lCellScore=lCellScore;
	m_cbWeaveCount=WeaveInfo.cbWeaveCount;
	m_dwFanCount=0;
	m_bFanDraw=false;

	DWORD pdwHigh[]={
		CHR_DA_SI_XI,CHR_DA_SAN_YUAN,CHR_JIU_LIAN,CHR_SHI_BA,CHR_LIAN_QI_DUI,CHR_DA_5,CHR_XIAO_5,CHR_XIAO_SI_XI,
		CHR_XIAO_SAN_YUAN,CHR_ZI_YI_SE,CHR_SI_AN_KE,CHR_YISE_SHUANG_LONG,CHR_TIAN_HU,CHR_DI_HU,CHR_YISE_SITONG,
		CHR_YISE_SIJIE,CHR_YISE_SIBU,CHR_QING_LAOTOU,CHR_CHUN_QUAN_DAI_YI,CHR_LONG_QI_DUI,CHR_QI_DUI,CHR_QING_YI_SE,
		CHR_QING_LONG,CHR_YISE_SANBU,CHR_YISE_SANTONG,CHR_THREE_ANKE,CHR_SAN_FENG_KE
	};

	BYTE pcbHighCount[]= {1,  2, 3,  4,  5, 6, 7, 8,  9,  10, 11, 12, 13, 14, 15, 16 ,17, 18, 19, 20,21, 22, 
		24, 25, 
		23, 26,27};
	float pdwHighWidth[]={85, 85,110,85, 85,85,90,85, 85, 85, 85, 135,79, 79, 140,140,140,90, 112,90,72, 90, 
		72,140, 
		140,90,90};
	float pcbHighHeght[]={50, 50,50, 50, 50,50,50,50, 50, 50, 50, 50, 50, 50, 50, 50 ,50, 50, 50, 50,50, 50, 50, 50, 
		50, 50,50};

	BYTE pcbHighFan[]=   {88, 88,88, 88, 88,88,88,64, 64, 64, 64, 64, 64, 64, 48, 48 ,32, 32, 32, 32,24, 24, 
		16, 16, 
		24,16,12};

	for(BYTE i=0;i<CountArray(pcbHighFan);i++)
	{
		if(!(m_ChiHuHigh&pdwHigh[i]).IsEmpty())
		{
			tagTypeInfo TypeInfo;
			if(pdwHigh[i]&(CHR_DA_SI_XI|CHR_DA_SAN_YUAN|CHR_JIU_LIAN|CHR_SHI_BA|CHR_LIAN_QI_DUI|CHR_DA_5|CHR_XIAO_5))
			{
				TypeInfo.bDaM=true;
				m_bFanDraw=true;
			}
			else
				TypeInfo.bDaM=false;
			TypeInfo.bHigh=true;
			if(pdwHigh[i]&
				(CHR_XIAO_SI_XI|CHR_XIAO_SAN_YUAN|CHR_ZI_YI_SE|CHR_SI_AN_KE|
				CHR_YISE_SHUANG_LONG|CHR_TIAN_HU|CHR_DI_HU))
			{
				TypeInfo.bXiaoM=true;
				m_bFanDraw=true;
			}
			else
				TypeInfo.bXiaoM=false;
			TypeInfo.cbFan=pcbHighFan[i];
			TypeInfo.dwWidth=pdwHighWidth[i];
			TypeInfo.dwHeight=pcbHighHeght[i];
			char szTemp[MAX_PATH];
			sprintf(szTemp, "%s%ld.png", m_StrFile.c_str(),pcbHighCount[i] ) ;
			TypeInfo.texture=m_phge->Texture_Load(szTemp);
			TypeInfo.pSprite=new MySprite(TypeInfo.texture,0,0,pdwHighWidth[i],pcbHighHeght[i]);
			m_ArrayTypeInfo.Add(TypeInfo);
		}
	}

	//DWORD pdwRight[]={ 
	//	CHR_ZI_MO,			56,72, 1,
	//	CHR_YI_BAN_GAO,		47,89, 1,
	//	CHR_LIAN_6,			48,76, 1,
	//	CHR_LAO_SHAO_F,		49,89, 1,
	//	CHR_DAN_DIAO,		54,78, 1,
	//	CHR_MEN_QI_QING,	40,88, 2,
	//	CHR_DOUBLE_ANKE,	43,89, 2,
	//	CHR_DUAN_YAOJIU,	45,90, 2,
	//	CHR_PING_HE,		46,72, 2,
	//	CHR_QUAN_DAI_YAO,	36,112,4,
	//	CHR_MENQING_ZIMO,	38,112,4,
	//	CHR_YAO_JIU_KE,		50,86, 1,
	//	CHR_JIAN_KE,		39,72, 2,
	//	CHR_DOUBLE_JIAN_KE,	34,91, 6,
	//	CHR_SI_GUI_YI,		42,90, 2,
	//	CHR_QUAN_QIU,		33,88, 6,
	//	CHR_PENG_PENG,		32,90, 6,
	//	CHR_MIAO_SHOU,		28,112,8,
	//	CHR_HAI_DI,			29,112,8,
	//	CHR_QIANG_GANG,		31,72, 8,
	//	CHR_GANG_KAI,		30,90, 8,
	//	CHR_JUE_ZHANG,		37,90, 4,
	//	CHR_MING_GANG,		51,77, cbMingGangCount,
	//	CHR_AN_GANG,		44,72, 2*cbAnGangCount,
	//	CHR_HUN_YI_SE,		35,90, 6,
	//	CHR_TING_CARD,		57,78, 1,
	//	CHR_LI_ZHI,			41,72, 2
	//};
	DWORD pdwRight[]={
		CHR_MIAO_SHOU,CHR_HAI_DI,CHR_GANG_KAI,CHR_QIANG_GANG,CHR_PENG_PENG,CHR_QUAN_QIU,CHR_DOUBLE_JIAN_KE,CHR_HUN_YI_SE,
		CHR_QUAN_DAI_YAO,CHR_JUE_ZHANG,CHR_MENQING_ZIMO,CHR_JIAN_KE,CHR_MEN_QI_QING,CHR_LI_ZHI,CHR_SI_GUI_YI,
		CHR_DOUBLE_ANKE,CHR_DUAN_YAOJIU,CHR_PING_HE,CHR_YI_BAN_GAO,CHR_LIAN_6,CHR_LAO_SHAO_F,CHR_YAO_JIU_KE,CHR_DAN_DIAO,
		CHR_ZI_MO,CHR_TING_CARD,CHR_AN_GANG,CHR_MING_GANG
	};
	BYTE pcbInfoCount[]= {28, 29, 30,31,32,33,34,35,36, 37,38, 39,40,41,42,43,45,46,47,48,49,50,54,56,57,44,51};
	float pcbInfoWidth[]={112,112,90,72,90,88,91,90,112,90,112,72,88,72,90,89,90,72,89,76,89,86,78,72,78,72,77};
	float pcbInfoHeght[]={50, 50, 50, 50, 50, 50, 50, 50,  50, 50, 50, 50, 50, 50, 50, 50, 50, 50, 50, 50, 50, 50, 50,50,
		50,50,50};

	BYTE pcbFanCount[]={8,8,8,8,6,6,6,6,4,4,4,2,2,2,2,2,2,2,1,1,1,1,1,1,1,2*cbAnGangCount,cbMingGangCount};

	for(BYTE i=0;i<CountArray(pcbFanCount);i++)
	{
		if(!(m_ChiHuRight&pdwRight[i]).IsEmpty())
		{
			{
				tagTypeInfo TypeInfo;
				TypeInfo.bDaM=false;
				TypeInfo.bHigh=false;
				TypeInfo.bXiaoM=false;
				TypeInfo.cbFan=pcbFanCount[i];
				TypeInfo.dwWidth=pcbInfoWidth[i];
				TypeInfo.dwHeight=pcbInfoHeght[i];

				char szTemp[MAX_PATH];
				sprintf(szTemp, "%s%ld.png", m_StrFile.c_str(),pcbHighCount[i] ) ;


				
				TypeInfo.texture=m_phge->Texture_Load(szTemp);
				TypeInfo.pSprite=new MySprite(TypeInfo.texture,0,0,pcbInfoWidth[i],pcbInfoHeght[i]);
				m_ArrayTypeInfo.Add(TypeInfo);
			}
		}
	}

	DWORD pdwNew[]={ CHR_PAI_MIAN ,CHR_BIAN_ZHANG,CHR_KAN_ZHANG,CHR_HUA_CARD};
	BYTE pcbNewCount[]={58,52,53,55};
	float pcbNewWidth[]={72,78,77,112};
	float pcbNewHeight[]={50,50,50,50};

	BYTE pcbNewFan[]={ScoreInfo.cbPaiMianCard,1,1,ScoreInfo.cbHuaCardCount};

	for(BYTE i=0;i<CountArray(pcbNewFan);i++)
	{
		if(!(m_ChiHuNew&pdwNew[i]).IsEmpty())
		{
			if(!(m_ChiHuNew&CHR_PAI_MIAN).IsEmpty())
			{
				if(ScoreInfo.cbPaiMianCard>0)
				{
					tagTypeInfo TypeInfo;
					TypeInfo.bDaM=false;
					TypeInfo.bHigh=false;
					TypeInfo.bXiaoM=false;
					TypeInfo.cbFan=pcbNewFan[i];
					TypeInfo.dwWidth=pcbNewWidth[i];
					TypeInfo.dwHeight=pcbNewHeight[i];
					/*CString  strtemp;
					strtemp.Format(TEXT("%s%ld.png"),m_StrFile,pcbNewCount[i]);*/
					char szTemp[MAX_PATH];
					sprintf(szTemp, "%s%ld.png", m_StrFile.c_str(),pcbNewCount[i] );
					TypeInfo.texture=m_phge->Texture_Load(szTemp);
					TypeInfo.pSprite=new MySprite(TypeInfo.texture,0,0,pcbNewWidth[i],pcbNewHeight[i]);
					m_ArrayTypeInfo.Add(TypeInfo);
				}
			}
			else
			{
				tagTypeInfo TypeInfo;
				TypeInfo.bDaM=false;
				TypeInfo.bHigh=false;
				TypeInfo.bXiaoM=false;
				TypeInfo.cbFan=pcbNewFan[i];
				TypeInfo.dwWidth=pcbNewWidth[i];
				TypeInfo.dwHeight=pcbNewHeight[i];
				/*CString  strtemp;
				strtemp.Format(TEXT("%s%ld.png"),m_StrFile,pcbNewCount[i]);*/
				char szTemp[MAX_PATH];
				sprintf(szTemp, "%s%ld.png", m_StrFile.c_str(),pcbNewCount[i] );
				TypeInfo.texture=m_phge->Texture_Load(szTemp);
				TypeInfo.pSprite=new MySprite(TypeInfo.texture,0,0,pcbNewWidth[i],pcbNewHeight[i]);
				m_ArrayTypeInfo.Add(TypeInfo);
			}
		}
	}

	for(INT_PTR i=0;i<m_ArrayTypeInfo.GetCount();i++)
	{
		m_dwFanCount+=m_ArrayTypeInfo[i].cbFan;
	}

	//ϱ
	for (BYTE i=0;i<m_cbWeaveCount;i++)
	{
		m_pWeaveCard[i]->SetCardData(WeaveInfo.cbCardData[i],WeaveInfo.cbCardCount[i],WIK_NULL);
		m_pWeaveCard[i]->SetDisplayItem(true);
	}
	//for(BYTE i=0;i<m_ArrayCard.GetCount();i++)
	//{
	//	//ϱ
	//	for (BYTE j=0;j<m_cbWeaveCount;j++)
	//	{
	//		m_pWeaveCard[j]->SetDuiHuaCard(m_ArrayCard[i],true);
	//	}
	//}
}
void CGameScore::Update(DWORD dwDelTick )
{
	//if(m_cbType==0)
	//{
 //		if(m_bUpdata)
	//	{
	//		m_cbChiHuCount++;
	//		if(m_cbChiHuCount==10)
	//		{
	//			m_cbChiHuCount=0;
	//			m_bChiHuUpdata=true;
	//			if(m_bPlaySound)
	//				TL_SoundManager::Instance().PlaySound("CommonResult");
	//		}
	//	}
	//	if(m_bChiHuUpdata)
	//	{
	//		m_cbChiHuIndex++;
	//		if(m_cbChiHuIndex==m_ArrayTypeInfo.GetCount())
	//		{	
	//			m_bUpdata=false;
	//			m_cbChiHuIndex--;
	//			m_cbType++;
	//			m_cbPage=(m_cbChiHuIndex/6);
	//			m_cbPageCount=m_cbPage;
	//			m_cbChiHuJiSuan=m_cbChiHuIndex;
	//			//if(m_cbPage>0)
	//			//	m_pPageUp->SetState(eItemStateNormal);
	//		}
	//		m_bChiHuUpdata=false;
	//	}
	//}
	SetScorePoint(hgePoint(m_fXScore,m_fYScore));
}
void CGameScore::DrawTimer(float nXPos,float nYPos,WORD wTime)
{
	//ȡ
	const float nNumberHeight=m_pTimeNumber->GetHeight();
	const float nNumberWidth=18.0f;

	//Ŀ
	LONG lNumberCount=0;
	WORD wNumberTemp=wTime;
	do
	{
		lNumberCount++;
		wNumberTemp/=10;
	} while (wNumberTemp>0L);

	//λö
	float nYDrawPos=nYPos-nNumberHeight/2;
	float nXDrawPos=nXPos+(lNumberCount*nNumberWidth)/2-nNumberWidth;

	//滭
	for (LONG i=0;i<lNumberCount;i++)
	{
		//滭
		WORD wCellNumber=wTime%10;
		m_pTimeNumber->SetTextureRect(wCellNumber*nNumberWidth,0.0f,nNumberWidth,nNumberHeight);
		m_pTimeNumber->Render(nXDrawPos,nYDrawPos);

		//ñ
		wTime/=10;
		nXDrawPos-=nNumberWidth;
	};

	return;
}
void CGameScore::SetShow()
{
	m_bHuangZhuang=false;

	m_bUpdata=true;
	m_cbType=0;
	//m_pPageUp->SetState(eItemStateDisable);
	//m_pPageDown->SetState(eItemStateDisable);
}
void CGameScore::StartShow()
{
}
void CGameScore::SetDuiHuaCard(BYTE cbCardData)
{
	m_ArrayCard.Add(cbCardData);
}
void CGameScore::SetContinuePos(hgePoint ptPos)
{
	m_ptContinue=ptPos;
	m_rcContinue.x1=m_ptContinue.x+17;
	m_rcContinue.x2=m_ptContinue.x+211;
	m_rcContinue.y1=m_ptContinue.y+25;
	m_rcContinue.y2=m_ptContinue.y+75;
}
void CGameScore::SetScorePoint(hgePoint ptPos)
{
	m_ptScorePos=ptPos;
	m_rcScorePos.x1=m_ptScorePos.x;
	m_rcScorePos.y1=m_ptScorePos.y;
	m_rcScorePos.x2=m_ptScorePos.x+512;
	m_dwScoreWidth=512;
	if(!m_bHuangZhuang)
	{
		DWORD cbCount=62+130;
		int dwCount=m_ArrayTypeInfo.GetCount()-2;
		cbCount=62+130;
		if(dwCount>0)
		{
			cbCount=cbCount+(dwCount/2+dwCount%2)*42;
		}
		cbCount+=90;
		m_rcScorePos.y2=(float)m_ptScorePos.y+cbCount;
		m_dwScoreHeight=cbCount;
	}
	else
	{
		m_rcScorePos.y2=m_ptScorePos.y+314;
		m_dwScoreHeight=314;
	}

	int nXPos=m_ptScorePos.x+14;
	int nYPos=m_ptScorePos.y+44;
	for(BYTE i=0;i<MAX_WEAVE;i++)
	{
		m_pWeaveCard[i]->SetControlPoint(nXPos,nYPos);
		nXPos+=103;
	}
}
void CGameScore::SetHuangZhuang(bool bHuangZhuang)
{
	m_bHuangZhuang=bHuangZhuang;

	m_bUpdata=false;
	m_cbType=0;
	//m_pPageUp->SetState(eItemStateDisable);
	//m_pPageDown->SetState(eItemStateDisable);
}
void CGameScore::SetEndTime(WORD wTimer)
{
	m_wTime=wTimer;
}
VOID CGameScore::DrawNumberString( LONGLONG lNumber, float nXPos, float nYPos, MySprite *pSprite,float nWidth,
								  float nHeight, bool bHasSign, bool bDrawCenter)
{
	//Դ
	float nNumberHeight=nHeight;
	float nNumberWidth=nWidth/(10+(bHasSign?1:0));

	//Ŀ
	INT nNumberCount=0;
	LONGLONG lNumberTemp=lNumber;
	do
	{
		nNumberCount++;
		lNumberTemp/=10;
	} while (lNumberTemp!=0);

	//λö
	float nYDrawPos=nYPos;
	float nXDrawPos= 0;
	if( !bDrawCenter )
		nXDrawPos = (nXPos+(nNumberCount+(bHasSign?0:-1))*nNumberWidth);
	else 
		nXDrawPos = (nXPos+(nNumberCount+(bHasSign?1:0))*nNumberWidth/2-nNumberWidth/2);

	BYTE bySignCount = bHasSign?1:0;
	//滭
	if( lNumber < 0L ) lNumberTemp = -lNumber;
	else lNumberTemp = lNumber;
	for (INT i=0;i<nNumberCount;i++)
	{
		//滭
		INT lCellNumber=INT(lNumberTemp%10);
		pSprite->SetTextureRect((float)(lCellNumber+bySignCount)*nNumberWidth,0,nNumberWidth,nNumberHeight);
		pSprite->Render(nXDrawPos-2,nYDrawPos);

		//ñ
		lNumberTemp/=10;
		nXDrawPos-=(INT)nNumberWidth;
	}
	//滭
	if( bHasSign )
	{
		pSprite->SetTextureRect(0,0,nNumberWidth,nNumberHeight);
		pSprite->Render(nXDrawPos,nYDrawPos);
	}

	return;
}
void CGameScore::DrawNumberString(LONGLONG lNumber,INT nXPos,INT nYPos,CHgeImage &HgeNumber,bool bHasSign, bool bDrawCenter)
{
	//Դ
	INT nNumberHeight=(int)HgeNumber.GetHeight();
	INT nNumberWidth=(int)HgeNumber.GetWidth()/(10+(bHasSign?2:0));

	//Ŀ
	INT nNumberCount=0;
	LONGLONG lNumberTemp=lNumber;
	do
	{
		nNumberCount++;
		lNumberTemp/=10;
	} while (lNumberTemp!=0);

	//λö
	INT nYDrawPos=nYPos;
	INT nXDrawPos= 0;
	if( !bDrawCenter )
		nXDrawPos = INT(nXPos+(nNumberCount+(bHasSign?0:-1))*nNumberWidth);
	else 
		nXDrawPos = INT(nXPos+(nNumberCount+(bHasSign?1:0))*nNumberWidth/2-nNumberWidth);

	BYTE bySignCount = bHasSign?2:0;
	//滭
	if( lNumber < 0L ) lNumberTemp = -lNumber;
	else lNumberTemp = lNumber;
	for (INT i=0;i<nNumberCount;i++)
	{
		//滭
		INT lCellNumber=INT(lNumberTemp%10);
		HgeNumber.DrawImage((float)nXDrawPos,(float)nYDrawPos,(float)nNumberWidth,(float)nNumberHeight,
			(float)((lCellNumber)*nNumberWidth),0);

		//ñ
		lNumberTemp/=10;
		nXDrawPos-=nNumberWidth;
	}
	//滭
	if( bHasSign )
	{
		HgeNumber.DrawImage((float)nXDrawPos,(float)nYDrawPos,(float)nNumberWidth,(float)nNumberHeight,
			(float)((lNumber>=0?10:11)*nNumberWidth),0);
	}
}
VOID CGameScore::DrawNumberFan( LONGLONG lNumber, float nXPos, float nYPos, MySprite *pSprite,float nWidth,
								  float nHeight,MySprite *pFan,bool bDrawFan,bool bHasSign)
{
	//Դ
	float nNumberHeight=nHeight;
	float nNumberWidth=nWidth/(10+(bHasSign?2:0));

	//Ŀ
	INT nNumberCount=0;
	LONGLONG lNumberTemp=lNumber;
	do
	{
		nNumberCount++;
		lNumberTemp/=10;
	} while (lNumberTemp!=0);

	//λö
	float nYDrawPos=nYPos;
	float nXDrawPos=(nXPos+(nNumberCount-1)*nNumberWidth);
	float nXFanPos=(nXPos+(nNumberCount)*nNumberWidth);

	BYTE bySignCount = bHasSign?2:0;
	//滭
	if( lNumber < 0L ) lNumberTemp = -lNumber;
	else lNumberTemp = lNumber;
	for (INT i=0;i<nNumberCount;i++)
	{
		//滭
		INT lCellNumber=INT(lNumberTemp%10);
		pSprite->SetTextureRect((float)(lCellNumber)*nNumberWidth,0,nNumberWidth,nNumberHeight);
		pSprite->Render(nXDrawPos,nYDrawPos-1);

		//ñ
		lNumberTemp/=10;
		nXDrawPos-=(INT)nNumberWidth;
	}

	if(bDrawFan)
		pFan->Render(nXFanPos,nYDrawPos);

	return;
}
void CGameScore::OnLButtonDown(UINT nFlags, const hgePoint& point)
{
	if(m_rcContinue.TestPoint(point.x,point.y))
		m_pButtonContinue->OnLButtonDown(nFlags,point);
	if(m_rcScorePos.TestPoint(point.x,point.y))
	{
		m_bLButtonDown=true;
		m_fXMousePos=point.x;
		m_fYMousePos=point.y;
		m_fXStep=m_fXScore;
		m_fYStep=m_fYScore;
	}
}
void CGameScore::OnLButtonUp(UINT nFlags, const hgePoint& point)
{
	if(m_rcContinue.TestPoint(point.x,point.y))
		m_pButtonContinue->OnLButtonUp(nFlags,point);
	m_bLButtonDown=false;
}
void CGameScore::OnMouseMove(UINT nFlags, const hgePoint& point)
{
	if(m_rcContinue.TestPoint(point.x,point.y))
		m_pButtonContinue->OnMouseMove(nFlags,point);
	if(m_bLButtonDown)
	{
		m_fXScore=m_fXStep+(point.x-m_fXMousePos);
		m_fYScore=m_fYStep+(point.y-m_fYMousePos);
		if(m_fYScore<30)
		{
			m_fYScore=30;
		}
		if(m_fYScore+m_dwScoreHeight>695)
		{
			m_fYScore=695-m_dwScoreHeight;
		}
		m_fXMousePos=point.x;
		m_fYMousePos=point.y;
		m_fXStep=m_fXScore;
		m_fYStep=m_fYScore;
	}
}
void CGameScore::OnPageUp(hgeItemBase *p)
{
	
	if(m_cbPage>0)
	{	
		m_cbPage--;
		m_cbChiHuIndex=m_cbPage*6+5;
		if(m_cbChiHuIndex>m_cbChiHuJiSuan)
		{
			m_cbChiHuIndex=m_cbChiHuJiSuan;
		}
		//m_pPageDown->SetState(eItemStateNormal);
		//if(m_cbPage<=0)
		//{
		//	m_pPageUp->SetState(eItemStateDisable);
		//}
	}
}
void CGameScore::OnPageDonw(hgeItemBase *p)
{
	
	if(m_cbPage<m_cbPageCount)
	{
		m_cbPage++;
		m_cbChiHuIndex=m_cbPage*6+5;
		if(m_cbChiHuIndex>m_cbChiHuJiSuan)
		{
			m_cbChiHuIndex=m_cbChiHuJiSuan;
		}
		//m_pPageUp->SetState(eItemStateNormal);
		//if(m_cbPage>=m_cbPageCount)
		//{
		//	m_pPageDown->SetState(eItemStateDisable);
		//}
	}
}