#ifndef GAME_SCORE_HEAD
#define GAME_SCORE_HEAD

#pragma once
#include "Stdafx.h"
#include "GameLogic.h"
#include "CardFile.h"

//Ϣ
struct tagScoreInfo
{
	//˿
	BYTE							cbCardCount;							//˿Ŀ
	BYTE							cbCardData[MAX_COUNT];					//˿

	//ûϢ
	TCHAR							szUserName[GAME_PLAYER][LEN_ACCOUNTS];		//û

	//Ϣ
	WORD							wChiHuUser;								//
	WORD							wProvideUser;							//Ӧû
	WORD							wChengBaoUser;							//аû
	WORD							wLianBankerCount;
	BYTE							cbProvideCard;							//Ӧ˿
	LONGLONG						lGameScore[GAME_PLAYER];				//Ϸ
	LONGLONG						lGameGold[GAME_PLAYER];					//Ϸ
	LONGLONG						lHitScore[GAME_PLAYER];

	BYTE							cbPaiMianCard;
	BYTE							cbHuaCardCount;							//Ƹ
	BYTE							cbFanCount;								//ܷ

	//ƽ
	DWORD							dwFanShu;
	DWORD							dwChiHuKind[GAME_PLAYER];				//
};

//Ϣ
struct tagWeaveInfo
{
	BYTE							cbWeaveCount;							//Ŀ
	BYTE							cbCardCount[MAX_WEAVE];					//˿Ŀ
	BYTE							cbPublicWeave[MAX_WEAVE];				//
	BYTE							cbCardData[MAX_WEAVE][4];				//˿
};

//Ϣ
struct tagTypeInfo
{
	bool							bHigh;
	bool							bDaM;
	bool							bXiaoM;
	BYTE							cbFan;
	float							dwWidth;
	float							dwHeight;
	HTEXTURE						texture;
	MySprite						*pSprite;
};

class CGameScore :
	public hgeItemContainer
{
protected:
	HGE								*m_phge;
	CHgeImage						m_ImageBackUp;
	CHgeImage						m_ImageBackMiddle;
	CHgeImage						m_ImageBackDown;
protected:
	MySprite						*m_pBaseNumber;
	MySprite						*m_pWin;
	MySprite						*m_pWinNum;
	MySprite						*m_pLost;
	MySprite						*m_pLostNum;
	MySprite						*m_pHuangZhuang;
	MySprite						*m_pAll;
	MySprite						*m_pAllFan;
	MySprite						*m_pAllFanNum;
	MySprite						*m_pFan;
	MySprite						*m_pFanNum;
	MySprite						*m_pDaManGuan;
	MySprite						*m_pXiaoManGuan;
	MySprite						*m_pYiMan;
	MySprite						*m_pTimeNumber;
protected:
	CHgeImage						m_ImageLine;
	CHgeImage						m_ImageRedouble;
	CHgeImage						m_ImageRedoubleNum;
	CHgeImage						m_ImageScoreNumber;
protected:
	BYTE							m_cbChiHuCount;
	BYTE							m_cbChiHuIndex;
	BYTE							m_cbChiHuJiSuan;
	bool							m_bChiHuUpdata;
	bool							m_bUpdata;
	BYTE							m_cbType;
	BYTE							m_cbPage;
	BYTE							m_cbPageCount;
	DWORD							m_dwFanCount;
	bool							m_bFanDraw;
private:
	LONG							m_lCellScore;
	CChiHuRight						m_ChiHuRight;
	CChiHuRight						m_ChiHuHigh;
	CChiHuRight						m_ChiHuNew;
	tagScoreInfo					m_ScoreInfo;
	WORD							m_wTime;
	BYTE							m_cbWeaveCount;
	CWeaveCard						*m_pWeaveCard[MAX_WEAVE];
	CWHArray<tagTypeInfo>     m_ArrayTypeInfo;
	CWHArray<BYTE>			m_ArrayCard;
protected:
	bool							m_bHuangZhuang;
	bool							m_bPlaySound;
public:
	hgeItemButton					*m_pButtonContinue;
	//hgeItemButton					*m_pPageUp;
	//hgeItemButton					*m_pPageDown;
protected:
	hgePoint						m_ptContinue;
	hgeRect							m_rcContinue;
	hgePoint						m_ptScorePos;
	hgeRect							m_rcScorePos;
	std::string							m_StrFile;
private:
	float							m_fXMousePos;
	float							m_fYMousePos;
	float							m_fXScore;
	float							m_fYScore;
	float							m_fXStep;
	float							m_fYStep;
	DWORD							m_dwScoreHeight;
	DWORD							m_dwScoreWidth;
	bool							m_bLButtonDown;
public:
	CGameScore(const tstring& strName);
public:
	~CGameScore(void);
public:
	void InitData(const char* strFile);
	void SetShow();
	void StartShow();
	void SetHuangZhuang(bool bHuangZhuang);
	//λ
	void RestorationData();
	//û
	void SetScoreInfo(const tagScoreInfo & ScoreInfo, const tagWeaveInfo & WeaveInfo, const BYTE cbMingGangCount,
		const BYTE cbAnGangCount,const CChiHuRight &ChiHuRight,const CChiHuRight &ChiHuHigh,
		const CChiHuRight &ChiHuNew,LONG lCellScore,WORD wMeChairID);
	void Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect);
	void Update(DWORD dwDelTick );
	void DrawTimer(float nXPos,float nYPos,WORD wTime);
	void SetEndTime(WORD wTimer);
	void SetPlaySound(bool bPlaySound){m_bPlaySound=bPlaySound;}
	//Ի
	void SetDuiHuaCard(BYTE cbCardData);
	void SetContinuePos(hgePoint ptPos);
	void SetScorePoint(hgePoint ptPos);
protected:
	//滭,bHasSignʾλͼǷ
	VOID DrawNumberString( LONGLONG lNumber, float nXPos, float nYPos, MySprite *pSprite,float nWidth,float nHeight, bool bHasSign, bool bDrawCenter=false );
	VOID DrawNumberFan( LONGLONG lNumber, float nXPos, float nYPos, MySprite *pSprite,float nWidth,float nHeight,
		MySprite *pFan,bool bDrawFan=true,bool bHasSign=false);
	void DrawNumberString(LONGLONG lNumber,INT nXPos,INT nYPos,CHgeImage &HgeNumber,bool bHasSign,
		bool bDrawCenter=false);
public:
	void OnLButtonDown(UINT nFlags, const hgePoint& point);
	void OnLButtonUp(UINT nFlags, const hgePoint& point);
	void OnMouseMove(UINT nFlags, const hgePoint& point);
protected:
	void OnPageUp(hgeItemBase  *p);
	void OnPageDonw(hgeItemBase  *p);
};
#endif