#include "StdAfx.h"
#include "GroupAnimate.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

extern char g_szCurPath[MAX_PATH];

CGroupAnimate::CGroupAnimate(const tstring& strName)
:hgeItemContainer(strName)
{
	m_ArraySprite.RemoveAll();
	m_phge = hgeCreate(HGE_VERSION);
	m_ArrayTexture.RemoveAll();
	m_fSpriteWidth=0;
	m_fSpriteHeight=0;
	m_dwFrame=0;
	m_dwSpeed=0;
	m_cbFrom=0;
	m_hgePoint=hgePoint(0.0f,0.0f);
	m_bStart=false;
	m_bRun=false;
	m_PathName=g_szCurPath;
}

CGroupAnimate::~CGroupAnimate(void)
{
}
void CGroupAnimate::InitAnimate(CString pathname,float nWidth,float nHeight,DWORD dwFrame,BYTE cbFrom)
{
	m_PathName+=pathname;
	m_fSpriteWidth=nWidth;
	m_fSpriteHeight=nHeight;
	m_dwFrame=dwFrame;
	m_cbFrom=cbFrom;
}
void CGroupAnimate::Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect)
{
	if(m_bStart&&m_dwFrame!=0)
	{
		m_ArraySprite[m_dwSpeed]->Render(m_hgePoint.x,m_hgePoint.y);
	}
}
void CGroupAnimate::UpData()
{
	if(m_bStart&&m_dwFrame!=0)
	{
		m_dwSpeed++;
		if(m_dwSpeed>=m_dwFrame)
		{
			m_dwSpeed=0;
			if(!m_bRun)
				Stop();
		}
	}
}
void CGroupAnimate::LondData()
{
	char szTemp[MAX_PATH];
	MySprite *_pSprite;
	HTEXTURE _texture;
	for(DWORD i=m_cbFrom;i<=m_dwFrame;i++)
	{
		sprintf(szTemp, "%s%ld.png", m_PathName, i);
		_texture=m_phge->Texture_Load(szTemp);
		_pSprite=new MySprite(_texture,0,0,m_fSpriteWidth,m_fSpriteHeight);
		m_ArraySprite.Add(_pSprite);
		m_ArrayTexture.Add(_texture);
	}
}
void CGroupAnimate::Start()
{
	m_bStart=true;
	m_dwSpeed=0;
}
void CGroupAnimate::Stop()
{
	m_bStart=false;
	for(INT_PTR i=0;i<m_ArrayTexture.GetCount();i++)
	{
		m_phge->Texture_Free(m_ArrayTexture[i]);
	}
	m_ArrayTexture.RemoveAll();
	for(BYTE i=0;i<m_ArraySprite.GetCount();i++)
	{
		if(m_ArraySprite[i])
			delete m_ArraySprite[i];
	}
	m_ArraySprite.RemoveAll();
}
void CGroupAnimate::SetPoint(hgePoint point)
{
	m_hgePoint=point;
}
