#include "StdAfx.h"
#include "HgeGUI.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

extern char g_szCurPath[MAX_PATH];
//////////////////////////////////////////////////////////////////////////
CHgeImage::CHgeImage(void)
{
	m_pHge = hgeCreate(HGE_VERSION);
	m_pImage = NULL;

	m_fWidth = 0.0f;
	m_fHeight = 0.0f;
	m_fItemWidth = 0.0f;
	m_fItemHeight = 0.0f;
	m_StrFile=g_szCurPath;
}

CHgeImage::~CHgeImage(void)
{
	DestroyImage();
	if (m_pHge) 
	{
		//m_pHge->Texture_Free(m_tex);
		m_pHge->Release();
		m_pHge = NULL;
	}
}


// װͼƬ
bool CHgeImage::LoadImage(const char *filename,bool bFile,int nxNum/* = 1*/, 
						  int nyNum/* = 1*/, DWORD size/* = 0*/, bool bMipmap/* = false*/)
{
	if (NULL == m_pHge)
		return false;

	float fx = 0.0f,
		  fy = 0.0f;

	if(bFile)
		m_StrFile+=filename;
	else
		m_StrFile=filename;

	HTEXTURE tex= m_pHge->Texture_Load(m_StrFile.c_str(), size, bMipmap);
	
	fx = (float)m_pHge->Texture_GetWidth(tex,true);
	fy = (float)m_pHge->Texture_GetHeight(tex,true);

	hgeSprite* pSprite = new hgeSprite(tex, 0.0f, 0.0f, fx, fy);	

	if (NULL == pSprite)
		return false;

	if (NULL != m_pImage)
		DestroyImage();

	m_pImage = pSprite;
	m_fWidth = fx;
	m_fHeight = fy;
	m_fItemWidth = fx / nxNum;
	m_fItemHeight = fy / nyNum;

	return true;
}

bool CHgeImage::SetImage(const char *filename,bool bFile)
{
	if (NULL == m_pHge)
		return false;

	float fx = 0.0f,
		fy = 0.0f;

	if(bFile)
		m_StrFile+=filename;
	else
		m_StrFile=filename;

	HTEXTURE tex= m_pHge->Texture_Load(m_StrFile.c_str());

	if(!tex)
		return false;

	fx = (float)m_pHge->Texture_GetWidth(tex,true);
	fy = (float)m_pHge->Texture_GetHeight(tex,true);

	hgeSprite* pSprite = new hgeSprite(tex, 0.0f, 0.0f, fx, fy);	

	if (NULL == pSprite)
		return false;

	if (NULL != m_pImage)
		DestroyImage();

	m_pImage = pSprite;
	m_fWidth = fx;
	m_fHeight = fy;

	return true;
}
// жͼƬ
void CHgeImage::DestroyImage(void)
{
	if (m_pHge && m_pImage && m_pImage->GetTexture())
	{
		//m_pHge->Texture_Free(m_pImage->GetTexture());
		delete m_pImage;
		m_pImage = NULL;
	}
}

// ͼƬ
void CHgeImage::DrawImage(float x, float y)
{
	if (m_pHge && m_pImage)
		m_pImage->Render(x, y);
}


// ͼƬ
void CHgeImage::DrawImage(float x, float y, float rot, float hscale/* = 1.0f*/, float vscale/* = 0.0f*/)
{
	if (m_pHge && m_pImage)
		m_pImage->RenderEx(x, y, rot, hscale, vscale);
}
void CHgeImage::DrawImage(float x, float y,float nDestWidth, float nDestHeight, float nXScr, float nYSrc)
{
	if(m_pHge && m_pImage)
	{
		m_pImage->SetTextureRect(nXScr,nYSrc,nDestWidth,nDestHeight);
		m_pImage->Render(x,y);
	}
}
void CHgeImage::DrawImage(float x, float y, float rot,float nDestWidth, float nDestHeight, float nXScr, float nYSrc,float hscale,float vscale)
{
	if(m_pHge && m_pImage)
	{
		m_pImage->SetTextureRect(nXScr,nYSrc,nDestWidth,nDestHeight);
		m_pImage->RenderEx(x,y,rot,hscale,vscale);
	}
}
//////////////////////////////////////////////////////////////////////////
CHgeButton::CHgeButton(void)
{
	m_pHge=hgeCreate(HGE_VERSION);
	m_pImage=NULL;
	m_StrFile=g_szCurPath;
	m_bShow=true;
	m_bState=true;
	m_cbButtonIndex=0;
	m_dwMessage=0;

	m_fWidth = 0.0f;
	m_fHeight = 0.0f;
	m_rcRect=CRect(0,0,0,0);
}
CHgeButton::~CHgeButton(void)
{
	DestroyImage();
	if(m_pHge)
	{
		m_pHge->Release();
		m_pHge=NULL;
	}
}
// װͼƬ
bool CHgeButton::LoadButtonImage(const char *filename,DWORD Message)
{
	if (NULL == m_pHge)
		return false;

	float fx = 0.0f,fy = 0.0f;

	m_StrFile+=filename;

	HTEXTURE tex= m_pHge->Texture_Load(m_StrFile.c_str());

	fx = (float)m_pHge->Texture_GetWidth(tex,true);
	fy = (float)m_pHge->Texture_GetHeight(tex,true);

	hgeSprite* pSprite = new hgeSprite(tex, 0.0f, 0.0f, fx, fy);	

	if (NULL == pSprite)
		return false;

	if (NULL != m_pImage)
		DestroyImage();

	m_pImage = pSprite;
	m_fWidth = fx;
	m_fHeight = fy;
	m_dwMessage=Message;

	return true;
}
bool CHgeButton::SetImage(const char *filename)
{
	if (NULL == m_pHge)
		return false;

	float fx = 0.0f,
		fy = 0.0f;

	m_StrFile=g_szCurPath;
	m_StrFile+=filename;

	HTEXTURE tex= m_pHge->Texture_Load(m_StrFile.c_str());

	hgeSprite* pSprite = new hgeSprite(tex, 0.0f, 0.0f, fx, fy);	

	if (NULL == pSprite)
		return false;

	if (NULL != m_pImage)
		DestroyImage();

	fx = (float)m_pHge->Texture_GetWidth(tex,true);
	fy = (float)m_pHge->Texture_GetHeight(tex,true);

	//m_pImage->SetTexture(tex);
	m_pImage = pSprite;
	m_fWidth = fx;
	m_fHeight = fy;

	delete pSprite;

	return true;
}
void CHgeButton::SetPoint(CPoint point)
{
	m_ptPoint=point;
	m_rcRect.left=m_ptPoint.x;
	m_rcRect.top=m_ptPoint.y;
	m_rcRect.right=m_rcRect.left+(int)m_fWidth/4;
	m_rcRect.bottom=m_rcRect.top+(int)m_fHeight;
}
void CHgeButton::SetShow(bool bShow)
{
	m_bShow=bShow;
	m_cbButtonIndex=0;
}
void CHgeButton::SetState(bool bState)
{
	m_bState=bState;
	if(bState)
		m_cbButtonIndex=0;
	else
		m_cbButtonIndex=3;
}
void CHgeButton::SetMessage(DWORD Message)
{
	m_dwMessage=Message;
}
void CHgeButton::DrawButton()
{
	if(m_bShow)
	{
		if(m_pHge&&m_pImage)
		{
			m_pImage->SetTextureRect(m_cbButtonIndex*(m_fWidth/4),0,m_fWidth/4,m_fHeight);
			m_pImage->Render((float)m_ptPoint.x,(float)m_ptPoint.y);
		}
	}
}
// жͼƬ
void CHgeButton::DestroyImage(void)
{
	if (m_pHge && m_pImage && m_pImage->GetTexture())
	{
		//m_pHge->Texture_Free(m_pImage->GetTexture());
		delete m_pImage;
		m_pImage = NULL;
	}
}
bool CHgeButton::OnLButtonDown(UINT nFlags, CPoint Point)
{
	if(m_bShow&&m_bState)
	{
		if(m_rcRect.PtInRect(Point))
		{
			m_cbButtonIndex=1;

			return true;
		}
	}

	return false;
}
bool CHgeButton::OnLButtonUp(UINT nFlags, CPoint Point)
{
	if(m_bShow&&m_bState)
	{
		if(m_cbButtonIndex!=0)
		{
			m_cbButtonIndex=2;
			m_ButtonMessage(m_dwMessage);
			return true;
		}
	}
	return false;
}
bool CHgeButton::OnMouseMove(UINT nFlags, CPoint Point)
{
	if(m_bShow&&m_bState)
	{
		if(m_rcRect.PtInRect(Point))
		{
			if(m_cbButtonIndex==0)
			{
				m_cbButtonIndex=2;
			}
			return true;
		}
		else
		{
			if(m_cbButtonIndex!=0)
			{
				m_cbButtonIndex=0;

				return true;
			}
		}
	}

	return false;
}
//////////////////////////////////////////////////////////////////////////
CHgeButtonEx::CHgeButtonEx(void)
{
	m_pHge=hgeCreate(HGE_VERSION);
	m_pImage=NULL;
	m_StrFile=g_szCurPath;
	m_bShow=true;
	m_bState=true;
	m_cbButtonIndex=0;
	m_dwMessage=0;
	m_Tex=0;

	m_fWidth = 0.0f;
	m_fHeight = 0.0f;
	m_rcRect=CRect(0,0,0,0);
}
CHgeButtonEx::~CHgeButtonEx(void)
{
	DestroyImage();
	if(m_pHge)
	{
		m_pHge->Release();
		m_pHge=NULL;
	}
}
// װͼƬ
bool CHgeButtonEx::LoadButtonImage(const char *filename,DWORD Message)
{
	if (NULL == m_pHge)
		return false;

	float fx = 0.0f,fy = 0.0f;

	m_StrFile+=filename;

	m_Tex= m_pHge->Texture_Load(m_StrFile.c_str());

	fx = (float)m_pHge->Texture_GetWidth(m_Tex,true);
	fy = (float)m_pHge->Texture_GetHeight(m_Tex,true);

	hgeSprite* pSprite = new hgeSprite(m_Tex, 0.0f, 0.0f, fx, fy);	

	if (NULL == pSprite)
		return false;

	if (NULL != m_pImage)
		DestroyImage();

	m_pImage = pSprite;
	m_fWidth = fx;
	m_fHeight = fy;
	m_dwMessage=Message;

	return true;
}
void CHgeButtonEx::SetPoint(CPoint point)
{
	m_ptPoint=point;
	m_rcRect.left=m_ptPoint.x;
	m_rcRect.top=m_ptPoint.y;
	m_rcRect.right=m_rcRect.left+(int)m_fWidth/4;
	m_rcRect.bottom=m_rcRect.top+(int)m_fHeight;
}
void CHgeButtonEx::SetShow(bool bShow)
{
	m_bShow=bShow;
	//m_cbButtonIndex=0;
}
void CHgeButtonEx::SetState(bool bState)
{
	m_bState=bState;
	if(bState)
		m_cbButtonIndex=0;
	else
		m_cbButtonIndex=3;
}
void CHgeButtonEx::SetMessage(DWORD Message)
{
	m_dwMessage=Message;
}
void CHgeButtonEx::DrawButton()
{
	if(m_bShow)
	{
		if(m_pHge&&m_pImage)
		{
			m_pImage->SetTextureRect(m_cbButtonIndex*(m_fWidth/4),0,m_fWidth/4,m_fHeight);
			m_pImage->Render((float)m_ptPoint.x,(float)m_ptPoint.y);
		}
	}
}
// жͼƬ
void CHgeButtonEx::DestroyImage(void)
{
	if (m_pHge && m_pImage && m_pImage->GetTexture())
	{
		//m_pHge->Texture_Free(m_pImage->GetTexture());
		delete m_pImage;
		m_pImage = NULL;
	}
}
bool CHgeButtonEx::IsCollided(CRect rcRect,CPoint Point)
{
	if(!m_rcRect.PtInRect(Point))
		return false;

	DWORD *dwptr=m_pHge->Texture_Lock(m_Tex,true,0,0,(int)m_fWidth,(int)m_fHeight);

	int tex_width=m_pHge->Texture_GetWidth(m_Tex);
	int nx=Point.x-rcRect.left;
	int ny=Point.y-rcRect.top;

	DWORD color=dwptr[tex_width*ny+nx];
	DWORD criterion=0x00FFFFFF;

	m_pHge->Texture_Unlock(m_Tex);

	if(color>criterion)
		return true;

	return false;
}
bool CHgeButtonEx::OnLButtonDown(UINT nFlags, CPoint Point)
{
	if(m_bShow&&m_bState)
	{
		if(IsCollided(m_rcRect,Point))
		{
			m_cbButtonIndex=1;
			return true;
		}
	}

	return false;
}
bool CHgeButtonEx::OnLButtonUp(UINT nFlags, CPoint Point)
{
	if(m_bShow&&m_bState)
	{
		if(m_cbButtonIndex!=0)
		{
			m_cbButtonIndex=2;
			m_ButtonMessage(m_dwMessage);
			return true;
		}
	}
	return false;
}
bool CHgeButtonEx::OnMouseMove(UINT nFlags, CPoint Point)
{
	if(m_bShow&&m_bState)
	{
		if(IsCollided(m_rcRect,Point))
		{
			if(m_cbButtonIndex==0)
			{
				m_cbButtonIndex=2;
			}
			return true;
		}
		else
		{
			if(m_cbButtonIndex!=0)
			{
				m_cbButtonIndex=0;

				return true;
			}
		}
	}

	return false;
}
//////////////////////////////////////////////////////////////////////////