#include "StdAfx.h"
#include "SetCellScore.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

CSetCellScore::CSetCellScore(const tstring &strname):hgeItemContainer(strname)
{
	m_pBack=NULL;
	m_ptPoint=hgePoint(0,0);
	m_ptOk=hgePoint(0,0);
	m_ptCancel=hgePoint(0,0);
	m_ptClose=hgePoint(0,0);
	for(BYTE i=0;i<9;i++)
	{
		m_pCheckBox[i]=NULL;
	}
	m_pOk=NULL;
	m_pCancel=NULL;
	m_pClose=NULL;
	ZeroMemory(m_cbCheckEstate,sizeof(m_cbCheckEstate));
	m_cbCheckPos=0;
	m_bWait=false;
	m_bSetOk=false;
	m_bLeave=false;
	m_lSetScore=0;
}

CSetCellScore::~CSetCellScore(void)
{
	if(m_pBack)
		delete m_pBack;
	if(m_pFont)
		delete m_pFont;
	if(m_pOk)
		delete m_pOk;
	if(m_pCancel)
		delete m_pCancel;
	if(m_pClose)
		delete m_pClose;
	for(BYTE i=0;i<9;i++)
	{
		if(m_pCheckBox[i])
			delete m_pCheckBox[i];
	}
}
void CSetCellScore::ReleaseData()
{
	ZeroMemory(m_cbCheckEstate,sizeof(m_cbCheckEstate));
	m_cbCheckPos=0;
	m_bWait=false;
	m_bSetOk=false;
	m_bLeave=false;
	m_lSetScore=0;
	m_lCellScore[0]=5;
	m_lCellScore[1]=10;
	m_lCellScore[2]=50;
	m_lCellScore[3]=100;
	m_lCellScore[4]=500;
	m_lCellScore[5]=1000;
	m_lCellScore[6]=10000;
	m_lCellScore[7]=50000;
	m_lCellScore[8]=100000;
	m_cbCheckEstate[0]=1;
	m_cbCheckPos=0;
}
void CSetCellScore::Init()
{
	m_pFont=new GfxFont("",14);
	HTEXTURE tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexSetCellBack");
	m_pBack=new MySprite(tex,0,0,319,212);

	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexOk");
	m_pOk=new hgeItemButton("OK",tex,hgePoint(0,0),hgePoint(65,31),TRUE,4,TRUE);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexCancel");
	m_pCancel=new hgeItemButton("Cancel",tex,hgePoint(0,0),hgePoint(65,31),TRUE,4,TRUE);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexClose");
	m_pClose=new hgeItemButton("Close",tex,hgePoint(0,0),hgePoint(65,31),TRUE,4,TRUE);

	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("GtexCheckBox");
	for(BYTE i=0;i<9;i++)
	{
		m_pCheckBox[i]=new MySprite(tex,0,0,42,14);
	}
	m_lCellScore[0]=5;
	m_lCellScore[1]=10;
	m_lCellScore[2]=50;
	m_lCellScore[3]=100;
	m_lCellScore[4]=500;
	m_lCellScore[5]=1000;
	m_lCellScore[6]=10000;
	m_lCellScore[7]=50000;
	m_lCellScore[8]=100000;

	m_cbCheckEstate[0]=1;
	m_cbCheckPos=0;
}
void CSetCellScore::Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect)
{
	m_pBack->Render(m_ptPoint.x,m_ptPoint.y);
	if(m_bWait)
	{
		m_pFont->Print(m_ptPoint.x+100,m_ptPoint.y+100,("ȴõע"));
		m_pClose->Render(m_ptClose,bClip,clipRect);
	}
	else if(m_bSetOk)
	{
		if(m_bLeave)
		{
			/*CString str;
			str.Format(("1Ϊ%ld\n\nǮ޷Ϸ"),m_lSetScore);*/

			char szBuffer[1024];
			sprintf(szBuffer, "1Ϊ%ld\n\nǮ޷Ϸ",m_lSetScore)  ;
			m_pFont->Print(m_ptPoint.x+60,m_ptPoint.y+80,szBuffer);
			m_pClose->Render(m_ptClose,bClip,clipRect);
		}
		else
		{
			/*CString str;
			str.Format(("1ӮΪ%ld\n\n\n       ǷϷ"),m_lSetScore);*/
			char szBuffer[1024];
			sprintf(szBuffer, ("1ӮΪ%ld\n\n\n       ǷϷ"),m_lSetScore);
			m_pFont->Print(m_ptPoint.x+65,m_ptPoint.y+75,szBuffer);
			m_pOk->Render(m_ptOk,bClip,clipRect);
			m_pCancel->Render(m_ptCancel,bClip,clipRect);
		}
	}
	else
	{
		m_pFont->Print(m_ptPoint.x+104,m_ptPoint.y+50,("1 = ??ӣ"));

		for(BYTE i=0;i<9;i++)
		{
			DrawNumberString(m_lCellScore[i],0xFFFFFFFF,(float)(60+85*(i/3)),(float)(80+28*(i%3)));
			m_pCheckBox[i]->SetTextureRect((float)m_cbCheckEstate[i]*14,0,14,14);
			m_pCheckBox[i]->Render(m_ptCheck[i].x,m_ptCheck[i].y);
		}

		m_pOk->Render(m_ptOk,bClip,clipRect);
		m_pCancel->Render(m_ptCancel,bClip,clipRect);
	}
}
void CSetCellScore::SetPoint(hgePoint Point)
{
	m_ptPoint=Point;
	m_ptOk.x=Point.x+70;
	m_ptOk.y=Point.y+168;
	m_rcOk.x1=m_ptOk.x;
	m_rcOk.y1=m_ptOk.y;
	m_rcOk.x2=m_ptOk.x+65;
	m_rcOk.y2=m_ptOk.y+31;
	m_ptCancel.x=Point.x+186;
	m_ptCancel.y=Point.y+168;
	m_rcCancel.x1=m_ptCancel.x;
	m_rcCancel.y1=m_ptCancel.y;
	m_rcCancel.x2=m_ptCancel.x+65;
	m_rcCancel.y2=m_ptCancel.y+31;
	m_ptClose.x=m_ptPoint.x+130;
	m_ptClose.y=m_ptPoint.y+168;
	m_rcClose.x1=m_ptClose.x;
	m_rcClose.y1=m_ptClose.y;
	m_rcClose.x2=m_ptClose.x+65;
	m_rcClose.y2=m_ptClose.y+31;

	for(BYTE i=0;i<9;i++)
	{
		m_ptCheck[i].x=(float)(40+85*(i/3))+m_ptPoint.x;
		m_ptCheck[i].y=(float)(80+28*(i%3))+m_ptPoint.y;
		m_rcCheck[i].x1=m_ptCheck[i].x;
		m_rcCheck[i].y1=m_ptCheck[i].y;
		m_rcCheck[i].x2=m_ptCheck[i].x+14+60;
		m_rcCheck[i].y2=m_ptCheck[i].y+14;
	}
}
void CSetCellScore::DrawNumberString(LONGLONG dwNumber,COLORREF crText,float nXPos,float nYPos)
{
	/*CString String;
	String.Format(TEXT("%ld"),dwNumber);*/
	char szBuffer[256];
	sprintf(szBuffer, "%ld", dwNumber);
	m_pFont->SetColor(crText);
	m_pFont->Print(m_ptPoint.x+nXPos,m_ptPoint.y+nYPos,szBuffer);
}
void CSetCellScore::SetUserScore(LONGLONG uUserScore)
{
	for(BYTE i=0;i<9;i++)
	{
		if(m_lCellScore[i]*100>uUserScore)
			m_cbCheckEstate[i]=2;
	}

	m_cbCheckEstate[0]=0;
	m_cbCheckPos=0;
	for(BYTE i=0;i<9;i++)
	{
		if(m_lCellScore[i]*100<=uUserScore)
			m_cbCheckPos=i;
	}
	m_cbCheckEstate[m_cbCheckPos]=1;
}
void CSetCellScore::OnLButtonDown(UINT nFlags, const hgePoint& point)
{
	if(m_bWait)
	{
		if(m_rcClose.TestPoint(point.x,point.y))
			m_pClose->OnLButtonDown(nFlags,point);
	}
	else if(m_bSetOk)
	{
		if(m_bLeave)
		{
			if(m_rcClose.TestPoint(point.x,point.y))
				m_pClose->OnLButtonDown(nFlags,point);
		}
		else
		{
			if(m_rcOk.TestPoint(point.x,point.y))
				m_pOk->OnLButtonDown(nFlags,point);
			if(m_rcCancel.TestPoint(point.x,point.y))
				m_pCancel->OnLButtonDown(nFlags,point);
		}
	}
	else
	{
		if(m_rcOk.TestPoint(point.x,point.y))
			m_pOk->OnLButtonDown(nFlags,point);
		if(m_rcCancel.TestPoint(point.x,point.y))
			m_pCancel->OnLButtonDown(nFlags,point);
		for(BYTE i=0;i<9;i++)
		{
			if(m_rcCheck[i].TestPoint(point.x,point.y))
			{
				if(m_cbCheckEstate[i]!=2)
				{
					for(BYTE z=0;z<9;z++)
					{
						if(m_cbCheckEstate[z]!=2)
							m_cbCheckEstate[z]=0;
					}
					m_cbCheckEstate[i]=1;
					m_cbCheckPos=i;
				}
			}
		}
	}
}
void CSetCellScore::OnLButtonUp(UINT nFlags, const hgePoint& point)
{
	if(m_bWait)
	{
		if(m_rcClose.TestPoint(point.x,point.y))
		{
			m_FPClose(NULL);
			m_pClose->OnLButtonUp(nFlags,point);
		}
	}
	else if(m_bSetOk)
	{
		if(m_bLeave)
		{
			if(m_rcClose.TestPoint(point.x,point.y))
			{
				m_FPClose(NULL);
				m_pClose->OnLButtonUp(nFlags,point);
			}
		}
		else
		{
			if(m_rcOk.TestPoint(point.x,point.y))
			{
				m_FPOk(255);
				m_pOk->OnLButtonUp(nFlags,point);
			}
			if(m_rcCancel.TestPoint(point.x,point.y))
				m_pCancel->OnLButtonUp(nFlags,point);
		}
	}
	else
	{
		if(m_rcOk.TestPoint(point.x,point.y))
		{
			m_FPOk(m_lCellScore[m_cbCheckPos]);
			m_pOk->OnLButtonUp(nFlags,point);
		}
		if(m_rcCancel.TestPoint(point.x,point.y))
			m_pCancel->OnLButtonUp(nFlags,point);
	}
}
void CSetCellScore::OnMouseMove(UINT nFlags, const hgePoint& point)
{
	if(m_bWait)
	{
		if(m_rcClose.TestPoint(point.x,point.y))
			m_pClose->OnMouseMove(nFlags,point);
	}
	else if(m_bSetOk)
	{
		if(m_bLeave)
		{
			if(m_rcClose.TestPoint(point.x,point.y))
				m_pClose->OnMouseMove(nFlags,point);
		}
		else
		{
			if(m_rcOk.TestPoint(point.x,point.y))
				m_pOk->OnMouseMove(nFlags,point);
			if(m_rcCancel.TestPoint(point.x,point.y))
				m_pCancel->OnMouseMove(nFlags,point);
		}
	}
	else
	{
		if(m_rcOk.TestPoint(point.x,point.y))
			m_pOk->OnMouseMove(nFlags,point);
		if(m_rcCancel.TestPoint(point.x,point.y))
			m_pCancel->OnMouseMove(nFlags,point);
	}
}
void CSetCellScore::SetWait()
{
	m_bWait=true;
}
void CSetCellScore::SetCellScore(LONGLONG uCellScore,bool bLeave)
{
	m_bSetOk=true;
	m_lSetScore=uCellScore;
	m_bLeave=bLeave;
	m_bWait=false;
}