#include "StdAfx.h"
#include "SiceContainer.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

CSiceContainer::CSiceContainer(const tstring& strName)
:hgeItemContainer(strName)
{
	m_pSiceOne=NULL;
	m_pSiceTwo=NULL;
	m_hSicePoint=hgePoint(0.0f,0.0f);
	m_cbSiceFirst=0;
	m_cbSiceSecond=0;
	m_pSiceFrame=NULL;
	m_cbDraw=0;
}

CSiceContainer::~CSiceContainer(void)
{
	if(m_pSiceOne)
		delete m_pSiceOne;
	if(m_pSiceTwo)
		delete m_pSiceTwo;
	if(m_pSiceFrame)
		delete m_pSiceFrame;
}
void CSiceContainer::Init()
{
	HTEXTURE tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("texGameSiceOne");
	m_pSiceOne=new MySprite(tex,0,0,330,55);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("texGameSiceTwo");
	m_pSiceTwo=new MySprite(tex,0,0,330,55);
	tex=TL_GUIDataManager::Instance().GetGameResManager()->GetTexture("texGameSiceRoll");
	m_pSiceFrame=new CDrawAnimate("SiceFrame");
	m_pSiceFrame->InitAnimate(tex,1350,300,9,false,true);
	m_pSiceFrame->_IsStop=BIND_THIS_METHOD(CSiceContainer::FrameStop);
}
void CSiceContainer::Render(const hgePoint& ptParentOffset,bool bClip,const hgeRect& clipRect)
{
	//m_bDrawSice=true;
	if(m_cbSiceFirst>0&&m_cbSiceSecond>0)
	{
		if(m_bDrawSice)
		{
			m_pSiceOne->SetTextureRect((float)(m_cbSiceFirst-1)*55,0,55,55);
			m_pSiceOne->Render(m_hSicePoint.x+5,m_hSicePoint.y+215);
			m_pSiceTwo->SetTextureRect((float)(m_cbSiceSecond-1)*55,0,55,55);
			m_pSiceTwo->Render(m_hSicePoint.x+95,m_hSicePoint.y+215);
		}
		else
		{
			m_pSiceFrame->Render(ptParentOffset,bClip,clipRect);
		}
	}
}
void CSiceContainer::Update(DWORD dwDelTick)
{
	if(m_cbSiceFirst>0&&m_cbSiceSecond>0)
	{
		if(m_bDrawSice)
		{
			m_cbDraw++;
			if(m_cbDraw==30)
				StopRender();
		}
		else
		{
			if(m_cbDraw%3==0)
				m_pSiceFrame->UpData();
			m_cbDraw++;
		}
	}
}
void CSiceContainer::SetSiceInfo(WORD wSice)
{
	if(wSice>0)
	{
		m_cbSiceFirst=HIBYTE(wSice);
		m_cbSiceSecond=LOBYTE(wSice);
		m_pSiceFrame->Start();
		m_bDrawSice=false;
	}
}
void CSiceContainer::SetSicePoint(hgePoint hPoint)
{
	m_hSicePoint=hPoint;
	m_pSiceFrame->SetPoint(m_hSicePoint);
}
void CSiceContainer::StopRender()
{
	if (EventTest)
	{
		EventTest();
	}
	m_cbSiceFirst=0;
	m_cbSiceSecond=0;
}
void CSiceContainer::FrameStop()
{
	m_bDrawSice=true;
	m_cbDraw=0;
}